//#define TEX
#ifndef GP2X
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#else
#include "SDL.h"
#include "SDL_gfxPrimitives.h"
#include "SDL_rotoZoom.h"
#include "SDL_framerate.h"
#include "SDL_ttf.h"
#include "SDL_mixer.h"
#include "SDL_image.h"
#include "SDL_joystick.h"
#include <sys/mman.h>
#include <sys/ioctl.h>
#endif
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <sstream>
#include <iostream>


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <string>
#include <map>
#include "fixed.h"
#define NUMOBJ 100
#define PI 3.14159265
#define fsin(a) fsin[a] 
#define fcos(a) fcos[a] 
#define ftan(a) ftan[a] 
#define FM(a,b) a*b
int pdiv[4096];
SDL_Surface* screen;
SDL_Surface* tex;
TTF_Font* font;
SDL_Event event;
int i,j;
bool quit;
Uint32 backcolor;
Fixed fcos[361];
Fixed fsin[361];
Fixed fsqrt[7000];
unsigned int zbuffer[320*240];
Fixed ftan[361];
Fixed hpc,aspect,vpc;
Fixed data[4096];
 Fixed Cos( unsigned short angle )
     {
        return ( data[ ( ( ( unsigned short ) ( angle + 0x4000 ) ) >> 4 ) ] );
     }

     Fixed Sin( unsigned short angle )
     {
        return ( data[ angle >> 4 ] );
     }
const static Fixed _identity_matrix_4x3[4][3] = {
   { (Fixed)1, 0L, 0L },
   { 0L, (Fixed)1, 0L },
   { 0L, 0L, (Fixed)1 },
   { 0L, 0L, 0L}
};
class vertex
{
	public:
	Fixed x,y,z;
#ifdef TEX
	int u,v;
#endif
	vertex() { x=0; y=0; z=0; };
	vertex(const Fixed& a) { x=a; y=a; z=a; }
	vertex(float a) { x=y=z=a; }
	vertex(double a) { x=y=z=a; }
	vertex(int a) { x=y=z=a; }
	vertex(long a) { x=y=z=a; }
	vertex(const vertex& a) { x=a.x; y=a.y; z=a.z; }
	vertex(const Fixed& a,const Fixed& b,const Fixed& c) { x=a; y=b; z=c; };
	vertex(float a,float b,float c) { x=a; y=b; z=c; };
	vertex(double a,double b,double c) { x=a; y=b; z=c; };
	vertex(int a,int b,int c) { x=a; y=b; z=c; };
	vertex(long a,long b,long c) { x=a; y=b; z=c; };
	vertex& operator =(const Fixed& a) { x=a; y=a; z=a; }
	vertex& operator =(int a) { x=a; y=a; z=a; }
	vertex& operator =(long a) { x=a; y=a; z=a; }	
	vertex& operator =(vertex a) { x=a.x; y=a.y; z=a.z; }	
	vertex operator -(vertex a) { return vertex(x-a.x, y-a.y, z-a.z); }
	//Fixed operator -(const Fixed& a) const { return Fixed(RAW, g - a.g); }
/*vertex operator - ( const vertex &v )
{
   return vertex( -v.x, -v.y, -v.z );
}*/

	
vertex Cross( const vertex &b ) const
{
vertex result;

   result.x = y* b.z -z*b.y;
   result.y = z* b.x  -  x* b.z ;
   result.z = x* b.y  -  y* b.x;

   return result;
}
//cube: c
//car: 445
Fixed Dot( const vertex &b ) const
{
   return x*b.x+y*b.y+z*b.z;
}
Fixed Magnitude( void ) const
{
float f;
   f  =  (float)(x  * x  + y  *  y  +  z  * z );
   printf("Mangitude: %f\n",f);
   return ( ( sqrt( f ) ) );
}

int MagnitudeSquared( void ) const
{
  return (int) (  ( z* z )
                          + ( y* y )
                          + ( z*  z ) );
}
void Normalize( void )
{
Fixed magnitude = Magnitude();
printf("Normalize: magnitude: %i\n",(int)magnitude);
   x =  x/ magnitude ;
   y =( y/ magnitude );
   z =( z/ magnitude );
}
};
static unsigned short ConvertDegree( unsigned short angle )
     {
        return ( unsigned short ) ( ( ( ( long ) angle ) << 16 ) / 3600L );
     }
#ifdef TEX

class texture
{
	public:
	SDL_Surface *srf;
	int wl,hl,wm,hm;
	texture(SDL_Surface *s) 
	{
		srf=s;
		wl=log2p(s->w);
		hl=log2p(s->h);
		wm=s->w-1;
		hm=s->h-1;
	}
	texture()
	{
		wl=hl=wm=hm=0;
	}
	void settexture(SDL_Surface *s)
	{
		srf=s;
		wl=log2p(s->w);
		hl=log2p(s->h);
		wm=s->w-1;
		hm=s->h-1;
	}
	~texture() 
	{
		SDL_FreeSurface(srf); 
	}
	// returns log2 of a number which is a power if two
	unsigned log2p(unsigned v) const
	{
		unsigned r = 0;
		while (!(v & 1)) {
			v >>= 1;
			++r;
		}
		return r;
	}
	// samples the texture using the given texture coordinate.
	// the integer texture coordinate is given in the upper 16 bits of the x and y variables.
	// it is NOT in the range [0.0, 1.0] but rather in the range of [0, width - 1] or [0, height - 1].
	// texture coordinates outside this range are wrapped.
	unsigned short sample_nearest(int x, int y) const
	{
		x >>= 16;
		y >>= 16;
		x &= wm;
		y &= hm;
		return *(static_cast<unsigned short*>(srf->pixels) + ((y << wl) + x));
	}
};
#endif
class matrix3x3
{
	public:
	Fixed data[3][3];
	void Transpose()
	{
		Fixed tmp;
		tmp = data[0][1];
		data[0][1] = data[1][0];
		data[1][0] = tmp;
		tmp = data[0][2];
		data[0][2] = data[2][0];
		data[2][0] = tmp;
		tmp = data[1][2];
		data[1][2] = data[2][1];
		data[2][1] = tmp;
	}
	const Fixed * operator[] ( int a ) const { return data[a]; }
    Fixed       * operator[] ( int a ) { return data[a]; }
};
class matrix4x3
{
	public:
	Fixed data[4][3];
	void MakeIdentity( void )
{
   memcpy( data, _identity_matrix_4x3, sizeof( _identity_matrix_4x3 ) );
}
    void MakeXTranslation(Fixed amount)
{
   data[3][0] = amount;
   data[3][1] = 0;
   data[3][2] = 0;
}
    void MakeYTranslation(Fixed amount)
{
   data[3][0] = 0;
   data[3][1] = amount;
   data[3][2] = 0;
}
    void MakeZTranslation(Fixed amount)
{
   data[3][0] = 0;
   data[3][1] = 0;
   data[3][2] = amount;
}
    void MakeXRotation(unsigned short amount){
unsigned short lookup = ConvertDegree(amount);

   data[1][1] =  Cos(lookup );
   data[2][2] =  Cos(lookup );
   data[2][1] = -Sin(lookup );
   data[1][2] =  Sin(lookup );
}
    void MakeYRotation(unsigned short amount)
{
unsigned short lookup = ConvertDegree(amount);

   data[0][0] =  Cos(lookup );
   data[0][2] = -Sin(lookup );
   data[2][0] =  Sin(lookup );
   data[2][2] =  Cos(lookup );
}
    void MakeZRotation(unsigned short amount)
{
unsigned short lookup = ConvertDegree( amount );

   data[0][0] =  Cos(lookup );
   data[1][1] =  Cos(lookup );
   data[0][1] =  Sin(lookup );
   data[1][0] = -Sin(lookup );
}
    void NormalizeDirectionVectors(void)
{
vertex v;
   GetVU( v );
   v.Normalize();
   SetVU( v );
   GetVR( v );
   v.Normalize();
   SetVR( v );
   GetVF( v );
   v.Normalize();
   SetVF( v );
}
    void GetRotationMatrix(matrix3x3 &rm) const
{
   for ( int i = 0; i < 3; i++ )
      memcpy( rm[i], data[i], sizeof( Fixed ) * 3 );
}
    void SetRotationMatrix(const matrix3x3 &rm)
{
   for ( int i = 0; i < 3; i++ )
      memcpy( data[i], rm[i], sizeof( Fixed ) * 3 );
}
    void SetTranslation(Fixed x,Fixed y,Fixed z)
    {
       data[3][0] = x;
       data[3][1] = y;
       data[3][2] = z;
    }
    void SetTranslation( const vertex &v )
    {
       SetTranslation( v.x, v.y, v.z );
    }
    vertex GetTranslation( void ) const
    {
       return vertex( data[3][0], data[3][1], data[3][2] );
    }
    void GetVU( vertex &v ) const
    {
       v.x = data[0][1];
       v.y = data[1][1];
       v.z = data[2][1];
    }
    void GetVR( vertex &v ) const
    {
       v.x = data[0][0];
       v.y = data[1][0];
       v.z = data[2][0];
    }
    void GetVF( vertex &v ) const
    {
       v.x = data[0][2];
       v.y = data[1][2];
       v.z = data[2][2];
    }
    void SetVU( const vertex &v )
    {
       data[0][1] = v.x;
       data[1][1] = v.y;
       data[2][1] = v.z;
    }
    void SetVR( const vertex &v )
    {
       data[0][0] = v.x;
       data[1][0] = v.y;
       data[2][0] = v.z;
    }
    void SetVF( const vertex &v )
    {
       data[0][2] = v.x;
       data[1][2] = v.y;
       data[2][2] = v.z;
	}
	const Fixed * operator[] ( int a ) const { return data[a]; }
    Fixed       * operator[] ( int a ) { return data[a]; }	
	

};
vertex vertexmulmatrix4x3 (vertex &v,const matrix4x3 m )
{
vertex result;

  result.x = ( m[0][0]* v.x ) +
             ( m[1][0]* v.y ) +
             ( m[2][0]* v.z ) +
             m[3][0];

  result.y = ( m[0][1]* v.x ) +
             ( m[1][1]* v.y ) +
             ( m[2][1]* v.z ) +
             m[3][1];

  result.z = ( m[0][2]* v.x ) +
             ( m[1][2]* v.y ) +
             ( m[2][2]* v.z ) +
             m[3][2];

  return result;
}

vertex vertexmulmatrix3x3( const vertex &v, const matrix3x3 &m )
{
vertex result;

  result.x = ( m[0][0]* v.x ) +
             ( m[1][0]* v.y ) +
             ( m[2][0]* v.z );

  result.y = ( m[0][1]* v.x ) +
             ( m[1][1]* v.y ) +
             ( m[2][1]* v.z );

  result.z = ( m[0][2]* v.x ) +
             ( m[1][2]* v.y ) +
             ( m[2][2]* v.z );

  return result;
}
matrix4x3 matrixmul ( const matrix4x3 &a, const matrix4x3 &b )
{
static matrix4x3 m;
   m[0][0] = FM( a[0][0], b[0][0] ) +             FM( a[0][1], b[1][0] ) +             FM( a[0][2], b[2][0] );
   m[0][1] = FM( a[0][0], b[0][1] ) +             FM( a[0][1], b[1][1] ) +             FM( a[0][2], b[2][1] );
   m[0][2] = FM( a[0][0], b[0][2] ) +             FM( a[0][1], b[1][2] ) +             FM( a[0][2], b[2][2] );
   m[1][0] = FM( a[1][0], b[0][0] ) +             FM( a[1][1], b[1][0] ) +             FM( a[1][2], b[2][0] );
   m[1][1] = FM( a[1][0], b[0][1] ) +             FM( a[1][1], b[1][1] ) +             FM( a[1][2], b[2][1] );
   m[1][2] = FM( a[1][0], b[0][2] ) +             FM( a[1][1], b[1][2] ) +             FM( a[1][2], b[2][2] );
   m[2][0] = FM( a[2][0], b[0][0] ) +             FM( a[2][1], b[1][0] ) +             FM( a[2][2], b[2][0] );
   m[2][1] = FM( a[2][0], b[0][1] ) +             FM( a[2][1], b[1][1] ) +             FM( a[2][2], b[2][1] );   m[2][2] = FM( a[2][0], b[0][2] ) +             FM( a[2][1], b[1][2] ) +             FM( a[2][2], b[2][2] );
   m[3][0] = FM( a[3][0], b[0][0] ) +             FM( a[3][1], b[1][0] ) +             FM( a[3][2], b[2][0] ) +             b[3][0];
   m[3][1] = FM( a[3][0], b[0][1] ) +  FM( a[3][1], b[1][1] ) + FM( a[3][2], b[2][1] ) +b[3][1];
   m[3][2] = FM( a[3][0], b[0][2] ) +             FM( a[3][1], b[1][2] ) +            FM( a[3][2], b[2][2] ) +            b[3][2];
   return m;
}
vertex vneg(vertex v)
{
	vertex r(-v.x,-v.y,-v.z);
	return r;
}
class object
{
	public:
	int id;//the objects id(DON'T TOUCH IT)
	Fixed x,y,z;
	int w,h,r;//width,height,and radius:  its YOUR job to update these
	int data1;//variables you can store stuff in(for inheritense/polymorphism)
	char *data2;//more
	Fixed data3;//even more
	vertex norms[4000];
	vertex verti[4000];//all the verti this object has
	int faces[4000][7];//collection of pointers to the 3 verti of each face - 0,1,2 are verti - 3,4,5 are rgb
	int nver,nfac;//number of verti/faces
	virtual int update()=0;//this function will be called every time 32D updates
	virtual void hit(object* obj)=0;//this gets called when this object collides with another,  it will be passed a pointer to the other object
	matrix4x3 w2obj;
    matrix4x3 local;
#ifdef TEX
	texture tex;
#endif
	object()
	{
		for(i=0;i<4000;i++)
		{
			faces[i][3]=rand()%155+100;
			faces[i][4]=rand()%155+100;//rand()%155+100;
			faces[i][5]=rand()%155+100;
		}
	//	faces[0][3]=255;
	//	faces[0][4]=255;
		local.MakeIdentity();
	}
	vertex GetPositionWCS( void ) const { return local.GetTranslation(); }
	const matrix4x3 *Calcw2obj( void )
{
vertex    position;
matrix3x3 rm3x3;

   /*
   ** Get object's rotation matrix and translation.
   */
   local.GetRotationMatrix( rm3x3 );

   /*
   ** Invert the rotation matrix (a transpose is the
   ** the same as an inversion when working with
   ** rotation matrices).
   */
   rm3x3.Transpose();

   /*
   ** Transform its location by the inverted rotation matrix
   */
   vertex pos=GetPositionWCS();
   position = vertexmulmatrix3x3(pos, rm3x3);

   /*
   ** Create world_to_object_matrix
   */
   w2obj.SetRotationMatrix( rm3x3 );
   w2obj.SetTranslation( vneg(position) );
   w2obj.NormalizeDirectionVectors();

   return &w2obj;
}
matrix4x3 translation_matrix;

void MoveAlongX( Fixed amount )
{
   translation_matrix.MakeIdentity();
   translation_matrix.MakeXTranslation( amount );
   local = matrixmul(translation_matrix ,local);
}

void MoveAlongY( Fixed amount )
{
   translation_matrix.MakeIdentity();
   translation_matrix.MakeYTranslation( amount );
   local = matrixmul(translation_matrix ,local);
}

void MoveAlongZ( Fixed amount )
{
   translation_matrix.MakeIdentity();
   translation_matrix.MakeZTranslation( amount );
   local = matrixmul(translation_matrix, local);
}
matrix4x3 rotation_matrix;

void RotateAroundX( unsigned short tenths_of_degrees )
{
Fixed m10 = local[1][0], m20 = local[2][0],m11 = local[1][1],m21 = local[2][1];
   rotation_matrix.MakeXRotation( tenths_of_degrees );
Fixed sm11 = rotation_matrix[1][1],sm12 = rotation_matrix[1][2],  sm21 = rotation_matrix[2][1],sm22 = rotation_matrix[2][2];
   /*
   ** Compute column 0
   */
   local[1][0] =( sm11* m10 ) + ( sm12* m20 );
   local[2][0] = ( sm21* m10 ) + ( sm22* m20 );
   /*
   ** Compute column 1
   */
   local[1][1] = ( sm11* m11 ) +( sm12* m21 );
   local[2][1] = ( sm21* m11 ) +  ( sm22* m21 );
   /*
   ** Compute column 2 (as col0 x col1 )
   */
   local[0][2] = ( local[1][0]* local[2][1] ) - ( local[2][0]* local[1][1] );
   local[1][2] = ( local[2][0]* local[0][1] ) - ( local[0][0]* local[2][1] );
   local[2][2] = ( local[0][0]* local[1][1] ) - ( local[0][1]* local[1][0] );
   /*
   ** Recompute column 0 as col1 x col2
   */
   vertex vu, vf, new_vr;
   local.GetVF( vf );
   local.GetVU( vu );
   new_vr = vu.Cross( vf );
   local.SetVR( new_vr );
   local.NormalizeDirectionVectors();
}
void RotateAroundY( unsigned short tenths_of_degrees )
{
Fixed m00 = local[0][0],m20 = local[2][0],m01 = local[0][1], m21 = local[2][1];
   rotation_matrix.MakeYRotation( tenths_of_degrees );
Fixed sm00 = rotation_matrix[0][0],sm02 = rotation_matrix[0][2], sm20 = rotation_matrix[2][0],sm22 = rotation_matrix[2][2];
   /*
   ** Compute column 0
   */
   local[0][0] = ( sm00* m00 ) +( sm02* m20 );
   local[2][0] = ( sm20* m00 ) +( sm22* m20 );
   /*
   ** Compute column 1
   */
   local[0][1] = ( sm00* m01 ) +( sm02* m21 );
   local[2][1] = ( sm20* m01 ) +( sm22* m21 );
   /*
   ** Compute column 2 (as col0 x col1 )
   */
   local[0][2] = ( local[1][0]* local[2][1] ) -( local[2][0]* local[1][1] );
   local[1][2] = ( local[2][0]* local[0][1] ) -( local[0][0]* local[2][1] );
   local[2][2] = ( local[0][0]* local[1][1] ) -( local[0][1]* local[1][0] );
   /*
   ** Recompute column 0 (as col1 x col2 )
   */
   vertex vu, vf, new_vr;
   local.GetVF( vf );
   local.GetVU( vu );
   new_vr = vu.Cross( vf );
   local.SetVR( new_vr );
   local.NormalizeDirectionVectors();
}
void RotateAroundZ( unsigned short tenths_of_degrees )
{
Fixed m00 = local[0][0],m01 = local[0][1],m10 = local[1][0], m11 = local[1][1];
   rotation_matrix.MakeZRotation( tenths_of_degrees );
Fixed sm00 = rotation_matrix[0][0],sm01 = rotation_matrix[0][1],sm10 = rotation_matrix[1][0],sm11 = rotation_matrix[1][1];
   /*
   ** Compute column 0
   */
   local[0][0] = ( sm00* m00 ) +( sm01* m10 );
   local[1][0] = ( sm10* m00 ) +( sm11* m10 );
   /*
   ** Compute column 1
   */
   local[0][1] = ( sm00* m01 ) + ( sm01* m11 );
   local[1][1] = ( sm10* m01 ) + ( sm11* m11 );
   /*
   ** Compute column 2 (as col0 x col1 )
   */
   local[0][2] = ( local[1][0]* local[2][1] ) - ( local[2][0]* local[1][1] );
   local[1][2] = ( local[2][0]* local[0][1] ) - ( local[0][0]* local[2][1] );
   local[2][2] = ( local[0][0]* local[1][1] ) - ( local[0][1]* local[1][0] );
   /*
   ** Recompute column 0 (as col1 x col2 )
   */
   vertex vu, vf, new_vr;
   local.GetVF( vf );
   local.GetVU( vu );
   new_vr = vu.Cross( vf );
   local.SetVR( new_vr );
   local.NormalizeDirectionVectors();
}
	void loadOBJ(const char *filename)  // Loads a Wavefront .OBJ 3D model from filename NOTE: You must add a line with just ! at the end of your file
	{
	FILE *fp;
	fp=fopen(filename,"r");
	bool in=1;
	int vat=0,fat=0,vtt=0;//what # vertice and face we're on
	while (in) {
		//printf("Loading\n");
		char cmd[99];
		fscanf(fp,"%s ",&cmd);	
		printf("Command: %s\n",cmd);
		if (cmd[0] == '#')
		{		
			printf("c#\n");
			fscanf(fp,"\n");
			continue;
		}
		else if (cmd == "v " || cmd[0] == 'v') {
			//iss >> verti[vat].x >> verti[vat].y >> verti[vat].z;
			printf("cv\n");
			float x,y,z;
			if(fscanf(fp,"%f %f %f\n",&x,&y,&z))
			{
			verti[vat].x=x;
			verti[vat].y=y;
			verti[vat].z=z;
			printf("loadOBJ: %f %f %f\n",x,y,z);
			vat++;
			}
		} else if (cmd == "vn") {
			//vec3f v;
			//iss >> v.x >> v.y >> v.z;
			//result.normals.push_back(v);
		} else if (cmd == "cr") {
			//vec3f v;
			//iss >> v.x >> v.y >> v.z;
			//result.normals.push_back(v);
		} else if (cmd == "t" || cmd[0]=='t') {
			#ifdef TEX
			printf("ct\n");
			int a,b;
			if(fscanf(fp,"%i %i\n",&a,&b))
			{
			verti[vtt].u=a;
			verti[vtt].v=b;
			printf("loadOBJ: %i %i\n",a,b);
			vtt++;
			}
			#endif
			//vec2f t;
			//iss >> t.x >> t.y;
			//result.texcoords.push_back(t);
		} else if (cmd == "f " || (cmd[0] == 'f')) {
			printf("cf\n");
			//iss >> faces[fat][0] >> faces[fat][1] >> faces[fat][2];
			int a,b,c;
			if(fscanf(fp,"%i %i %i \n",&a,&b,&c))
			{
			faces[fat][0]=a-1;
			faces[fat][1]=b-1;
			faces[fat][2]=c-1;
			printf("loadOBJ: %i %i %i\n",a,b,c);
			fat++;
			}
		} else if (cmd == "g") {
			//iss >> faces[fat][0] >> faces[fat][1] >> faces[fat][2];
			fscanf(fp,"%s\n",cmd);
		} else if (cmd == "! " || cmd[0] == '!') {
			printf("c!\n");
			in=0;
		} else fscanf(fp,"\n");
	}
	nver=vat;
	nfac=fat;
	printf("loadOBJ: %i faces and %i verti\n",nfac,nver);
	fclose(fp);
	vertex s1,s2;
	for(i=0;i<nfac;i++)
	{
		s1=verti[faces[i][1]]-verti[faces[i][0]];
		s2=verti[faces[i][2]]-verti[faces[i][1]];
		printf("loadOBJ: sides\n");
		norms[i]=s1.Cross(s2);
		printf("loadOBJ: crossed\n");
		norms[i].Normalize();
		printf("loadOBJ: normalized\n");
		faces[i][6]=-(int)(norms[i].Dot(verti[faces[i][0]]));
		printf("loadOBJ: face %i computed\n",i);
	}		
}

};
bool behind(vertex point,vertex norm,Fixed pc)
{
	printf("(%i,%i,%i).Dot((%i,%i,%i))+%i=%i\n",(int)point.x,(int)point.y,(int)point.z,(int)norm.x,(int)norm.y,(int)norm.z,(int)pc,(int)(point.Dot(norm)+pc));
	if(point.Dot(norm)+pc>=0)
		return 0;	
	else
	return 1;
}
class cube:public object
{
	public:
	int update()
	{
	
	}
	void hit(object* obj)
	{
	
	}
	cube()
	{
#ifdef TEX
		loadOBJ("cubet.obj");
		tex.settexture(SDL_DisplayFormatAlpha(SDL_LoadBMP("texture.bmp")));
#else
		loadOBJ("cube3.obj");
		
#endif
	/*	verti[0]=-20;//setting the verti
		verti[1].x=-20;//notice how you can set the x,y,z serperatly, or all at once
		verti[1].y=20;
		verti[1].z=-20;
		verti[2].x=20;
		verti[2].y=20;
		verti[2].z=-20;
		verti[3].x=20;
		verti[3].y=-20;
		verti[3].z=-20;
		verti[4].x=-20;
		verti[4].y=-20;
		verti[4].z=20;
		verti[5].x=20;
		verti[5].y=-20;
		verti[5].z=20;
		verti[6].x=20;
		verti[6].y=20;
		verti[6].z=20;
		verti[7].x=-20;
		verti[7].y=20;
		verti[7].z=20;
		nver=8;//we have 8 verti
		faces[0][0]=0;
		faces[0][1]=1;
		faces[0][2]=2;
		faces[1][0]=2;
		faces[1][1]=3;
		faces[1][2]=0;
		faces[2][0]=4;
		faces[2][1]=5;
		faces[2][2]=6;
		faces[3][0]=6;
		faces[3][1]=7;
		faces[3][2]=4;
		faces[4][0]=0;
		faces[4][1]=3;
		faces[4][2]=5;
		faces[5][0]=5;
		faces[5][1]=4;
		faces[5][2]=0;
		faces[6][0]=3;
		faces[6][1]=2;
		faces[6][2]=6;
		faces[7][0]=6;
		faces[7][1]=5;
		faces[7][2]=3;
		faces[8][0]=2;
		faces[8][1]=1;
		faces[8][2]=7;
		faces[9][0]=7;
		faces[9][1]=6;
		faces[9][2]=2;
		faces[10][0]=1;
		faces[10][1]=0;
		faces[10][2]=4;
		faces[11][0]=4;
		faces[11][1]=7;
		faces[11][2]=1;
		nfac=12;//12 faces*/
	}
};
object * objs[NUMOBJ];//32D's list of objects
//object camera;
// int addobj(object *obj)
// this function will add an object to 32D's list
int addobj(object &obj)
{
	//this cycles through the list of objects until it finds an empty one, then points that one to obj
	int d;
	for(d=0;d<NUMOBJ;d++)
	{
		if(objs[d]==0)
		{
			objs[d]=&obj;
			printf("addobj: Added object at %i\n",d);
			objs[d]->id=d;
			return 1;//we're done
		}
	}
	printf("addobj: failure\n");
	return 0;//FAILURE - we're at the maximum number of objects, if this happens, change NUMOBJ
}

// START VIDEO//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void drawText(SDL_Surface* screen, char* string, int x, int y, int fR, int fG, int fB)
{
	SDL_Color foregroundColor = { fR, fG, fB };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,string, foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
}

void drawTextInt(SDL_Surface* screen, int number, int x, int y, int fR, int fG, int fB)
{
	char tmp_num[16];
	sprintf((char*)tmp_num, "%d", number);
	SDL_Color foregroundColor = { fR, fG, fB };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,tmp_num, foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
}

void drawSprite(SDL_Surface* imageSurface, SDL_Surface* screenSurface, int srcX, int srcY, int dstX, int dstY, int width, int height)
{
	SDL_Rect srcRect;
	srcRect.x = srcX;
	srcRect.y = srcY;
	srcRect.w = width;
	srcRect.h = height;

	SDL_Rect dstRect;
	dstRect.x = dstX;
	dstRect.y = dstY;
	dstRect.w = width;
	dstRect.h = height;

	SDL_BlitSurface(imageSurface, &srcRect, screenSurface, &dstRect);
}
int zbuf[320][240];
int boxA(SDL_Surface * surface, int x1, int y1, int x2, int y2, Uint32 color, Uint8 alpha)
{
    Uint32 Rmask = surface->format->Rmask, Gmask =
	surface->format->Gmask, Bmask = surface->format->Bmask, Amask = surface->format->Amask;
    Uint32 R, G, B, A = 0;
    int x, y;

    	/* Probably 15-bpp or 16-bpp */
	    Uint16 *row, *pixel;
	    Uint32 dR = (color & Rmask), dG = (color & Gmask), dB = (color & Bmask), dA = (color & Amask);

	    for (y = y1; y <= y2; y++) {
		row = (Uint16 *) surface->pixels + y * surface->pitch / 2;
		for (x = x1; x <= x2; x++) {
		    pixel = row + x;

		    R = ((*pixel & Rmask) + ((dR - (*pixel & Rmask)) * alpha >> 8)) & Rmask;
		    G = ((*pixel & Gmask) + ((dG - (*pixel & Gmask)) * alpha >> 8)) & Gmask;
		    B = ((*pixel & Bmask) + ((dB - (*pixel & Bmask)) * alpha >> 8)) & Bmask;
		    //if (Amask)
			A = ((*pixel & Amask) + ((dA - (*pixel & Amask)) * alpha >> 8)) & Amask;

		    *pixel = R | G | B | A;
		}
	    }


    return (0);
}
int boxA(SDL_Surface * surface, int x1, int y1, int x2, int y2, Uint32 color)
{
	SDL_Rect r;
	r.x=x1;
	r.y=y1;
	r.w=x2-x1;
	r.h=y2-y1;
	SDL_FillRect(screen,&r,color);
}

int hlineColor(SDL_Surface * dst, int x1, int x2, int y, Uint32 color)
{
	boxA(dst,x1,y,x2,y+1,color);
}
int hlineColor(SDL_Surface * dst, int x1, int x2, int y, Uint32 color,int a)
{
	boxA(dst,x1,y,x2,y+1,color,a);
}

int gfxPrimitivesCompareInt(const void *a, const void *b);
static int *gfxPrimitivesPolyInts = NULL;
static int gfxPrimitivesPolyAllocated = 0;
int mlk=8;
#ifdef TEX
int drawpoly(SDL_Surface * dst, const int * vx, const int * vy, int n, texture *tex)
{
	
}
#endif
/*void tritex(int x1,int y1,int x2,int y2,int x2,int y3,SDL_Surface * tex)
{
	int x,y;
	int xi,yi,bot1,bot2;
	Fixed dxr,dxl,xs,xe,hl,hr;
	Fixed a,b,c,d,det,ix,iy,jx,jy,duy,dvy,us,vs,uc,vc;
	hl=y2-y1;
	hr=y3-y1;
	if(y2>y3)
	{
		bot1=y3;
		bot2=y2;
	}
	else
	{
		bot1=y2;
		bot2=y3;
	}
	dxl=(x2-x1)/hl;
	dxr=(x3-x1)/hr;
	xs=x1;
	xe=x1+.5;
	ix=(x3-x1);
	iy=(y3-y1);
	jx=(x2-x1);
	jy=(y2-y1);
	det=(ix*jy-iy*jx);
	a=jy/det;
	b=-jx/det;
	c=-iy/det;
	d=ix/det;
	us=0;
	vs=0;
	duy=(a*dxl+b);
	dvy=(c*dxl+d);
	row = (Uint16 *) screen->pixels+(y1<<8+y1<<6);
	for(y=y1;y<bot1;y++,row+=320;
	{
		uc=us;
		vc=vs;
		for(x=xs;x<=xe;x++)
		{
			xi=abs((uc*63+.5));
			yi=abs((vc*63+.5));
		}
	}
}*/
#ifdef TEX
struct gradients_fx_fl_a {
	gradients_fx_fl_a(vertex *pVertices );
	float aOneOverZ[3];				// 1/z for each vertex
	float aUOverZ[3];				// u/z for each vertex
	float aVOverZ[3];				// v/z for each vertex
	float dOneOverZdX, dOneOverZdY;	// d(1/z)/dX, d(1/z)/dY
	float dUOverZdX, dUOverZdY;		// d(u/z)/dX, d(u/z)/dY
	float dVOverZdX, dVOverZdY;		// d(v/z)/dX, d(v/z)/dY
	float dUdXModifier;
	float dVdXModifier;
};

struct edge_fx_fl_a {
	edge_fx_fl_a(gradients_fx_fl_a const &Gradients, vertex *pVertices, int Top,
			int Bottom );
	inline int Step( void );

	long X, XStep, Numerator, Denominator;			// DDA info for x
	long ErrorTerm;
	int Y, Height;					// current y and vertical count
	float OneOverZ, OneOverZStep, OneOverZStepExtra;// 1/z and step
	float UOverZ, UOverZStep, UOverZStepExtra;		// u/z and step
	float VOverZ, VOverZStep, VOverZStepExtra;		// v/z and step
};

inline int edge_fx_fl_a::Step( void ) {
	X += XStep; Y++; Height--;
	UOverZ += UOverZStep; VOverZ += VOverZStep; OneOverZ += OneOverZStep;

	ErrorTerm += Numerator;
	if(ErrorTerm >= Denominator) {
		X++;
		ErrorTerm -= Denominator;
		OneOverZ += OneOverZStepExtra;
		UOverZ += UOverZStepExtra; VOverZ += VOverZStepExtra;
	}
	return Height;
}	

void DrawScanLine_suba(SDL_Surface * Dest, gradients_fx_fl_a const &Gradients,edge_fx_fl_a *pLeft, edge_fx_fl_a *pRight, SDL_Surface * Texture );


/******** TextureMapTriangle **********/

void TextureMapTriangle_suba_fx_fl( SDL_Surface * Dest,vertex *pVertices, SDL_Surface * Texture )
{
	int Top, Middle, Bottom, MiddleForCompare, BottomForCompare;
	float Y0 = pVertices[0].y, Y1 = pVertices[1].y,Y2 = pVertices[2].y;

	// sort vertices in y
	if(Y0 < Y1) {
		if(Y2 < Y0) {
			Top = 2; Middle = 0; Bottom = 1;
			MiddleForCompare = 0; BottomForCompare = 1;
		} else {
			Top = 0;
			if(Y1 < Y2) {
				Middle = 1; Bottom = 2;
				MiddleForCompare = 1; BottomForCompare = 2;
			} else {
				Middle = 2; Bottom = 1;
				MiddleForCompare = 2; BottomForCompare = 1;
			}
		}
	} else {
		if(Y2 < Y1) {
			Top = 2; Middle = 1; Bottom = 0;
			MiddleForCompare = 1; BottomForCompare = 0;
		} else {
			Top = 1;
			if(Y0 < Y2) {
				Middle = 0; Bottom = 2;
				MiddleForCompare = 3; BottomForCompare = 2;
			} else {
				Middle = 2; Bottom = 0;
				MiddleForCompare = 2; BottomForCompare = 3;
			}
		}
	}

	gradients_fx_fl_a Gradients(pVertices);
	edge_fx_fl_a TopToBottom(Gradients,pVertices,Top,Bottom);
	edge_fx_fl_a TopToMiddle(Gradients,pVertices,Top,Middle);
	edge_fx_fl_a MiddleToBottom(Gradients,pVertices,Middle,Bottom);
	edge_fx_fl_a *pLeft, *pRight;
	int MiddleIsLeft;

	// the triangle is clockwise, so if bottom > middle then middle is right
	if(BottomForCompare > MiddleForCompare) {
		MiddleIsLeft = 0;
		pLeft = &TopToBottom; pRight = &TopToMiddle;
	} else {
		MiddleIsLeft = 1;
		pLeft = &TopToMiddle; pRight = &TopToBottom;
	}

	int Height = TopToMiddle.Height;

	while(Height--) {
		DrawScanLine_suba(Dest,Gradients,pLeft,pRight,Texture);
		TopToMiddle.Step(); TopToBottom.Step();
	}

	Height = MiddleToBottom.Height;

	if(MiddleIsLeft) {
		pLeft = &MiddleToBottom; pRight = &TopToBottom;
	} else {
		pLeft = &TopToBottom; pRight = &MiddleToBottom;
	}
	
	while(Height--) {
		DrawScanLine_suba(Dest,Gradients,pLeft,pRight,Texture);
		MiddleToBottom.Step(); TopToBottom.Step();
	}
}

/********** gradients_fx_fl_a constructor **********/

gradients_fx_fl_a::gradients_fx_fl_a( vertex *pVertices )
{
	int Counter;

	float X1Y0 = ((pVertices[1].x - pVertices[2].x)*(
							pVertices[0].y - pVertices[2].y));
	float X0Y1 = ((pVertices[0].x - pVertices[2].x)*
							(pVertices[1].y - pVertices[2].y));
	float OneOverdX = 1.0 / (X1Y0 - X0Y1);

	float OneOverdY = -OneOverdX;

	for(Counter = 0;Counter < 3;Counter++)
	{
		float const OneOverZ = 1/(float)pVertices[Counter].z;
		aOneOverZ[Counter] = OneOverZ;
		aUOverZ[Counter] = pVertices[Counter].u * OneOverZ;
		aVOverZ[Counter] = pVertices[Counter].v * OneOverZ;
	}

	dOneOverZdX = OneOverdX * (((aOneOverZ[1] - aOneOverZ[2]) *
			(pVertices[0].y - pVertices[2].y)) -
			((aOneOverZ[0] - aOneOverZ[2]) *
			(pVertices[1].y - pVertices[2].y)));
	dOneOverZdY = OneOverdY * (((aOneOverZ[1] - aOneOverZ[2]) *
			(pVertices[0].x - pVertices[2].x)) -
			((aOneOverZ[0] - aOneOverZ[2]) *
			(pVertices[1].x - pVertices[2].x)));

	dUOverZdX = OneOverdX * (((aUOverZ[1] - aUOverZ[2]) *
			(pVertices[0].y - pVertices[2].y)) -
			((aUOverZ[0] - aUOverZ[2]) *
			(pVertices[1].y - pVertices[2].y)));
	dUOverZdY = OneOverdY * (((aUOverZ[1] - aUOverZ[2]) *
			(pVertices[0].x - pVertices[2].x)) -
			((aUOverZ[0] - aUOverZ[2]) *
			(pVertices[1].x - pVertices[2].x)));

	dVOverZdX = OneOverdX * (((aVOverZ[1] - aVOverZ[2]) *
			(pVertices[0].y - pVertices[2].y)) -
			((aVOverZ[0] - aVOverZ[2]) *
			(pVertices[1].y - pVertices[2].y)));
	dVOverZdY = OneOverdY * (((aVOverZ[1] - aVOverZ[2]) *
			(pVertices[0].x - pVertices[2].x)) -
			((aVOverZ[0] - aVOverZ[2]) *
			(pVertices[1].x - pVertices[2].x)));

	//
	// set up rounding modifiers
	//
	// see gradient.txt for the detailed description
	//

	float const Half = 0x8000;
	float const PosModifier = Half;
	float const NegModifier = Half - 1;

	float dUdXIndicator = dUOverZdX * aOneOverZ[0] - aUOverZ[0] * dOneOverZdX;

	if(dUdXIndicator > 0)
	{
		dUdXModifier = PosModifier;
	}
	else
	if(dUdXIndicator < 0)
	{
		dUdXModifier = NegModifier;
	}
	else
	{
		// dUdX == 0

		float dUdYIndicator = dUOverZdY * aOneOverZ[0] -
								aUOverZ[0] * dOneOverZdY;

		if(dUdYIndicator >= 0)
		{
			dUdXModifier = PosModifier;
		}
		else
		{
			dUdXModifier = NegModifier;
		}
	}

	float dVdXIndicator = dVOverZdX * aOneOverZ[0] - aVOverZ[0] * dOneOverZdX;

	if(dVdXIndicator > 0)
	{
		dVdXModifier = PosModifier;
	}
	else
	if(dVdXIndicator < 0)
	{
		dVdXModifier = NegModifier;
	}
	else
	{
		// dVdX == 0

		float dVdYIndicator = dVOverZdY * aOneOverZ[0] -
								aVOverZ[0] * dOneOverZdY;

		if(dVdYIndicator >= 0)
		{
			dVdXModifier = PosModifier;
		}
		else
		{
			dVdXModifier = NegModifier;
		}
	}
}

/********** handle floor divides and mods correctly ***********/

inline void FloorDivMod( long Numerator, long Denominator, long &Floor,
				long &Mod )
{
	assert(Denominator > 0);		// we assume it's positive
	if(Numerator >= 0) {
		// positive case, C is okay
		Floor = Numerator / Denominator;
		Mod = Numerator % Denominator;
	} else {
		// Numerator is negative, do the right thing
		Floor = -((-Numerator) / Denominator);
		Mod = (-Numerator) % Denominator;
		if(Mod) {
			// there is a remainder
			Floor--; Mod = Denominator - Mod;
		}
	}
}

/********** edge_fx_fl_a constructor ***********/

edge_fx_fl_a::edge_fx_fl_a( gradients_fx_fl_a const &Gradients, vertex *pVertices, int Top,
		int Bottom )
{
	Y = ceil(pVertices[Top].y);
	int YEnd = ceil(pVertices[Bottom].y);
	Height = YEnd - Y;

	if(Height)
	{
		long dN = pVertices[Bottom].y - pVertices[Top].y;
		long dM = pVertices[Bottom].x - pVertices[Top].x;
	
		long InitialNumerator = dM*16*Y - dM*(float)pVertices[Top].y +	dN*(float)pVertices[Top].x - 1 + dN*16;
		FloorDivMod(InitialNumerator,dN*16,X,ErrorTerm);
		FloorDivMod(dM*16,dN*16,XStep,Numerator);
		Denominator = dN*16;
	
		float YPrestep = (Y*16 - (float)pVertices[Top].y);
		float XPrestep = (X*16 - (float)pVertices[Top].x);
	
		OneOverZ = Gradients.aOneOverZ[Top]
						+ YPrestep * Gradients.dOneOverZdY
						+ XPrestep * Gradients.dOneOverZdX;
		OneOverZStep = XStep * Gradients.dOneOverZdX
						+ Gradients.dOneOverZdY;
		OneOverZStepExtra = Gradients.dOneOverZdX;
	
		UOverZ = Gradients.aUOverZ[Top]
						+ YPrestep * Gradients.dUOverZdY
						+ XPrestep * Gradients.dUOverZdX;
		UOverZStep = XStep * Gradients.dUOverZdX
						+ Gradients.dUOverZdY;
		UOverZStepExtra = Gradients.dUOverZdX;
	
		VOverZ = Gradients.aVOverZ[Top]
						+ YPrestep * Gradients.dVOverZdY
						+ XPrestep * Gradients.dVOverZdX;
		VOverZStep = XStep * Gradients.dVOverZdX
						+ Gradients.dVOverZdY;
		VOverZStepExtra = Gradients.dVOverZdX;
	}
}

/********** DrawScanLine ************/

void DrawScanLine_suba( SDL_Surface * Dest,gradients_fx_fl_a const &Gradients,edge_fx_fl_a *pLeft, edge_fx_fl_a *pRight, SDL_Surface * Texture )
{
	int XStart = pLeft->X;
	int Width = pRight->X - XStart;

	Uint16 *pDestBits = (Uint16 *) Dest->pixels;
	Uint16 *pTextureBits = (Uint16 *) Texture->pixels;
	pDestBits += pLeft->Y * 320 + XStart;
	long TextureDeltaScan = Texture->w;

	int const AffineLength = 8;

	float OneOverZLeft = pLeft->OneOverZ;
	float UOverZLeft = pLeft->UOverZ;
	float VOverZLeft = pLeft->VOverZ;

	float dOneOverZdXAff = Gradients.dOneOverZdX * AffineLength;
	float dUOverZdXAff = Gradients.dUOverZdX * AffineLength;
	float dVOverZdXAff = Gradients.dVOverZdX * AffineLength;

	float OneOverZRight = OneOverZLeft + dOneOverZdXAff;
	float UOverZRight = UOverZLeft + dUOverZdXAff;
	float VOverZRight = VOverZLeft + dVOverZdXAff;

	float ZLeft = 1/OneOverZLeft;
	float ULeft = ZLeft * UOverZLeft;
	float VLeft = ZLeft * VOverZLeft;

	float ZRight, URight, VRight;
	float U, V, DeltaU, DeltaV;

	if(Width > 0)
	{
		int Subdivisions = Width / AffineLength;
		int WidthModLength = Width % AffineLength;

		if(!WidthModLength)
		{
			Subdivisions--;
			WidthModLength = AffineLength;
		}

		while(Subdivisions-- > 0)
		{
			ZRight = 1/OneOverZRight;
			URight = ZRight * UOverZRight;
			VRight = ZRight * VOverZRight;
	
			U = (ULeft) + Gradients.dUdXModifier;
			V = (VLeft) + Gradients.dVdXModifier;
			DeltaU = (URight - ULeft) / AffineLength;
			DeltaV = (VRight - VLeft) / AffineLength;

			for(int Counter = 0;Counter < AffineLength;Counter++)
			{
				int UInt = ((int)U)>>16;
				int VInt = ((int)V)>>16;

				*(pDestBits++) = *(pTextureBits + UInt +
						(VInt * TextureDeltaScan));

				U += DeltaU;
				V += DeltaV;
			}

			ZLeft = ZRight;
			ULeft = URight;
			VLeft = VRight;
	
			OneOverZRight += dOneOverZdXAff;
			UOverZRight += dUOverZdXAff;
			VOverZRight += dVOverZdXAff;
		}
	
		if(WidthModLength)
		{
			ZRight = 1/(pRight->OneOverZ - Gradients.dOneOverZdX);
			URight = ZRight * (pRight->UOverZ - Gradients.dUOverZdX);
			VRight = ZRight * (pRight->VOverZ - Gradients.dVOverZdX);

			U = (ULeft) + Gradients.dUdXModifier;
			V = (VLeft) + Gradients.dVdXModifier;

			if(--WidthModLength)
			{
				// guard against div-by-0 for 1 pixel lines
				DeltaU = (URight - ULeft) / WidthModLength;
				DeltaV = (VRight - VLeft) / WidthModLength;
			}
	
			for(int Counter = 0;Counter <= WidthModLength;Counter++)
			{
				int UInt = ((int)U)>>16;
				int VInt = ((int)V)>>16;
	
				*(pDestBits++) = *(pTextureBits + UInt +(VInt * TextureDeltaScan));
		
				U += DeltaU;
				V += DeltaV;
			}
		}
	}
}
#endif
/*
void DrawScanLine_suba(SDL_Surface * Dest,gradients_fx_fl_a const &Gradients,edge_fx_fl_a *pLeft, edge_fx_fl_a *pRight,SDL_Surface * Texture )
{
	int XStart = pLeft->X;
	int Width = pRight->X - XStart;
	Uint16 *pDestBits = (Uint16 *) Dest->pixels
	Uint16 *pTextureBits = (Uint16 *) Texture->pixels;
	pDestBits += pLeft->Y * Dest.DeltaScan + XStart;
long TextureDeltaScan = Texture.DeltaScan;
int const AffineLength = 8;
float OneOverZLeft = pLeft->OneOverZ;
float UOverZLeft = pLeft->UOverZ;
float VOverZLeft = pLeft->VOverZ;
float dOneOverZdXAff = Gradients.dOneOverZdX * AffineLength;
float dUOverZdXAff = Gradients.dUOverZdX * AffineLength;
float dVOverZdXAff = Gradients.dVOverZdX * AffineLength;
float OneOverZRight = OneOverZLeft + dOneOverZdXAff;
float UOverZRight = UOverZLeft + dUOverZdXAff;
float VOverZRight = VOverZLeft + dVOverZdXAff;
float ZLeft = 1/OneOverZLeft;
float ULeft = ZLeft * UOverZLeft;
float VLeft = ZLeft * VOverZLeft;
float ZRight, URight, VRight;
fixed16_16 U, V, DeltaU, DeltaV;
if(Width > 0) {
int Subdivisions = Width / AffineLength;
int WidthModLength = Width % AffineLength;
if(!WidthModLength) {
Subdivisions;
WidthModLength = AffineLength;
}
while(Subdivisions > 0) {
ZRight = 1/OneOverZRight;
URight = ZRight * UOverZRight;
VRight = ZRight * VOverZRight;
U = FloatToFixed16_16(ULeft) + Gradients.dUdXModifier;
V = FloatToFixed16_16(VLeft) + Gradients.dVdXModifier;
DeltaU =
FloatToFixed16_16(URight - ULeft)/AffineLength;
DeltaV =
FloatToFixed16_16(VRight - VLeft)/AffineLength;
for(int Counter = 0;Counter < AffineLength;Counter++){
int UInt = U>>16;
int VInt = V>>16;
*(pDestBits++) = *(pTextureBits + UInt +
(VInt * TextureDeltaScan));
U += DeltaU;
V += DeltaV;
}
ZLeft = ZRight;
ULeft = URight;
VLeft = VRight;
OneOverZRight += dOneOverZdXAff;
UOverZRight += dUOverZdXAff;
VOverZRight += dVOverZdXAff;
}
if(WidthModLength) {
ZRight = 1/(pRight->OneOverZ - Gradients.dOneOverZdX);
URight = ZRight *
(pRight->UOverZ - Gradients.dUOverZdX);
VRight = ZRight *
(pRight->VOverZ - Gradients.dVOverZdX);
U = FloatToFixed16_16(ULeft) + Gradients.dUdXModifier;
V = FloatToFixed16_16(VLeft) + Gradients.dVdXModifier;
if(WidthModLength) {
// guard against div-by-0 for 1 pixel lines
DeltaU =
FloatToFixed16_16(URight - Uleft)
/ WidthModLength;
DeltaV =
FloatToFixed16_16(VRight - Vleft)
/ WidthModLength;
}
for(int Counter = 0;
Counter <= WidthModLength;Counter++) {
int UInt = U>>16;
int VInt = V>>16;
*(pDestBits++) = *(pTextureBits + UInt +
(VInt * TextureDeltaScan));
U += DeltaU;
V += DeltaV;
}
}
}
}*/
void DrawFlatTriangle (vertex a, vertex b,vertex c,Uint32 color)
{
int x0 =a.x; int y0= a.y;
int x1 =b.x; int y1 =b.y;
int x2 =c.x; int y2 =c.y;
//int c = shade[poly.c];
 Uint16 *row;
if ((x0<-mlk || x0>320+mlk || y0<-mlk || y0>320+mlk) && 
    (x1<-mlk || x1>320+mlk || y1<-mlk || y1>320+mlk) && 
    (x2<-mlk || x2>320+mlk || y2<-mlk || y2>320+mlk)) return;

//156-187
// ===== Sort =====

int temp;
if (y1<y0)
{
    temp = x0; x0 = x1; x1 = temp;
    temp = y0; y0 = y1; y1 = temp;
}
if (y2<y0)
{
    temp = x0; x0 = x2; x2 = temp;
    temp = y0; y0 = y2; y2 = temp;
}
if (y2<y1)
{
    temp = x1; x1 = x2; x2 = temp;
    temp = y1; y1 = y2; y2 = temp;
}

// ===== Interpolation variables =====

int n, fp = 8;
int lx01=0, lx12=0, lx02=0;

int dx01 = x1 - x0;
int dy01 = y1 - y0;

    if (dy01!=0)
        lx01 = ((dx01<<fp)*pdiv[dy01+2048])>>16;

int dx12 = x2 - x1;
int dy12 = y2 - y1;

    if (dy12!=0)
        lx12 = ((dx12<<fp)*pdiv[dy12+2048])>>16;

int dx02 = x2 - x0;
int dy02 = y2 - y0;

    if (dy02!=0)
        lx02 = ((dx02<<fp)*pdiv[dy02+2048])>>16;

int vramofs;
int x, y;

int x01 = x0<<fp;
int x02 = x01;

int sx1, sx2;

    int yp = y0 * 320;
    for (y = y0; y<y1; y++)
    {
        sx1 = x01>>fp;
        sx2 = x02>>fp;

        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
        }

        yp+=320;
        vramofs = yp + sx1;
        for (x = sx1; x<sx2; x++)
        {
            if (vramofs>=0 && vramofs<76800 && x>=0 && x<320)
              row = (Uint16 *) screen->pixels+vramofs;
               *row=color;
            vramofs++;
        }
        x01+=lx01;
        x02+=lx02;
    }

    x01 = x1<<fp;

    yp = y1 * 320;
    for (y = y1; y<y2; y++)
    {
        sx1 = x01>>fp;
        sx2 = x02>>fp;

        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
        }

        yp+=320;
        vramofs = yp + sx1;
        for (x = sx1; x<sx2; x++)
        {
            if (vramofs>=0 && vramofs<76800 && x>=0 && x<320)
              row = (Uint16 *) screen->pixels+vramofs;
               *row=color;
            vramofs++;
        }
        x01+=lx12;
        x02+=lx02;
    }
}
#ifdef TEX
void DrawTextureTriangle(vertex a,vertex b,vertex c, SDL_Surface * texture)
{
int x0 =a.x; int y0 =a.y;
int x1 =b.x; int y1 =b.y;
int x2 =c.x; int y2 =c.y;
 int tshr=texture->w;
/*
if ((x0<-mlk || x0>WIDTH+mlk || y0<-mlk || y0>HEIGHT+mlk) && 
    (x1<-mlk || x1>WIDTH+mlk || y1<-mlk || y1>HEIGHT+mlk) && 
    (x2<-mlk || x2>WIDTH+mlk || y2<-mlk || y2>HEIGHT+mlk)) return;
*/


int u0 = a.u; int v0 = a.v;
int u1 = b.u; int v1 = b.v;
int u2 = c.u; int v2 = c.v;

// ===== Sort =====

int temp;
if (y1<y0)
{
    temp = u0; u0 = u1; u1 = temp;
    temp = v0; v0 = v1; v1 = temp;
    temp = x0; x0 = x1; x1 = temp;
    temp = y0; y0 = y1; y1 = temp;
}
if (y2<y0)
{
    temp = u0; u0 = u2; u2 = temp;
    temp = v0; v0 = v2; v2 = temp;
    temp = x0; x0 = x2; x2 = temp;
    temp = y0; y0 = y2; y2 = temp;
}
if (y2<y1)
{
    temp = u1; u1 = u2; u2 = temp;
    temp = v1; v1 = v2; v2 = temp;
    temp = x1; x1 = x2; x2 = temp;
    temp = y1; y1 = y2; y2 = temp;
}

// ===== Interpolation variables =====

int n;
int fp = 8;
int lx01=0, lx12=0, lx02=0;
int lu01=0, lu12=0, lu02=0;
int lv01=0, lv12=0, lv02=0;

int dx01 = x1 - x0;
int dy01 = y1 - y0;
int du01 = u1 - u0;
int dv01 = v1 - v0;

    if (dy01!=0)
    {
        lx01 = ((dx01<<fp)*pdiv[dy01+2048])>>16;
        lu01 = ((du01<<fp)*pdiv[dy01+2048])>>16;
        lv01 = ((dv01<<fp)*pdiv[dy01+2048])>>16;
    }

int dx12 = x2 - x1;
int dy12 = y2 - y1;
int du12 = u2 - u1;
int dv12 = v2 - v1;

    if (dy12!=0)
    {
        lx12 = ((dx12<<fp)*pdiv[dy12+2048])>>16;
        lu12 = ((du12<<fp)*pdiv[dy12+2048])>>16;
        lv12 = ((dv12<<fp)*pdiv[dy12+2048])>>16;
    }

int dx02 = x2 - x0;
int dy02 = y2 - y0;
int du02 = u2 - u0;
int dv02 = v2 - v0;

    if (dy02!=0)
    {
        lx02 = ((dx02<<fp)*pdiv[dy02+2048])>>16;
        lu02 = ((du02<<fp)*pdiv[dy02+2048])>>16;
        lv02 = ((dv02<<fp)*pdiv[dy02+2048])>>16;
    }

int vramofs;
int x, y;
 Uint16 *row;
 Uint16 p;
int x01 = x0<<fp;
int x02 = x01;
int u01 = u0<<fp;
int u02 = u01;
int v01 = v0<<fp;
int v02 = v01;

int du, dv;
int su1, su2;
int sv1, sv2;
int sx1, sx2;

int px, py;
printf("starting\n");
    int yp = y0 * 320;
    for (y = y0; y<y1; y++)
    {
        sx1 = x01>>fp;
        sx2 = x02>>fp;
        su1 = u01;
        su2 = u02;
        sv1 = v01;
        sv2 = v02;

        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
            temp = su1; su1 = su2; su2 = temp;
            temp = sv1; sv1 = sv2; sv2 = temp;
        }

        if (sx2!=sx1)
        {
            du = ((su2 - su1)*pdiv[(sx2-sx1)+2048])>>16;
            dv = ((sv2 - sv1)*pdiv[(sx2-sx1)+2048])>>16;
        }

        yp+=320;
        vramofs = yp + sx1;
        for (x = sx1; x<sx2; x++)
        {
            su1+=du;
            sv1+=dv;
            if (vramofs>=0 && vramofs<76800 && x>=0 && x<320)
            {
//Uint16 *p = (Uint16 *)texture->pixels+(((su1>>fp)>>tshr) + (((sv1>>fp)>>tshr)<<(8-tshr)));          
			   p = (Uint16)texture->pixels+(((su1>>fp)>>tshr) + (((sv1>>fp)>>tshr)<<(8-tshr)));
                row = (Uint16 *) screen->pixels+vramofs;
				printf("r2d\n");
               *row=p;
			   printf("drawn1\n");
            }
            vramofs++;
        }
        x01+=lx01;
        x02+=lx02;
        u01+=lu01;
        u02+=lu02;
        v01+=lv01;
        v02+=lv02;
    }

    x01 = x1<<fp;
    u01 = u1<<fp;
    v01 = v1<<fp;

    yp = y1 * 320;
    for (y = y1; y<y2; y++)
    {
        sx1 = x01>>fp;
        sx2 = x02>>fp;
        su1 = u01;
        su2 = u02;
        sv1 = v01;
        sv2 = v02;

        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
            temp = su1; su1 = su2; su2 = temp;
            temp = sv1; sv1 = sv2; sv2 = temp;
        }

        if (sx2!=sx1)
        {
            du = ((su2 - su1)*pdiv[(sx2-sx1)+2048])>>16;
            dv = ((sv2 - sv1)*pdiv[(sx2-sx1)+2048])>>16;
        }

        yp+=320;
        vramofs = yp + sx1;
        for (x = sx1; x<sx2; x++)
        {
            su1+=du;
            sv1+=dv;
            if (vramofs>=0 && vramofs<76800 && x>=0 && x<320)
            {
        p = (Uint16)texture->pixels+(((su1>>fp)>>tshr) + (((sv1>>fp)>>tshr)<<(8-tshr)));
                row = (Uint16 *) screen->pixels+vramofs;
				printf("r2d\n");
               *row=p;
            }
            vramofs++;
        }
        x01+=lx12;
        x02+=lx02;
        u01+=lu12;
        u02+=lu02;
        v01+=lv12;
        v02+=lv02;
    }
}
#endif
void DrawFlatTriangleZB (vertex a,vertex b,vertex c,Uint32 color)
{
int x0 =a.x; int y0 =a.y;
int x1 =b.x; int y1 =b.y;
int x2 =c.x; int y2 =c.y;

if ((x0<-mlk || x0>320+mlk || y0<-mlk || y0>320+mlk) && 
    (x1<-mlk || x1>320+mlk || y1<-mlk || y1>320+mlk) && 
    (x2<-mlk || x2>320+mlk || y2<-mlk || y2>320+mlk)) return;

int z0 = a.z;
int z1 = b.z;
int z2 = c.z;
 Uint16 *row;
// ===== Sort =====

int temp;
if (y1<y0)
{
    temp = x0; x0 = x1; x1 = temp;
    temp = y0; y0 = y1; y1 = temp;
    temp = z0; z0 = z1; z1 = temp;
}
if (y2<y0)
{
    temp = x0; x0 = x2; x2 = temp;
    temp = y0; y0 = y2; y2 = temp;
    temp = z0; z0 = z2; z2 = temp;
}
if (y2<y1)
{
    temp = x1; x1 = x2; x2 = temp;
    temp = y1; y1 = y2; y2 = temp;
    temp = z1; z1 = z2; z2 = temp;
}

// ===== Interpolation variables =====

int n, fp = 8;
int lx01=0, lx12=0, lx02=0;
int lz01=0, lz12=0, lz02=0;


int dx01 = x1 - x0;
int dy01 = y1 - y0;
int dz01 = z1 - z0;

    if (dy01!=0)
    {
        lx01 = ((dx01<<fp)*pdiv[dy01+2048])>>16;
        lz01 = (dz01*pdiv[dy01+2048])>>16;
    }

int dx12 = x2 - x1;
int dy12 = y2 - y1;
int dz12 = z2 - z1;

    if (dy12!=0)
    {
        lx12 = ((dx12<<fp)*pdiv[dy12+2048])>>16;
        lz12 = (dz12*pdiv[dy12+2048])>>16;
    }

int dx02 = x2 - x0;
int dy02 = y2 - y0;
int dz02 = z2 - z0;

    if (dy02!=0)
    {
        lx02 = ((dx02<<fp)*pdiv[dy02+2048])>>16;
        lz02 = (dz02*pdiv[dy02+2048])>>16;
    }

int vramofs;
int x, y;

int x01 = x0<<fp;
int x02 = x01;
int z01 = z0;
int z02 = z01;

int dz;
int sx1, sx2;
int sz1, sz2;

    int yp = y0 * 320;
    for (y = y0; y<y1; y++)
    {
        sx1 = x01>>fp;
        sx2 = x02>>fp;
        sz1 = z01;
        sz2 = z02;

        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
            temp = sz1; sz1 = sz2; sz2 = temp;
        }
        if (sx2!=sx1) dz = ((sz2 - sz1)*pdiv[(sx2-sx1)+2048])>>16;

        yp+=320;
        vramofs = yp + sx1;
        for (x = sx1; x<sx2; x++)
        {
            sz1+=dz;
            if ((vramofs>=0 && vramofs<76800 && x>=0 && x<320) && sz1<zbuffer[vramofs])
            {
                zbuffer[vramofs] = sz1;
				row = (Uint16 *) screen->pixels+vramofs;
               *row=color;
            }


            vramofs++;
        }
        x01+=lx01;
        x02+=lx02;
        z01+=lz01;
        z02+=lz02;
    }

    x01 = x1<<fp;
    z01 = z1;

    yp = y1 * 320;
    for (y = y1; y<y2; y++)
    {
        sx1 = x01>>fp;
        sx2 = x02>>fp;
        sz1 = z01;
        sz2 = z02;

        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
            temp = sz1; sz1 = sz2; sz2 = temp;
        }

        if (sx2!=sx1) dz = ((sz2 - sz1)*pdiv[(sx2-sx1)+2048])>>16;

        yp+=320;
        vramofs = yp + sx1;
        for (x = sx1; x<sx2; x++)
        {
            sz1+=dz;
            if ((vramofs>=0 && vramofs<76800 && x>=0 && x<320) && sz1< zbuffer[vramofs])
            {
                zbuffer[vramofs] = sz1;
                row = (Uint16 *) screen->pixels+vramofs;
               *row=color;
            }
            vramofs++;
        }
        x01+=lx12;
        x02+=lx02;
        z01+=lz12;
        z02+=lz02;
    }
}

void FB_Triangle( int x1, int y1,
                          int x2, int y2,
                          int x3, int  y3  ,
                          Uint32 color );
void drawtri2( vertex a,vertex b,vertex c,Uint32 color )
{
/*
** Cache variables locally
*/
int x1 = a.x;
int x2 = b.x;
int x3 = c.x;
int y1 = a.y;
int y2 = b.y;
int y3 = c.y;
int tmp;

   /*
   ** Sort our vertices from top to bottom
   */
   if ( y3 < y1 ) {
      tmp = y3;
      y3 = y1;
      y1 = tmp;
      tmp = x3;
      x3 = x1;
      x1 = tmp;
   }

   if ( y2 < y1 ) {
      tmp = y2;
      y2 = y1;
      y1 = tmp;
      tmp = x2;
      x2 = x1;
      x1 = tmp;
   }

   if ( y3 < y2 ) {
      tmp = y3;
      y3 = y2;
      y2 = tmp;
      tmp = x3;
      x3 = x2;
      x2 = tmp;
   }

   /*
   ** If the triangle has no horizontal edges then split it into
   ** two triangles that do.
   */
   if ( y2 != y1 && y3 != y1 && y3 != y2 ) {
      int             xn;
      Fixed ratio;

      /*
      ** Determine new x value:
      **   xn = ( x3 - x1 ) * ( ( y2 - y1 ) / ( y3 - y1 ) ) + x1
      */

      /*
      ** Precompute the ratio of ( y2 - y1 ) / ( y3 - y1 )
      */
      ratio = ( (Fixed)( y2 - y1 )/ (Fixed)( y3 - y1 ) );

      /*
      ** xn = ( ( x3 - x1 ) * ratio ) + x1
      */
      xn =   (int)( ( (Fixed)( x3 - x1 )* ratio ) )+ x1;

      /*
      ** Draw the two subtriangles
      */
      if ( xn < x2 ) {
         FB_Triangle( x1, y1, xn, y2, x2, y2, color );
         FB_Triangle( x3, y3, x2, y2, xn, y2, color );
      }
      else {
         FB_Triangle( x1, y1, x2, y2, xn, y2, color );
         FB_Triangle( x3, y3, x2, y2, xn, y2, color );
      }
   }
   /*
   ** Top is flat
   */
   else if ( y1 == y2 ) {
      if ( x1 < x2 ) {
         FB_Triangle( x3, y3, x2, y2, x1, y2, color );
      }
      else {
         FB_Triangle( x3, y3, x1, y2, x2, y2, color );
      }
   }
   /*
   ** Bottom is flat
   */
   else if ( y2 == y3 ) {
      if ( x2 < x3 ) {
         FB_Triangle( x1, y1, x2, y2, x3, y2, color );
      }
      else {
         FB_Triangle( x1, y1, x3, y2, x2, y2, color );
      }
   }
}

/*
** void AstVGA::FB_Triangle( x1, y1, x2, y23, x3, , color )
**
** This routine renders a flat-bottomed triangle to the screen.  The
** reason the triangle must have a flat bottom is so that the delta
** X values for the left and right sides can then be guaranteed to
** never change over the entire span of the triangle, making the code
** simpler and faster.
*/
void FB_Triangle( int x1, int y1,
                          int x2, int y2,
                          int x3, int  y3  ,
                          Uint32 color )
{
Fixed dx_left, dx_right;
Fixed curx_left, curx_right;
Fixed height = y2 - y1;//3

   /*
   ** Make sure that y23 - y1 != 0
   */
   if ( height == 0 )
      return;

   /*
   ** Determine the change in X (i.e. slope) for left and right sides
   */
   dx_left  =(Fixed)( x2 - x1 ) / height;
   dx_right = (Fixed)( x3 - x1 ) / height;

   curx_left = curx_right = (Fixed)( x1 );

   /*
   ** Draw each scan line from top to bottom
   */
   if ( y1 < y3 )  {//3
      for ( int y = y1; y <= y3; y++ ) {//3

        hlineColor( screen,(int)( curx_left ), (int)( curx_right ), y, color );

        /*
        ** Adjust X coordinates
        */
        curx_left  += dx_left;
        curx_right += dx_right;
      }
   }
   else {
      for ( int y = y1; y >= y3; y-- ) {//3

        hlineColor( screen,(int)( curx_left ), (int)( curx_right ), y, color );

        /*
        ** Adjust X coordinates
        */
        curx_left  -= dx_left;
        curx_right -= dx_right;
      }
   }
}
int drawpoly(SDL_Surface * dst, const int * vx, const int * vy, int n, Uint32 color)
{
    int result;
    int i;
    int y, xa, xb;
    int miny, maxy;
    int x1, y1;
    int x2, y2;
    int ind1, ind2;
    int ints;
    /*
     * Sanity check 
     */
    if (n < 3) {
	return -1;
    }

    /*
     * Allocate temp array, only grow array 
     */
    if (!gfxPrimitivesPolyAllocated) {
	gfxPrimitivesPolyInts = (int *) malloc(sizeof(int) * n);
	gfxPrimitivesPolyAllocated = n;
    } else {
	if (gfxPrimitivesPolyAllocated < n) {
	    gfxPrimitivesPolyInts = (int *) realloc(gfxPrimitivesPolyInts, sizeof(int) * n);
	    gfxPrimitivesPolyAllocated = n;
	}
    }

    /*
     * Determine Y maxima 
     */
    miny = vy[0];
    maxy = vy[0];
    for (i = 1; (i < n); i++) {
	if (vy[i] < miny) {
	    miny = vy[i];
	} else if (vy[i] > maxy) {
	    maxy = vy[i];
	}
    }

    /*
     * Draw, scanning y 
     */
    result = 0;
    for (y = miny; (y <= maxy); y++) {
	ints = 0;
	for (i = 0; (i < n); i++) {
	    if (!i) {
		ind1 = n - 1;
		ind2 = 0;
	    } else {
		ind1 = i - 1;
		ind2 = i;
	    }
	    y1 = vy[ind1];
	    y2 = vy[ind2];
	    if (y1 < y2) {
		x1 = vx[ind1];
		x2 = vx[ind2];
	    } else if (y1 > y2) {
		//return 0;
		y2 = vy[ind1];
		y1 = vy[ind2];
		x2 = vx[ind1];
		x1 = vx[ind2];
	    } else {
		continue;
	    }
	    if ( ((y >= y1) && (y < y2)) || ((y == maxy) && (y > y1) && (y <= y2)) ) {
		gfxPrimitivesPolyInts[ints++] = ((65536 * (y - y1)) / (y2 - y1)) * (x2 - x1) + (65536 * x1);
	    } 
	    
	}
	
	qsort(gfxPrimitivesPolyInts, ints, sizeof(int), gfxPrimitivesCompareInt);

	for (i = 0; (i < ints); i += 2) {
	    xa = gfxPrimitivesPolyInts[i] + 1;
	    xa = (xa >> 16) + ((xa & 32768) >> 15);
	    xb = gfxPrimitivesPolyInts[i+1] - 1;
	    xb = (xb >> 16) + ((xb & 32768) >> 15);
	    result |= hlineColor(dst, xa, xb, y, color);
	}
    }

    return (result);
}
int drawpoly(SDL_Surface * dst, const int * vx, const int * vy, int n, Uint32 color,int a)
{
    int result;
    int i;
    int y, xa, xb;
    int miny, maxy;
    int x1, y1;
    int x2, y2;
    int ind1, ind2;
    int ints;

    /*
     * Sanity check 
     */
    if (n < 3) {
	return -1;
    }

    /*
     * Allocate temp array, only grow array 
     */
    if (!gfxPrimitivesPolyAllocated) {
	gfxPrimitivesPolyInts = (int *) malloc(sizeof(int) * n);
	gfxPrimitivesPolyAllocated = n;
    } else {
	if (gfxPrimitivesPolyAllocated < n) {
	    gfxPrimitivesPolyInts = (int *) realloc(gfxPrimitivesPolyInts, sizeof(int) * n);
	    gfxPrimitivesPolyAllocated = n;
	}
    }

    /*
     * Determine Y maxima 
     */
    miny = vy[0];
    maxy = vy[0];
    for (i = 1; (i < n); i++) {
	if (vy[i] < miny) {
	    miny = vy[i];
	} else if (vy[i] > maxy) {
	    maxy = vy[i];
	}
    }

    /*
     * Draw, scanning y 
     */
    result = 0;
    for (y = miny; (y <= maxy); y++) {
	ints = 0;
	for (i = 0; (i < n); i++) {
	    if (!i) {
		ind1 = n - 1;
		ind2 = 0;
	    } else {
		ind1 = i - 1;
		ind2 = i;
	    }
	    y1 = vy[ind1];
	    y2 = vy[ind2];
	    if (y1 < y2) {
		x1 = vx[ind1];
		x2 = vx[ind2];
	    } else if (y1 > y2) {
		y2 = vy[ind1];
		y1 = vy[ind2];
		x2 = vx[ind1];
		x1 = vx[ind2];
	    } else {
		continue;
	    }
	    if ( ((y >= y1) && (y < y2)) || ((y == maxy) && (y > y1) && (y <= y2)) ) {
		gfxPrimitivesPolyInts[ints++] = ((65536 * (y - y1)) / (y2 - y1)) * (x2 - x1) + (65536 * x1);
	    } 
	    
	}
	
	qsort(gfxPrimitivesPolyInts, ints, sizeof(int), gfxPrimitivesCompareInt);

	for (i = 0; (i < ints); i += 2) {
	    xa = gfxPrimitivesPolyInts[i] + 1;
	    xa = (xa >> 16) + ((xa & 32768) >> 15);
	    xb = gfxPrimitivesPolyInts[i+1] - 1;
	    xb = (xb >> 16) + ((xb & 32768) >> 15);
	    result |= hlineColor(dst, xa, xb, y, color,a);
	}
    }

    return (result);
}
#define clip_xmin(surface) surface->clip_rect.x
#define clip_xmax(surface) surface->clip_rect.x+surface->clip_rect.w-1
#define clip_ymin(surface) surface->clip_rect.y
#define clip_ymax(surface) surface->clip_rect.y+surface->clip_rect.h-1
int _putPixelAlpha(SDL_Surface * surface, int x, int y, Uint32 color, Uint8 alpha)
{
    Uint32 Rmask = surface->format->Rmask, Gmask =
	surface->format->Gmask, Bmask = surface->format->Bmask, Amask = surface->format->Amask;
    Uint32 R, G, B, A = 0;

    if (x >= clip_xmin(surface) && x <= clip_xmax(surface)
	&& y >= clip_ymin(surface) && y <= clip_ymax(surface)) {

	switch (surface->format->BytesPerPixel) {
	case 1:{		/* Assuming 8-bpp */
		if (alpha == 255) {
		    *((Uint8 *) surface->pixels + y * surface->pitch + x) = color;
		} else {
		    Uint8 *pixel = (Uint8 *) surface->pixels + y * surface->pitch + x;

		    Uint8 dR = surface->format->palette->colors[*pixel].r;
		    Uint8 dG = surface->format->palette->colors[*pixel].g;
		    Uint8 dB = surface->format->palette->colors[*pixel].b;
		    Uint8 sR = surface->format->palette->colors[color].r;
		    Uint8 sG = surface->format->palette->colors[color].g;
		    Uint8 sB = surface->format->palette->colors[color].b;

		    dR = dR + ((sR - dR) * alpha >> 8);
		    dG = dG + ((sG - dG) * alpha >> 8);
		    dB = dB + ((sB - dB) * alpha >> 8);

		    *pixel = SDL_MapRGB(surface->format, dR, dG, dB);
		}
	    }
	    break;

	case 2:{		/* Probably 15-bpp or 16-bpp */
		if (alpha == 255) {
		    *((Uint16 *) surface->pixels + y * surface->pitch / 2 + x) = color;
		} else {
		    Uint16 *pixel = (Uint16 *) surface->pixels + y * surface->pitch / 2 + x;
		    Uint32 dc = *pixel;

		    R = ((dc & Rmask) + (((color & Rmask) - (dc & Rmask)) * alpha >> 8)) & Rmask;
		    G = ((dc & Gmask) + (((color & Gmask) - (dc & Gmask)) * alpha >> 8)) & Gmask;
		    B = ((dc & Bmask) + (((color & Bmask) - (dc & Bmask)) * alpha >> 8)) & Bmask;
		    if (Amask)
			A = ((dc & Amask) + (((color & Amask) - (dc & Amask)) * alpha >> 8)) & Amask;

		    *pixel = R | G | B | A;
		}
	    }
	    break;

	case 3:{		/* Slow 24-bpp mode, usually not used */
		Uint8 *pix = (Uint8 *) surface->pixels + y * surface->pitch + x * 3;
		Uint8 rshift8 = surface->format->Rshift / 8;
		Uint8 gshift8 = surface->format->Gshift / 8;
		Uint8 bshift8 = surface->format->Bshift / 8;
		Uint8 ashift8 = surface->format->Ashift / 8;


		if (alpha == 255) {
		    *(pix + rshift8) = color >> surface->format->Rshift;
		    *(pix + gshift8) = color >> surface->format->Gshift;
		    *(pix + bshift8) = color >> surface->format->Bshift;
		    *(pix + ashift8) = color >> surface->format->Ashift;
		} else {
		    Uint8 dR, dG, dB, dA = 0;
		    Uint8 sR, sG, sB, sA = 0;

		    pix = (Uint8 *) surface->pixels + y * surface->pitch + x * 3;

		    dR = *((pix) + rshift8);
		    dG = *((pix) + gshift8);
		    dB = *((pix) + bshift8);
		    dA = *((pix) + ashift8);

		    sR = (color >> surface->format->Rshift) & 0xff;
		    sG = (color >> surface->format->Gshift) & 0xff;
		    sB = (color >> surface->format->Bshift) & 0xff;
		    sA = (color >> surface->format->Ashift) & 0xff;

		    dR = dR + ((sR - dR) * alpha >> 8);
		    dG = dG + ((sG - dG) * alpha >> 8);
		    dB = dB + ((sB - dB) * alpha >> 8);
		    dA = dA + ((sA - dA) * alpha >> 8);

		    *((pix) + rshift8) = dR;
		    *((pix) + gshift8) = dG;
		    *((pix) + bshift8) = dB;
		    *((pix) + ashift8) = dA;
		}
	    }
	    break;

	case 4:{		/* Probably 32-bpp */
		if (alpha == 255) {
		    *((Uint32 *) surface->pixels + y * surface->pitch / 4 + x) = color;
		} else {
		    Uint32 Rshift, Gshift, Bshift, Ashift;
		    Uint32 *pixel = (Uint32 *) surface->pixels + y * surface->pitch / 4 + x;
		    Uint32 dc = *pixel;

		    Rshift = surface->format->Rshift;
		    Gshift = surface->format->Gshift;
		    Bshift = surface->format->Bshift;
		    Ashift = surface->format->Ashift;

		    R = ((dc & Rmask) + (((((color & Rmask) - (dc & Rmask)) >> Rshift) * alpha >> 8) << Rshift)) & Rmask;
		    G = ((dc & Gmask) + (((((color & Gmask) - (dc & Gmask)) >> Gshift) * alpha >> 8) << Gshift)) & Gmask;
		    B = ((dc & Bmask) + (((((color & Bmask) - (dc & Bmask)) >> Bshift) * alpha >> 8) << Bshift)) & Bmask;
		    if (Amask)
			A = ((dc & Amask) + (((((color & Amask) - (dc & Amask)) >> Ashift) * alpha >> 8) << Ashift)) & Amask;

		    *pixel = R | G | B | A;
		}
	    }
	    break;
	}
    }

    return (0);
}
int pixelColorNolock(SDL_Surface * dst, int x, int y, Uint32 color)
{
    Uint8 alpha;
    Uint32 mcolor;
    int result = 0;

    /*
     * Setup color 
     */
    alpha = color & 0x000000ff;
    mcolor =
	SDL_MapRGBA(dst->format, (color & 0xff000000) >> 24,
		    (color & 0x00ff0000) >> 16, (color & 0x0000ff00) >> 8, alpha);

    /*
     * Draw 
     */
    result = _putPixelAlpha(dst, x, y, mcolor, alpha);

    return (result);
}
int pixelColor(SDL_Surface * dst, int x, int y, Uint32 color)
{
    Uint8 alpha;
    Uint32 mcolor;
    int result = 0;

    /*
     * Lock the surface 
     */
    if (SDL_MUSTLOCK(dst)) {
	if (SDL_LockSurface(dst) < 0) {
	    return (-1);
	}
    }

    /*
     * Setup color 
     */
    alpha = color & 0x000000ff;
    mcolor =
	SDL_MapRGBA(dst->format, (color & 0xff000000) >> 24,
		    (color & 0x00ff0000) >> 16, (color & 0x0000ff00) >> 8, alpha);

    /*
     * Draw 
     */
    result = _putPixelAlpha(dst, x, y, mcolor, alpha);

    /*
     * Unlock the surface 
     */
    if (SDL_MUSTLOCK(dst)) {
	SDL_UnlockSurface(dst);
    }

    return (result);
}

#define CLIP_LEFT_EDGE   0x1
#define CLIP_RIGHT_EDGE  0x2
#define CLIP_BOTTOM_EDGE 0x4
#define CLIP_TOP_EDGE    0x8
#define CLIP_INSIDE(a)   (!a)
#define CLIP_REJECT(a,b) (a&b)
#define CLIP_ACCEPT(a,b) (!(a|b))
#define ABS(a) (((a)<0) ? -(a) : (a))
static int clipEncode(int x, int y, int left, int top, int right, int bottom)
{
    int code = 0;

    if (x < left) {
	code |= CLIP_LEFT_EDGE;
    } else if (x > right) {
	code |= CLIP_RIGHT_EDGE;
    }
    if (y < top) {
	code |= CLIP_TOP_EDGE;
    } else if (y > bottom) {
	code |= CLIP_BOTTOM_EDGE;
    }
    return code;
}

int VLineAlpha(SDL_Surface * dst, int x, int y1, int y2, Uint32 color)
{
    return (boxA(dst, x, y1, x, y2, color));
}

int vlineColor(SDL_Surface * dst, int x, int y1, int y2, Uint32 color)
{
    int left, right, top, bottom;
    Uint8 *pixel, *pixellast;
    int dy;
    int pixx, pixy;
    int h;
    int ytmp;
    int result = -1;
    Uint8 *colorptr;

    /*
     * Get clipping boundary 
     */
    left = dst->clip_rect.x;
    right = dst->clip_rect.x + dst->clip_rect.w - 1;
    top = dst->clip_rect.y;
    bottom = dst->clip_rect.y + dst->clip_rect.h - 1;

    /*
     * Check visibility of vline 
     */
    if ((x<left) || (x>right)) {
     return (0);
    }
    if ((y1<top) && (y2<top)) {
     return(0);
    }
    if ((y1>bottom) && (y2>bottom)) {
     return(0);
    }

    /*
     * Clip y 
     */
    if (y1 < top) {
	y1 = top;
    }
    if (y2 > bottom) {
	y2 = bottom;
    }

    /*
     * Swap y1, y2 if required 
     */
    if (y1 > y2) {
	ytmp = y1;
	y1 = y2;
	y2 = ytmp;
    }

    /*
     * Calculate height 
     */
    h = y2 - y1;

    /*
     * Sanity check on height 
     */
    if (h < 0) {
	return (0);
    }

    /*
     * Alpha check 
     */
    if ((color & 255) == 255) {

	/*
	 * No alpha-blending required 
	 */

	/*
	 * Setup color 
	 */
	colorptr = (Uint8 *) & color;
	if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {
	    color = SDL_MapRGBA(dst->format, colorptr[0], colorptr[1], colorptr[2], colorptr[3]);
	} else {
	    color = SDL_MapRGBA(dst->format, colorptr[3], colorptr[2], colorptr[1], colorptr[0]);
	}

	/*
	 * Lock surface 
	 */
	SDL_LockSurface(dst);

	/*
	 * More variable setup 
	 */
	dy = h;
	pixx = dst->format->BytesPerPixel;
	pixy = dst->pitch;
	pixel = ((Uint8 *) dst->pixels) + pixx * (int) x + pixy * (int) y1;
	pixellast = pixel + pixy * dy;

	/*
	 * Draw 
	 */
	switch (dst->format->BytesPerPixel) {
	case 1:
	    for (; pixel <= pixellast; pixel += pixy) {
		*(Uint8 *) pixel = color;
	    }
	    break;
	case 2:
	    for (; pixel <= pixellast; pixel += pixy) {
		*(Uint16 *) pixel = color;
	    }
	    break;
	case 3:
	    for (; pixel <= pixellast; pixel += pixy) {
		if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {
		    pixel[0] = (color >> 16) & 0xff;
		    pixel[1] = (color >> 8) & 0xff;
		    pixel[2] = color & 0xff;
		} else {
		    pixel[0] = color & 0xff;
		    pixel[1] = (color >> 8) & 0xff;
		    pixel[2] = (color >> 16) & 0xff;
		}
	    }
	    break;
	default:		/* case 4 */
	    for (; pixel <= pixellast; pixel += pixy) {
		*(Uint32 *) pixel = color;
	    }
	    break;
	}

	/*
	 * Unlock surface 
	 */
	SDL_UnlockSurface(dst);

	/*
	 * Set result code 
	 */
	result = 0;

    } else {

	/*
	 * Alpha blending blit 
	 */

	result = VLineAlpha(dst, x, y1, y1 + h, color);

    }

    return (result);
}
static int clipLine(SDL_Surface * dst, int * x1, int * y1, int * x2, int * y2)
{
    int left, right, top, bottom;
    int code1, code2;
    int draw = 0;
    int swaptmp;
    float m;

    /*
     * Get clipping boundary 
     */
    left = dst->clip_rect.x;
    right = dst->clip_rect.x + dst->clip_rect.w - 1;
    top = dst->clip_rect.y;
    bottom = dst->clip_rect.y + dst->clip_rect.h - 1;

    while (1) {
	code1 = clipEncode(*x1, *y1, left, top, right, bottom);
	code2 = clipEncode(*x2, *y2, left, top, right, bottom);
	if (CLIP_ACCEPT(code1, code2)) {
	    draw = 1;
	    break;
	} else if (CLIP_REJECT(code1, code2))
	    break;
	else {
	    if (CLIP_INSIDE(code1)) {
		swaptmp = *x2;
		*x2 = *x1;
		*x1 = swaptmp;
		swaptmp = *y2;
		*y2 = *y1;
		*y1 = swaptmp;
		swaptmp = code2;
		code2 = code1;
		code1 = swaptmp;
	    }
	    if (*x2 != *x1) {
		m = (*y2 - *y1) / (float) (*x2 - *x1);
	    } else {
		m = 1.0f;
	    }
	    if (code1 & CLIP_LEFT_EDGE) {
		*y1 += (int) ((left - *x1) * m);
		*x1 = left;
	    } else if (code1 & CLIP_RIGHT_EDGE) {
		*y1 += (int) ((right - *x1) * m);
		*x1 = right;
	    } else if (code1 & CLIP_BOTTOM_EDGE) {
		if (*x2 != *x1) {
		    *x1 += (int) ((bottom - *y1) / m);
		}
		*y1 = bottom;
	    } else if (code1 & CLIP_TOP_EDGE) {
		if (*x2 != *x1) {
		    *x1 += (int) ((top - *y1) / m);
		}
		*y1 = top;
	    }
	}
    }

    return draw;
}
int lineColor(SDL_Surface * dst, int x1, int y1, int x2, int y2, Uint32 color)
{
    int pixx, pixy;
    int x, y;
    int dx, dy;
    int ax, ay;
    int sx, sy;
    int swaptmp;
    Uint8 *pixel;
    Uint8 *colorptr;

    /*
     * Clip line and test if we have to draw 
     */
    if (!(clipLine(dst, &x1, &y1, &x2, &y2))) {
	return (0);
    }

    /*
     * Test for special cases of straight lines or single point 
     */
    if (x1 == x2) {
	if (y1 < y2) {
	    return (vlineColor(dst, x1, y1, y2, color));
	} else if (y1 > y2) {
	    return (vlineColor(dst, x1, y2, y1, color));
	} else {
	    return (pixelColor(dst, x1, y1, color));
	}
    }
    if (y1 == y2) {
	if (x1 < x2) {
	    return (hlineColor(dst, x1, x2, y1, color));
	} else if (x1 > x2) {
	    return (hlineColor(dst, x2, x1, y1, color));
	}
    }

    /*
     * Variable setup 
     */
    dx = x2 - x1;
    dy = y2 - y1;
    sx = (dx >= 0) ? 1 : -1;
    sy = (dy >= 0) ? 1 : -1;

    /* Lock surface */
    if (SDL_MUSTLOCK(dst)) {
	if (SDL_LockSurface(dst) < 0) {
	    return (-1);
	}
    }

    /*
     * Check for alpha blending 
     */
    if ((color & 255) == 255) {

	/*
	 * No alpha blending - use fast pixel routines 
	 */

	/*
	 * Setup color 
	 */
	colorptr = (Uint8 *) & color;
	if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {
	    color = SDL_MapRGBA(dst->format, colorptr[0], colorptr[1], colorptr[2], colorptr[3]);
	} else {
	    color = SDL_MapRGBA(dst->format, colorptr[3], colorptr[2], colorptr[1], colorptr[0]);
	}

	/*
	 * More variable setup 
	 */
	dx = sx * dx + 1;
	dy = sy * dy + 1;
	pixx = dst->format->BytesPerPixel;
	pixy = dst->pitch;
	pixel = ((Uint8 *) dst->pixels) + pixx * (int) x1 + pixy * (int) y1;
	pixx *= sx;
	pixy *= sy;
	if (dx < dy) {
	    swaptmp = dx;
	    dx = dy;
	    dy = swaptmp;
	    swaptmp = pixx;
	    pixx = pixy;
	    pixy = swaptmp;
	}

	/*
	 * Draw 
	 */
	x = 0;
	y = 0;
	switch (dst->format->BytesPerPixel) {
	case 1:
	    for (; x < dx; x++, pixel += pixx) {
		*pixel = color;
		y += dy;
		if (y >= dx) {
		    y -= dx;
		    pixel += pixy;
		}
	    }
	    break;
	case 2:
	    for (; x < dx; x++, pixel += pixx) {
		*(Uint16 *) pixel = color;
		y += dy;
		if (y >= dx) {
		    y -= dx;
		    pixel += pixy;
		}
	    }
	    break;
	case 3:
	    for (; x < dx; x++, pixel += pixx) {
		if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {
		    pixel[0] = (color >> 16) & 0xff;
		    pixel[1] = (color >> 8) & 0xff;
		    pixel[2] = color & 0xff;
		} else {
		    pixel[0] = color & 0xff;
		    pixel[1] = (color >> 8) & 0xff;
		    pixel[2] = (color >> 16) & 0xff;
		}
		y += dy;
		if (y >= dx) {
		    y -= dx;
		    pixel += pixy;
		}
	    }
	    break;
	default:		/* case 4 */
	    for (; x < dx; x++, pixel += pixx) {
		*(Uint32 *) pixel = color;
		y += dy;
		if (y >= dx) {
		    y -= dx;
		    pixel += pixy;
		}
	    }
	    break;
	}

    } else {

	/*
	 * Alpha blending required - use single-pixel blits 
	 */

	ax = ABS(dx) << 1;
	ay = ABS(dy) << 1;
	x = x1;
	y = y1;
	if (ax > ay) {
	    int d = ay - (ax >> 1);

	    while (x != x2) {
		pixelColorNolock (dst, x, y, color);
		if (d > 0 || (d == 0 && sx == 1)) {
		    y += sy;
		    d -= ax;
		}
		x += sx;
		d += ay;
	    }
	} else {
	    int d = ax - (ay >> 1);

	    while (y != y2) {
		pixelColorNolock (dst, x, y, color);
		if (d > 0 || ((d == 0) && (sy == 1))) {
		    x += sx;
		    d -= ay;
		}
		y += sy;
		d += ax;
	    }
	}
	pixelColorNolock (dst, x, y, color);

    }

    /* Unlock surface */
    if (SDL_MUSTLOCK(dst)) {
	SDL_UnlockSurface(dst);
    }

    return (0);
}
int _texturedHLine(SDL_Surface * dst, Sint16 x1, Sint16 x2, Sint16 y,SDL_Surface *texture,int texture_dx,int texture_dy)
{
    Sint16 left, right, top, bottom;
    Sint16 w;
    Sint16 xtmp;
    int result = 0;
    int texture_x_walker;    
    int texture_y_start;    
    SDL_Rect source_rect,dst_rect;
    int pixels_written,write_width;

    /*
     * Get clipping boundary 
     */
    left = dst->clip_rect.x;
    right = dst->clip_rect.x + dst->clip_rect.w - 1;
    top = dst->clip_rect.y;
    bottom = dst->clip_rect.y + dst->clip_rect.h - 1;

    /*
     * Check visibility of hline 
     */
    if ((x1<left) && (x2<left)) {
     return(0);
    }
    if ((x1>right) && (x2>right)) {
     return(0);
    }
    if ((y<top) || (y>bottom)) {
     return (0);
    }

    
    /*
     * Swap x1, x2 if required 
     */
    if (x1 > x2) {
	xtmp = x1;
	x1 = x2;
	x2 = xtmp;
    }
    
    /*
     * Clip x 
     */
    if (x1 < left) {
	x1 = left;
    }
    if (x2 > right) {
	x2 = right;
    }


    /*
     * Calculate width 
     */
    w = x2 - x1;

    /*
     * Sanity check on width 
     */
    if (w < 0) {
	return (0);
    }

    /*
     * Determint where in the texture we start drawing
     **/
    texture_x_walker =   (x1 - texture_dx)  % texture->w;
    if (texture_x_walker < 0){
      texture_x_walker = texture->w +texture_x_walker ;
    }

    texture_y_start = (y + texture_dy) % texture->h;
    if (texture_y_start < 0){
       texture_y_start = texture->h + texture_y_start;
    }

    //setup the source rectangle  we are only drawing one horizontal line
    source_rect.y = texture_y_start;
    source_rect.x =texture_x_walker;
    source_rect.h =1;
    //we will draw to the current y
    dst_rect.y = y;

    //if there are enough pixels left in the current row of the texture
    //draw it all at once
    if (w <= texture->w -texture_x_walker){
      source_rect.w = w;
      source_rect.x = texture_x_walker;
      dst_rect.x= x1;
      result != SDL_BlitSurface  (texture,&source_rect , dst, &dst_rect) ;
    } else {//we need to draw multiple times
      //draw the first segment
      pixels_written = texture->w  -texture_x_walker;
      source_rect.w = pixels_written;
      source_rect.x = texture_x_walker;
      dst_rect.x= x1;
      result != SDL_BlitSurface  (texture,&source_rect , dst, &dst_rect);
      write_width = texture->w;

      //now draw the rest
      //set the source x to 0
      source_rect.x = 0;
      while(pixels_written < w){
        if (write_width >= w - pixels_written){
          write_width=  w- pixels_written;
        }
        source_rect.w = write_width;
        dst_rect.x = x1 + pixels_written;
        result  != SDL_BlitSurface  (texture,&source_rect , dst, &dst_rect) ;
        pixels_written += write_width;
      }
  }
  return result;
}
int texturedPolygon(SDL_Surface * dst, const Sint16 * vx, const Sint16 * vy, int n, SDL_Surface * texture,int texture_dx,int texture_dy)
{
    int result;
    int i;
    int y, xa, xb;
    int minx,maxx,miny, maxy;
    int x1, y1;
    int x2, y2;
    int ind1, ind2;
    int ints;
    /*
     * Sanity check 
     */
    if (n < 3) {
	return -1;
    }

    /*
     * Allocate temp array, only grow array 
     */
    if (!gfxPrimitivesPolyAllocated) {
	gfxPrimitivesPolyInts = (int *) malloc(sizeof(int) * n);
	gfxPrimitivesPolyAllocated = n;
    } else {
	if (gfxPrimitivesPolyAllocated < n) {
	    gfxPrimitivesPolyInts = (int *) realloc(gfxPrimitivesPolyInts, sizeof(int) * n);
	    gfxPrimitivesPolyAllocated = n;
	}
    }


    miny = vy[0];
    maxy = vy[0];
    minx = vx[0];
    maxx = vx[0];
    for (i = 1; (i < n); i++) {
        if (vy[i] < miny) {
            miny = vy[i];
        } else if (vy[i] > maxy) {
            maxy = vy[i];
        }
        if (vx[i] < minx) {
            minx = vx[i];
        } else if (vx[i] > maxx) {
            maxx = vx[i];
        }
    }
    if (maxx <0 || minx > dst->w){
      return 0;
    }
    if (maxy <0 || miny > dst->h){
      return 0;
    }
    
    /*
     * Draw, scanning y 
     */
    result = 0;
    for (y = miny; (y <= maxy); y++) {
	ints = 0;
	for (i = 0; (i < n); i++) {
	    if (!i) {
		ind1 = n - 1;
		ind2 = 0;
	    } else {
		ind1 = i - 1;
		ind2 = i;
	    }
	    y1 = vy[ind1];
	    y2 = vy[ind2];
	    if (y1 < y2) {
		x1 = vx[ind1];
		x2 = vx[ind2];
	    } else if (y1 > y2) {
		y2 = vy[ind1];
		y1 = vy[ind2];
		x2 = vx[ind1];
		x1 = vx[ind2];
	    } else {
		continue;
	    }
	    if ( ((y >= y1) && (y < y2)) || ((y == maxy) && (y > y1) && (y <= y2)) ) {
		gfxPrimitivesPolyInts[ints++] = ((65536 * (y - y1)) / (y2 - y1)) * (x2 - x1) + (65536 * x1);
	    } 
	    
	}
	
	qsort(gfxPrimitivesPolyInts, ints, sizeof(int), gfxPrimitivesCompareInt);

	for (i = 0; (i < ints); i += 2) {
	    xa = gfxPrimitivesPolyInts[i] + 1;
	    xa = (xa >> 16) + ((xa & 32768) >> 15);
	    xb = gfxPrimitivesPolyInts[i+1] - 1;
	    xb = (xb >> 16) + ((xb & 32768) >> 15);
	    result |= _texturedHLine(dst, xa, xb, y, texture,texture_dx,texture_dy);
	}
    }


    return (result);
}
int polygonColor(SDL_Surface * dst, const int * vx, const int * vy, int n, Uint32 color)
{
    int result;
    int i;
    const int *x1, *y1, *x2, *y2;

    /*
     * Sanity check 
     */
    if (n < 3) {
	return (-1);
    }

    /*
     * Pointer setup 
     */
    x1 = x2 = vx;
    y1 = y2 = vy;
    x2++;
    y2++;

    /*
     * Draw 
     */
    result = 0;
    for (i = 1; i < n; i++) {
	result |= lineColor(dst, *x1, *y1, *x2, *y2, color);
	x1 = x2;
	y1 = y2;
	x2++;
	y2++;
    }
    result |= lineColor(dst, *x1, *y1, *vx, *vy, color);

    return (result);
}
int gfxPrimitivesCompareInt(const void *a, const void *b)
{
    return (*(const int *) a) - (*(const int *) b);
}

int drawtri(SDL_Surface * srf,int x1,int y1,int x2,int y2,int x3,int y3,int r,int g,int b)
{
	int vx[3]; 
	int vy[3];
	vx[0]=x1;
	vx[1]=x2;
	vx[2]=x3;
	vy[0]=y1;
	vy[1]=y2;
	vy[2]=y3; 
	drawpoly(srf,vx,vy,3,SDL_MapRGB(screen->format,r,g,b));
//	drawtri2(vertex(x1,y1,0),vertex(x2,y2,0),vertex(x3,y2,0),SDL_MapRGB(screen->format,r,g,b));
	//drawTextInt(screen,1,vx[0],vy[0],255,255,255);
	//drawTextInt(screen,2,vx[1],vy[1],255,255,255);
	//drawTextInt(screen,3,vx[2],vy[2],255,255,255);
	//polygonColor(srf,vx,vy,3,SDL_MapRGB(screen->format,255,255,255));
}
int drawtriw(SDL_Surface * srf,int x1,int y1,int x2,int y2,int x3,int y3,int r,int g,int b)
{
	int vx[3]; 
	int vy[3];
	vx[0]=x1;
	vx[1]=x2;
	vx[2]=x3;
	vy[0]=y1;
	vy[1]=y2;
	vy[2]=y3; 
	//drawpoly(srf,vx,vy,3,SDL_MapRGB(screen->format,r,g,b));

	polygonColor(srf,vx,vy,3,SDL_MapRGB(screen->format,255,255,255));
	//drawTextInt(screen,1,vx[0],vy[0],255,255,255);
	//drawTextInt(screen,2,vx[1],vy[1],255,255,255);
	//drawTextInt(screen,3,vx[2],vy[2],255,255,255);
}
#ifdef HWER
int drawtri(SDL_Surface * srf,vertex v1,vertex v2,vertex v3,texture *tex)
{
	int vx[6]; 
	int vy[6];
	vx[0]=v1.x;
	vx[1]=v2.x;
	vx[2]=v3.x;
	vy[0]=v1.y;
	vy[1]=v2.y;
	vy[2]=v3.y; 
	vx[3]=v1.tx;
	vx[4]=v2.tx;
	vx[5]=v3.tx;
	vy[3]=v1.ty;
	vy[4]=v2.ty;
	vy[5]=v3.ty; 
	drawpoly(srf,vx,vy,3,tex);
	polygonColor(srf,vx,vy,3,SDL_MapRGB(screen->format,255,255,255));
}
#endif
int drawtri(SDL_Surface * srf,int x1,int y1,int x2,int y2,int x3,int y3,int r,int g,int b,int a)
{
	int vx[3]; 
	int vy[3];
	vx[0]=x1;
	vx[1]=x2;
	vx[2]=x3;
	vy[0]=y1;
	vy[1]=y2;
	vy[2]=y3;
	drawpoly(srf,vx,vy,3,SDL_MapRGB(screen->format,r,g,b),a);
}

int vid_init()
{
	SDL_Init(SDL_INIT_EVERYTHING);
	#ifndef GP2X
	screen=SDL_SetVideoMode(320,240,16,SDL_SWSURFACE);
	SDL_WM_SetCaption( "32D", 0 );	
	#else
	screen=SDL_SetVideoMode(320,240,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
	SDL_ShowCursor(SDL_DISABLE);															// Disable mouse cursor on gp2x
	#endif
	TTF_Init();
	font = TTF_OpenFont("arial.ttf", 12);
	backcolor=SDL_MapRGB(screen->format,0,0,0);
	SDL_FillRect(screen,NULL,backcolor);
}

vertex project(vertex ver)
{
	vertex ret;
	if(ver.z<=0) return 0;
	ret.x=((ver.x)*hpc/ver.z)+160;
	ret.y=-((ver.y)*vpc/ver.z)+120;
	ret.z=ver.z;
#ifdef TEX
	ret.u=ver.u;
	ret.v=ver.v;
#endif	
	return ret;
}
class face
{
	public:
	int z;
	int verti[3];

};
unsigned short swp[4000];
int zdata[4000];
void zsort(int zsortdata[], object *obj)
{
    int i, mz;
    for (i=0; i<obj->nfac; i++)
    {
        mz = (int)(obj->verti[obj->faces[i][0]].z + obj->verti[obj->faces[i][1]].z + obj->verti[obj->faces[i][2]].z)/3;
        zsortdata[i] = -mz;
		swp[i] = i;
    }
}
inline void ClearZbuffer()
{
   // memset(zbuffer, 30000, sizeof(unsigned int) * 76800);
   int f;
   for(f=0;f<76800;f++)
   {
	printf("%i ",zbuffer[f]);
	zbuffer[f]=300000;
	if(f%320==0)printf("\n");
	}
	printf("\n\n");
}
void quicksort (int lo, int hi, int data[])
{
	int m1 = lo;
	int m2 = hi;
	int temp0;
	unsigned short temp1;

	int mp = data[(lo + hi)>>1];

	while (m1<=m2)
	{
		while (data[m1] < mp) m1++;
		while (mp < data[m2]) m2--;

		if (m1<=m2)
		{
			temp0 = data[m1]; data[m1] = data[m2]; data[m2] = temp0;
			temp1 = swp[m1]; swp[m1] = swp[m2]; swp[m2] = temp1;
			m1++;
			m2--;
		}
	}

	if (m2>lo) quicksort(lo, m2, data);
	if (m1<hi) quicksort(m1, hi, data);
}
int mode;
bool texd=0;
int vid_update()
{
	SDL_FillRect(screen,NULL,backcolor);
	int vx0, vy0, vx1, vy1, n;
	bool done=0;
	int objat=0;
	int tx[3],ty[3];
	printf("vid_update: ready\n");
	vertex tver[4000];
	switch(mode)
	{
	case 0:
	for(i=0;i<objs[objat]->nver;i++)
		tver[i]=project(vertexmulmatrix4x3(objs[objat]->verti[i],objs[objat]->local));
	zsort(zdata,objs[objat]);
	quicksort(0, objs[objat]->nfac - 1, zdata);
	for(i=objs[objat]->nfac-1;i>=0;i--)
	{
		vx0 = tver[objs[objat]->faces[swp[i]][0]].x - tver[objs[objat]->faces[swp[i]][1]].x;
        vy0 = tver[objs[objat]->faces[swp[i]][0]].y - tver[objs[objat]->faces[swp[i]][1]].y;
        vx1 = tver[objs[objat]->faces[swp[i]][2]].x - tver[objs[objat]->faces[swp[i]][1]].x;
        vy1 = tver[objs[objat]->faces[swp[i]][2]].y - tver[objs[objat]->faces[swp[i]][1]].y;
        n = vx0 * vy1 - vx1 * vy0;
		if(n<0)
		//DrawFlatTriangleZB(tver[objs[objat]->faces[i][0]],tver[objs[objat]->faces[i][1]],tver[objs[objat]->faces[i][2]],SDL_MapRGB(screen->format,objs[objat]->faces[i][3],objs[objat]->faces[i][4],objs[objat]->faces[i][5]));
		drawtri(screen,tver[objs[objat]->faces[swp[i]][0]].x,tver[objs[objat]->faces[swp[i]][0]].y,tver[objs[objat]->faces[swp[i]][1]].x,tver[objs[objat]->faces[swp[i]][1]].y,tver[objs[objat]->faces[swp[i]][2]].x,tver[objs[objat]->faces[swp[i]][2]].y,objs[objat]->faces[swp[i]][3],objs[objat]->faces[swp[i]][4],objs[objat]->faces[swp[i]][5]);
	
//	tri(tver[objs[objat]->faces[i][0]],tver[objs[objat]->faces[i][1]],tver[objs[objat]->faces[i][2]],SDL_MapRGB(screen->format,objs[objat]->faces[i][3],objs[objat]->faces[i][4],objs[objat]->faces[i][5]));
	}
	break;
	case 1:
	for(i=0;i<objs[objat]->nver;i++)
		tver[i]=project(vertexmulmatrix4x3(objs[objat]->verti[i],objs[objat]->local));
	ClearZbuffer();
	for(i=objs[objat]->nfac-1;i>=0;i--)
	{
		if(objs[objat]->norms[i].z>=0)
		DrawFlatTriangleZB(tver[objs[objat]->faces[i][0]],tver[objs[objat]->faces[i][1]],tver[objs[objat]->faces[i][2]],SDL_MapRGB(screen->format,objs[objat]->faces[i][3],objs[objat]->faces[i][4],objs[objat]->faces[i][5]));
		//drawtri(screen,tver[objs[objat]->faces[swp[i]][0]].x,tver[objs[objat]->faces[swp[i]][0]].y,tver[objs[objat]->faces[swp[i]][1]].x,tver[objs[objat]->faces[swp[i]][1]].y,tver[objs[objat]->faces[swp[i]][2]].x,tver[objs[objat]->faces[swp[i]][2]].y,objs[objat]->faces[swp[i]][3],objs[objat]->faces[swp[i]][4],objs[objat]->faces[swp[i]][5]);
	}
	break;
	
	case 3:
	for(i=0;i<objs[objat]->nver;i++)
		tver[i]=project(vertexmulmatrix4x3(objs[objat]->verti[i],objs[objat]->local));
	zsort(zdata,objs[objat]);
	quicksort(0, objs[objat]->nfac - 1, zdata);
	for(i=objs[objat]->nfac-1;i>=0;i--)
	{
		vx0 = tver[objs[objat]->faces[swp[i]][0]].x - tver[objs[objat]->faces[swp[i]][1]].x;
        vy0 = tver[objs[objat]->faces[swp[i]][0]].y - tver[objs[objat]->faces[swp[i]][1]].y;
        vx1 = tver[objs[objat]->faces[swp[i]][2]].x - tver[objs[objat]->faces[swp[i]][1]].x;
        vy1 = tver[objs[objat]->faces[swp[i]][2]].y - tver[objs[objat]->faces[swp[i]][1]].y;
        n = vx0 * vy1 - vx1 * vy0;
		if(n<0)
		//DrawFlatTriangleZB(tver[objs[objat]->faces[i][0]],tver[objs[objat]->faces[i][1]],tver[objs[objat]->faces[i][2]],SDL_MapRGB(screen->format,objs[objat]->faces[i][3],objs[objat]->faces[i][4],objs[objat]->faces[i][5]));
		drawtri(screen,tver[objs[objat]->faces[swp[i]][0]].x,tver[objs[objat]->faces[swp[i]][0]].y,tver[objs[objat]->faces[swp[i]][1]].x,tver[objs[objat]->faces[swp[i]][1]].y,tver[objs[objat]->faces[swp[i]][2]].x,tver[objs[objat]->faces[swp[i]][2]].y,objs[objat]->faces[swp[i]][3],objs[objat]->faces[swp[i]][4],objs[objat]->faces[swp[i]][5]);
	//DrawFlatTriangle(tver[objs[objat]->faces[i][0]],tver[objs[objat]->faces[i][1]],tver[objs[objat]->faces[i][2]],SDL_MapRGB(screen->format,objs[objat]->faces[i][3],objs[objat]->faces[i][4],objs[objat]->faces[i][5]));
	}
	break;
	case 4:
	for(i=0;i<objs[objat]->nver;i++)
		tver[i]=project(vertexmulmatrix4x3(objs[objat]->verti[i],objs[objat]->local));
	zsort(zdata,objs[objat]);
	quicksort(0, objs[objat]->nfac - 1, zdata);
	for(i=objs[objat]->nfac-1;i>=0;i--)
	{
		vx0 = tver[objs[objat]->faces[swp[i]][0]].x - tver[objs[objat]->faces[swp[i]][1]].x;
        vy0 = tver[objs[objat]->faces[swp[i]][0]].y - tver[objs[objat]->faces[swp[i]][1]].y;
        vx1 = tver[objs[objat]->faces[swp[i]][2]].x - tver[objs[objat]->faces[swp[i]][1]].x;
        vy1 = tver[objs[objat]->faces[swp[i]][2]].y - tver[objs[objat]->faces[swp[i]][1]].y;
        n = vx0 * vy1 - vx1 * vy0;
		//if(n<0)
		//DrawFlatTriangleZB(tver[objs[objat]->faces[i][0]],tver[objs[objat]->faces[i][1]],tver[objs[objat]->faces[i][2]],SDL_MapRGB(screen->format,objs[objat]->faces[i][3],objs[objat]->faces[i][4],objs[objat]->faces[i][5]));
		drawtriw(screen,tver[objs[objat]->faces[swp[i]][0]].x,tver[objs[objat]->faces[swp[i]][0]].y,tver[objs[objat]->faces[swp[i]][1]].x,tver[objs[objat]->faces[swp[i]][1]].y,tver[objs[objat]->faces[swp[i]][2]].x,tver[objs[objat]->faces[swp[i]][2]].y,objs[objat]->faces[swp[i]][3],objs[objat]->faces[swp[i]][4],objs[objat]->faces[swp[i]][5]);
#ifdef TEX	
	vertex v[3];
		v[0]=tver[objs[objat]->faces[swp[i]][0]];
		v[1]=tver[objs[objat]->faces[swp[i]][1]];
		v[2]=tver[objs[objat]->faces[swp[i]][2]];
		TextureMapTriangle_suba_fx_fl(screen,v,tex);
//	DrawTextureTriangle(tver[objs[objat]->faces[i][0]],tver[objs[objat]->faces[i][1]],tver[objs[objat]->faces[i][2]],tex);
#endif
	}
	break;
	case 2:
	vertex cam(0),came;
	objs[objat]->Calcw2obj();
	came=vertexmulmatrix4x3(cam,objs[objat]->w2obj);
	for(i=0;i<objs[objat]->nver;i++)
		tver[i]=project(vertexmulmatrix4x3(objs[objat]->verti[i],objs[objat]->local));
	for(i=0;i<objs[objat]->nfac;i++)
	{
		if(!behind(came,objs[objat]->norms[i],objs[objat]->faces[i][6]))
		drawtri(screen,tver[objs[objat]->faces[i][0]].x,tver[objs[objat]->faces[i][0]].y,tver[objs[objat]->faces[i][1]].x,tver[objs[objat]->faces[i][1]].y,tver[objs[objat]->faces[i][2]].x,tver[objs[objat]->faces[i][2]].y,objs[objat]->faces[i][3],objs[objat]->faces[i][4],objs[objat]->faces[i][5]);
	}
	break;
	}
}

// END VIDEO//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int inputwait()
{
bool quit=0;
SDL_Event ev;
while(!quit)
      while(SDL_PollEvent(&ev))
     {
       switch(ev.type)
       {
         case SDL_KEYDOWN:
		 quit=1;
		 break;
		 }
		 }
  }
		/*
		[G:\supertux\data\music\cave.mod]
[G:\supertux\data\music\fortress.mod]
[G:\supertux\data\music\fortress2.mod]
[G:\supertux\data\music\leveldone.mod]
[G:\supertux\data\music\Mortimers_chipdisko.mod]
[G:\supertux\data\music\salcon.mod]
[G:\supertux\data\music\cave-fast.mod]
[G:\supertux\data\music\fortress-fast.mod]
[G:\supertux\data\music\fortress2-fast.mod]
[G:\supertux\data\music\Mortimers_chipdisko-fast.mod]
[G:\supertux\data\music\SALCON-fast.MOD]
[G:\supertux\data\music\9.mod]
[G:\supertux\data\music\theme.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\area1-game.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\area1-game2.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\area2-game.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\area3-game.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\area4-game.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\area5-game.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\gardien-go.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\high-score.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\over-theme.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\tecno-winn.mod]
[G:\tecnoballz-0.91-gp2x\release\tecnoballz_gp2x\TecnoballZ\musics\tecnoballz.mod]
[G:\sdltest\music.mod]
[G:\noiz2sa\data\sounds\stg0.mod]
[G:\noiz2sa\data\sounds\stg1.mod]
[G:\noiz2sa\data\sounds\stg2.mod]
[G:\noiz2sa\data\sounds\stg3.mod]
[G:\noiz2sa\data\sounds\stg4.mod]
[G:\noiz2sa\data\sounds\stg5.mod]
[G:\noiz2sa\data\sounds\stg6.mod]
[G:\noiz2sa\data\sounds\stg9.mod]
[G:\znax\music\title.mod]
[G:\myold64.mod]
*/ int nfrm=0, pfrm=0;
int fps=0, atime=0;
int main(int argc, char **argv)
{
	vid_init();
	for(i=0;i<360;i++)
	{
		fcos[i]=(Fixed)cos(i*PI/180);
		fsin[i]=(Fixed)sin(i*PI/180);
		ftan[i]=(Fixed)tan(i*PI/180);
	}
	for ( i = 0; i < 4096/2; i++ ) {
      double radian = ( ( double ) i ) * ( 2.0 * M_PI ) / ( double ) 4096;
      float result = sin( radian );
      data[i] = (Fixed)( result );
   }
   for ( i = 0; i < 4096/2; i++ ) {
      data[i+4096/2] = data[i] * -1;
   }
   for(i=0;i<7000;i++)
   fsqrt[i]=(float)sqrt(i);
   int fp = 16;
    int i;
    for (i=0; i<4096; i++)
    {
        if ((i-2048)!=0)
            pdiv[i] = (1<<fp)/(i-2048);
        else
            pdiv[i] = (1<<fp);
    }

	hpc=(Fixed)160/ftan(30);
	vpc=((Fixed)120/ftan(30))*1.3333333333333333333333;
	printf("main: hpc=%d,vpc=%d\n",(double)hpc,(double)vpc);
	aspect=1;
	tex=SDL_DisplayFormatAlpha(SDL_LoadBMP("texture.bmp"));
	cube Cube;	
	addobj(Cube);
	Cube.MoveAlongZ(75);
	//Cube.RotateAroundX(90);
	
	printf("main: starting\n");
	vid_update();
	SDL_Flip(screen);
	SDL_Event ev;
	//Cube.RotateAroundZ(450);
	unsigned zm,ym,xm;
	int at;
	bool quit=0;
	int start;
struct timeval tv;
gettimeofday(&tv,NULL);
start=SDL_GetTicks();
	int totalfps=0;
	bool move=0;
	SDL_Rect r,r2;
	r.x=0;
	r.y=0;
	r.w=100;
	r.h=5;
	r2.x=5;
	r2.y=20;
	r2.w=100;
	r2.h=5;
while(!quit)
{
#ifndef GP2X
      while(SDL_PollEvent(&ev))
     {
       switch(ev.type)
       {
         case SDL_KEYDOWN:
		 switch(ev.key.keysym.sym)
		 {
			case SDLK_UP:
			 Cube.RotateAroundX(50);
			break;
			case SDLK_DOWN:
			 Cube.RotateAroundX((unsigned short)-50);
			break;
			case SDLK_RIGHT:
			 Cube.RotateAroundY(50);
			break;
			case SDLK_LEFT:
			 Cube.RotateAroundY(-50);
			break;
			case SDLK_o:
			 Cube.RotateAroundZ(50);
			break;
			case SDLK_p:
			 Cube.RotateAroundZ(-50);
			break;
			case SDLK_w:
			Cube.MoveAlongY(50);
			break;
			case SDLK_s:
			Cube.MoveAlongY(-50);
			break;
			case SDLK_a:
			Cube.MoveAlongX(-50);
			break;
			case SDLK_d:
			Cube.MoveAlongX(50);
			break;
			case SDLK_r:
			Cube.MoveAlongZ(50);
			break;
			case SDLK_f:
			Cube.MoveAlongZ(-50);
			break;
			case SDLK_ESCAPE:
			quit=1;
			break;
			case SDLK_t:
			mode++;
			if(mode>4)mode=0;
			break;
			case SDLK_g:
			mode--;
			if(mode<0)mode=4;
			break;
			case SDLK_b:
			move=!move;
			break;
			
		}
		 break;
		 case SDL_KEYUP:
		 switch(ev.key.keysym.sym)
		 {
			case SDLK_UP:
			xm=0;
			break;
			case SDLK_DOWN:
			xm=0;
			break;
			case SDLK_RIGHT:
			ym=0;
			break;
			case SDLK_LEFT:
			ym=0;
			break;
			case SDLK_o:
			zm=0;
			break;
			case SDLK_p:
			zm=0;
			break;
			
		}
		 break;
		 }
		 }
		 #else
		 SDL_BlitSurface(tex,&r,screen,&r2);
		 #endif
	//	  Cube.RotateAroundZ(1);
	//	  Cube.RotateAroundY(1);
		//  Cube.RotateAroundX(1);
		  gettimeofday(&tv,NULL);
		  at++;
		 /* if(at%1000==0)
		  {
			
			printf("main: fps=%i\n",at/(tv.tv_sec-start));
		}*/
	//	 Cube.RotateAroundY(5);
	if(move)
	{
		 Cube.RotateAroundZ(2);
		 Cube.RotateAroundY(2);
		 Cube.RotateAroundX(2);
		 }
		 	vid_update();
			if (SDL_GetTicks()-atime>=1000)
	{
		atime = SDL_GetTicks();
		fps=(nfrm-pfrm);
		pfrm=nfrm;
	}
	nfrm++;
			drawTextInt(screen,/*at/(SDL_GetTicks()/1000.f)*/fps,0,0,255,255,255);
			drawTextInt(screen,(int)Cube.local.GetTranslation().x,0,12,255,255,255);
			drawTextInt(screen,(int)Cube.local.GetTranslation().y,0,24,255,255,255);
			drawTextInt(screen,(int)Cube.local.GetTranslation().z,0,36,255,255,255);
			drawTextInt(screen,(int)mode,0,48,255,255,255);
			
	SDL_Flip(screen);
	//SDL_Delay(50);
		 }
	SDL_Quit();
	printf("%ffps\n",(float)(at/(SDL_GetTicks()/1000.f)));
}
