#define TEXTURE
#ifndef GP2X
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#else
#include "SDL.h"
#include "SDL_gfxPrimitives.h"
#include "SDL_rotoZoom.h"
#include "SDL_framerate.h"
#include "SDL_ttf.h"
#include "SDL_mixer.h"
#include "SDL_image.h"
#include "SDL_joystick.h"
#include <sys/mman.h>
#include <sys/ioctl.h>
#endif
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <sstream>
#include <iostream>


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <string>
#include <map>
#include <cstddef>
#include <cassert>
#include <cmath>
#include <algorithm>
#include "fixed.h"
#define NUMOBJ 100
#define PI 3.14159265
#define fsin(a) fsin[a] 
#define fcos(a) fcos[a] 
#define ftan(a) ftan[a] 
#define FM(a,b) a*b
SDL_Surface* screen;
TTF_Font* font;
SDL_Event event;
int i,j;
bool quit;
Uint32 backcolor;
Fixed fcos[361];
Fixed fsin[361];
Fixed ftan[361];
Fixed hpc,aspect,vpc;

const static Fixed _identity_matrix_4x3[4][3] = {
   { (Fixed)1, 0L, 0L },
   { 0L, (Fixed)1, 0L },
   { 0L, 0L, (Fixed)1 },
   { 0L, 0L, 0L}
};
class vertex
{
	public:
	Fixed x,y,z;
#ifdef TEXTURE
	int tx,ty;
#endif
	vertex() { x=0; y=0; z=0; };
	vertex(const Fixed& a) { x=a; y=a; z=a; }
	vertex(float a) { x=y=z=a; }
	vertex(double a) { x=y=z=a; }
	vertex(int a) { x=y=z=a; }
	vertex(long a) { x=y=z=a; }
	vertex(const vertex& a) { x=a.x; y=a.y; z=a.z; }
	vertex(const Fixed& a,const Fixed& b,const Fixed& c) { x=a; y=b; z=c; };
	vertex(float a,float b,float c) { x=a; y=b; z=c; };
	vertex(double a,double b,double c) { x=a; y=b; z=c; };
	vertex(int a,int b,int c) { x=a; y=b; z=c; };
	vertex(long a,long b,long c) { x=a; y=b; z=c; };
	vertex& operator =(const Fixed& a) { x=a; y=a; z=a; }
	vertex& operator =(int a) { x=a; y=a; z=a; }
	vertex& operator =(long a) { x=a; y=a; z=a; }	
	
vertex Cross( const vertex &b ) const
{
vertex result;

   result.x = y* b.z -z*b.y;
   result.y = z* b.x  -  x* b.z ;
   result.z = x* b.y  -  y* b.x;

   return result;
}
Fixed Dot( const vertex &b ) const
{
   return x*b.x+y*b.y+z*b.z;
}
Fixed Magnitude( void ) const
{
float f;

   f  =  (float)(x  *( x ) +
         y  * ( y ) +
        z  *( z ));
   return ( (Fixed)( sqrt( f ) ) );
}

int MagnitudeSquared( void ) const
{
  return (int) (  ( z* z )
                          + ( y* y )
                          + ( z*  z ) );
}
void Normalize( void )
{
Fixed magnitude = Magnitude();

   x =  x/ magnitude ;
   y =( y/ magnitude );
   z =( z/ magnitude );
}
};
static unsigned short ConvertDegree( unsigned short angle )
     {
        return ( unsigned short ) ( ( ( ( long ) angle ) << 16 ) / 3600L );
     }
class texture
{
	public:
	SDL_Surface *srf;
	int wl,hl,wm,hm;
	texture(SDL_Surface *s) 
	{
		srf=s;
		wl=log2p(s->w);
		hl=log2p(s->h);
		wm=s->w-1;
		hm=s->h-1;
	}
	texture()
	{
		wl=hl=wm=hm=0;
	}
	void settexture(SDL_Surface *s)
	{
		srf=s;
		wl=log2p(s->w);
		hl=log2p(s->h);
		wm=s->w-1;
		hm=s->h-1;
	}
	~texture() 
	{
		SDL_FreeSurface(srf); 
	}
	// returns log2 of a number which is a power if two
	unsigned log2p(unsigned v) const
	{
		unsigned r = 0;
		while (!(v & 1)) {
			v >>= 1;
			++r;
		}
		return r;
	}
	// samples the texture using the given texture coordinate.
	// the integer texture coordinate is given in the upper 16 bits of the x and y variables.
	// it is NOT in the range [0.0, 1.0] but rather in the range of [0, width - 1] or [0, height - 1].
	// texture coordinates outside this range are wrapped.
	unsigned short sample_nearest(int x, int y) const
	{
		x >>= 16;
		y >>= 16;
		x &= wm;
		y &= hm;
		return *(static_cast<unsigned short*>(srf->pixels) + ((y << wl) + x));
	}
};
class matrix3x3
{
	public:
	Fixed data[3][3];
	void Transpose()
	{
		Fixed tmp;
		tmp = data[0][1];
		data[0][1] = data[1][0];
		data[1][0] = tmp;
		tmp = data[0][2];
		data[0][2] = data[2][0];
		data[2][0] = tmp;
		tmp = data[1][2];
		data[1][2] = data[2][1];
		data[2][1] = tmp;
	}
	const Fixed * operator[] ( int a ) const { return data[a]; }
    Fixed       * operator[] ( int a ) { return data[a]; }
};
class matrix4x3
{
	public:
	Fixed data[4][3];
	void MakeIdentity( void )
{
   memcpy( data, _identity_matrix_4x3, sizeof( _identity_matrix_4x3 ) );
}
    void MakeXTranslation(Fixed amount)
{
   data[3][0] = amount;
   data[3][1] = 0;
   data[3][2] = 0;
}
    void MakeYTranslation(Fixed amount)
{
   data[3][0] = 0;
   data[3][1] = amount;
   data[3][2] = 0;
}
    void MakeZTranslation(Fixed amount)
{
   data[3][0] = 0;
   data[3][1] = 0;
   data[3][2] = amount;
}
    void MakeXRotation(unsigned short amount){
unsigned short lookup = ConvertDegree(amount);

   data[1][1] =  cos( lookup );
   data[2][2] =  cos( lookup );
   data[2][1] = -sin( lookup );
   data[1][2] =  sin( lookup );
}
    void MakeYRotation(unsigned short amount)
{
unsigned short lookup = ConvertDegree(amount);

   data[0][0] =  cos( lookup );
   data[0][2] = -sin( lookup );
   data[2][0] =  sin( lookup );
   data[2][2] =  cos( lookup );
}
    void MakeZRotation(unsigned short amount)
{
unsigned short lookup = ConvertDegree( amount );

   data[0][0] =  cos( lookup );
   data[1][1] =  cos( lookup );
   data[0][1] =  sin( lookup );
   data[1][0] = -sin( lookup );
}
    void NormalizeDirectionVectors(void)
{
vertex v;
   GetVU( v );
   v.Normalize();
   SetVU( v );
   GetVR( v );
   v.Normalize();
   SetVR( v );
   GetVF( v );
   v.Normalize();
   SetVF( v );
}
    void GetRotationMatrix(matrix3x3 &rm) const
{
   for ( int i = 0; i < 3; i++ )
      memcpy( rm[i], data[i], sizeof( Fixed ) * 3 );
}
    void SetRotationMatrix(const matrix3x3 &rm)
{
   for ( int i = 0; i < 3; i++ )
      memcpy( data[i], rm[i], sizeof( Fixed ) * 3 );
}
    void SetTranslation(Fixed x,Fixed y,Fixed z)
    {
       data[3][0] = x;
       data[3][1] = y;
       data[3][2] = z;
    }
    void SetTranslation( const vertex &v )
    {
       SetTranslation( v.x, v.y, v.z );
    }
    vertex GetTranslation( void ) const
    {
       return vertex( data[3][0], data[3][1], data[3][2] );
    }
    void GetVU( vertex &v ) const
    {
       v.x = data[0][1];
       v.y = data[1][1];
       v.z = data[2][1];
    }
    void GetVR( vertex &v ) const
    {
       v.x = data[0][0];
       v.y = data[1][0];
       v.z = data[2][0];
    }
    void GetVF( vertex &v ) const
    {
       v.x = data[0][2];
       v.y = data[1][2];
       v.z = data[2][2];
    }
    void SetVU( const vertex &v )
    {
       data[0][1] = v.x;
       data[1][1] = v.y;
       data[2][1] = v.z;
    }
    void SetVR( const vertex &v )
    {
       data[0][0] = v.x;
       data[1][0] = v.y;
       data[2][0] = v.z;
    }
    void SetVF( const vertex &v )
    {
       data[0][2] = v.x;
       data[1][2] = v.y;
       data[2][2] = v.z;
	}
	const Fixed * operator[] ( int a ) const { return data[a]; }
    Fixed       * operator[] ( int a ) { return data[a]; }	
	

};
vertex vertexmulmatrix4x3 (vertex &v,const matrix4x3 m )
{
vertex result;

  result.x = ( m[0][0]* v.x ) +
             ( m[1][0]* v.y ) +
             ( m[2][0]* v.z ) +
             m[3][0];

  result.y = ( m[0][1]* v.x ) +
             ( m[1][1]* v.y ) +
             ( m[2][1]* v.z ) +
             m[3][1];

  result.z = ( m[0][2]* v.x ) +
             ( m[1][2]* v.y ) +
             ( m[2][2]* v.z ) +
             m[3][2];

  return result;
}
matrix4x3 matrixmul ( const matrix4x3 &a, const matrix4x3 &b )
{
static matrix4x3 m;
   m[0][0] = FM( a[0][0], b[0][0] ) +             FM( a[0][1], b[1][0] ) +             FM( a[0][2], b[2][0] );
   m[0][1] = FM( a[0][0], b[0][1] ) +             FM( a[0][1], b[1][1] ) +             FM( a[0][2], b[2][1] );
   m[0][2] = FM( a[0][0], b[0][2] ) +             FM( a[0][1], b[1][2] ) +             FM( a[0][2], b[2][2] );
   m[1][0] = FM( a[1][0], b[0][0] ) +             FM( a[1][1], b[1][0] ) +             FM( a[1][2], b[2][0] );
   m[1][1] = FM( a[1][0], b[0][1] ) +             FM( a[1][1], b[1][1] ) +             FM( a[1][2], b[2][1] );
   m[1][2] = FM( a[1][0], b[0][2] ) +             FM( a[1][1], b[1][2] ) +             FM( a[1][2], b[2][2] );
   m[2][0] = FM( a[2][0], b[0][0] ) +             FM( a[2][1], b[1][0] ) +             FM( a[2][2], b[2][0] );
   m[2][1] = FM( a[2][0], b[0][1] ) +             FM( a[2][1], b[1][1] ) +             FM( a[2][2], b[2][1] );   m[2][2] = FM( a[2][0], b[0][2] ) +             FM( a[2][1], b[1][2] ) +             FM( a[2][2], b[2][2] );
   m[3][0] = FM( a[3][0], b[0][0] ) +             FM( a[3][1], b[1][0] ) +             FM( a[3][2], b[2][0] ) +             b[3][0];
   m[3][1] = FM( a[3][0], b[0][1] ) +  FM( a[3][1], b[1][1] ) + FM( a[3][2], b[2][1] ) +b[3][1];
   m[3][2] = FM( a[3][0], b[0][2] ) +             FM( a[3][1], b[1][2] ) +            FM( a[3][2], b[2][2] ) +            b[3][2];
   return m;
}

class object
{
	public:
	int id;//the objects id(DON'T TOUCH IT)
	Fixed x,y,z;
	int w,h,r;//width,height,and radius:  its YOUR job to update these
	int data1;//variables you can store stuff in(for inheritense/polymorphism)
	char *data2;//more
	Fixed data3;//even more
	vertex verti[1500];//all the verti this object has
	int faces[1500][5];//collection of pointers to the 3 verti of each face - 0,1,2 are verti - 3,4,5 are rgb
	int nver,nfac;//number of verti/faces
	virtual int update()=0;//this function will be called every time 32D updates
	virtual void hit(object* obj)=0;//this gets called when this object collides with another,  it will be passed a pointer to the other object
	matrix4x3 w2obj;
    matrix4x3 local;
	texture tex;
	object()
	{
		for(i=0;i<1500;i++)
		{
			faces[i][3]=rand()%255;
			faces[i][4]=rand()%255;
			faces[i][5]=rand()%255;
		}
		local.MakeIdentity();
	}
	const matrix4x3 *Calcw2obj( void )
{
vertex    position;
matrix3x3 rm3x3;

   /*
   ** Get object's rotation matrix and translation.
   */
   local.GetRotationMatrix( rm3x3 );

   /*
   ** Invert the rotation matrix (a transpose is the
   ** the same as an inversion when working with
   ** rotation matrices).
   */
   rm3x3.Transpose();

   /*
   ** Transform its location by the inverted rotation matrix
   */
   //position = local.GetTranslation*rm3x3;

   /*
   ** Create world_to_object_matrix
   */
   w2obj.SetRotationMatrix( rm3x3 );
   //w2obj.SetTranslation( -position );
   w2obj.NormalizeDirectionVectors();

   return &w2obj;
}
matrix4x3 translation_matrix;

void MoveAlongX( Fixed amount )
{
   translation_matrix.MakeIdentity();
   translation_matrix.MakeXTranslation( amount );
   local = matrixmul(translation_matrix ,local);
}

void MoveAlongY( Fixed amount )
{
   translation_matrix.MakeIdentity();
   translation_matrix.MakeYTranslation( amount );
   local = matrixmul(translation_matrix ,local);
}

void MoveAlongZ( Fixed amount )
{
   translation_matrix.MakeIdentity();
   translation_matrix.MakeZTranslation( amount );
   local = matrixmul(translation_matrix, local);
}
matrix4x3 rotation_matrix;

void RotateAroundX( unsigned short tenths_of_degrees )
{
Fixed m10 = local[1][0], m20 = local[2][0],m11 = local[1][1],m21 = local[2][1];
   rotation_matrix.MakeXRotation( tenths_of_degrees );
Fixed sm11 = rotation_matrix[1][1],sm12 = rotation_matrix[1][2],  sm21 = rotation_matrix[2][1],sm22 = rotation_matrix[2][2];
   /*
   ** Compute column 0
   */
   local[1][0] =( sm11* m10 ) + ( sm12* m20 );
   local[2][0] = ( sm21* m10 ) + ( sm22* m20 );
   /*
   ** Compute column 1
   */
   local[1][1] = ( sm11* m11 ) +( sm12* m21 );
   local[2][1] = ( sm21* m11 ) +  ( sm22* m21 );
   /*
   ** Compute column 2 (as col0 x col1 )
   */
   local[0][2] = ( local[1][0]* local[2][1] ) - ( local[2][0]* local[1][1] );
   local[1][2] = ( local[2][0]* local[0][1] ) - ( local[0][0]* local[2][1] );
   local[2][2] = ( local[0][0]* local[1][1] ) - ( local[0][1]* local[1][0] );
   /*
   ** Recompute column 0 as col1 x col2
   */
   vertex vu, vf, new_vr;
   local.GetVF( vf );
   local.GetVU( vu );
   new_vr = vu.Cross( vf );
   local.SetVR( new_vr );
   local.NormalizeDirectionVectors();
}
void RotateAroundY( unsigned short tenths_of_degrees )
{
Fixed m00 = local[0][0],m20 = local[2][0],m01 = local[0][1], m21 = local[2][1];
   rotation_matrix.MakeYRotation( tenths_of_degrees );
Fixed sm00 = rotation_matrix[0][0],sm02 = rotation_matrix[0][2], sm20 = rotation_matrix[2][0],sm22 = rotation_matrix[2][2];
   /*
   ** Compute column 0
   */
   local[0][0] = ( sm00* m00 ) +( sm02* m20 );
   local[2][0] = ( sm20* m00 ) +( sm22* m20 );
   /*
   ** Compute column 1
   */
   local[0][1] = ( sm00* m01 ) +( sm02* m21 );
   local[2][1] = ( sm20* m01 ) +( sm22* m21 );
   /*
   ** Compute column 2 (as col0 x col1 )
   */
   local[0][2] = ( local[1][0]* local[2][1] ) -( local[2][0]* local[1][1] );
   local[1][2] = ( local[2][0]* local[0][1] ) -( local[0][0]* local[2][1] );
   local[2][2] = ( local[0][0]* local[1][1] ) -( local[0][1]* local[1][0] );
   /*
   ** Recompute column 0 (as col1 x col2 )
   */
   vertex vu, vf, new_vr;
   local.GetVF( vf );
   local.GetVU( vu );
   new_vr = vu.Cross( vf );
   local.SetVR( new_vr );
   local.NormalizeDirectionVectors();
}
void RotateAroundZ( unsigned short tenths_of_degrees )
{
Fixed m00 = local[0][0],m01 = local[0][1],m10 = local[1][0], m11 = local[1][1];
   rotation_matrix.MakeZRotation( tenths_of_degrees );
Fixed sm00 = rotation_matrix[0][0],sm01 = rotation_matrix[0][1],sm10 = rotation_matrix[1][0],sm11 = rotation_matrix[1][1];
   /*
   ** Compute column 0
   */
   local[0][0] = ( sm00* m00 ) +( sm01* m10 );
   local[1][0] = ( sm10* m00 ) +( sm11* m10 );
   /*
   ** Compute column 1
   */
   local[0][1] = ( sm00* m01 ) + ( sm01* m11 );
   local[1][1] = ( sm10* m01 ) + ( sm11* m11 );
   /*
   ** Compute column 2 (as col0 x col1 )
   */
   local[0][2] = ( local[1][0]* local[2][1] ) - ( local[2][0]* local[1][1] );
   local[1][2] = ( local[2][0]* local[0][1] ) - ( local[0][0]* local[2][1] );
   local[2][2] = ( local[0][0]* local[1][1] ) - ( local[0][1]* local[1][0] );
   /*
   ** Recompute column 0 (as col1 x col2 )
   */
   vertex vu, vf, new_vr;
   local.GetVF( vf );
   local.GetVU( vu );
   new_vr = vu.Cross( vf );
   local.SetVR( new_vr );
   local.NormalizeDirectionVectors();
}
	void loadOBJ(const char *filename)  // Loads a Wavefront .OBJ 3D model from filename NOTE: You must add a line with just ! at the end of your file
	{
	FILE *fp;
	fp=fopen(filename,"r");
	bool in=1;
	int vat=0,fat=0,vtt=0;//what # vertice and face we're on
	while (in) {
		//printf("Loading\n");
		char cmd[99];
		fscanf(fp,"%s ",&cmd);	
		printf("Command: %s\n",cmd);
		if (cmd[0] == '#')
		{		
			printf("c#\n");
			fscanf(fp,"\n");
			continue;
		}
		else if (cmd == "v " || cmd[0] == 'v') {
			//iss >> verti[vat].x >> verti[vat].y >> verti[vat].z;
			printf("cv\n");
			float x,y,z;
			if(fscanf(fp,"%f %f %f\n",&x,&y,&z))
			{
			verti[vat].x=x;
			verti[vat].y=y;
			verti[vat].z=z;
			printf("loadOBJ: %f %f %f\n",x,y,z);
			vat++;
			}
		} else if (cmd == "vn") {
			//vec3f v;
			//iss >> v.x >> v.y >> v.z;
			//result.normals.push_back(v);
		} else if (cmd == "cr") {
			//vec3f v;
			//iss >> v.x >> v.y >> v.z;
			//result.normals.push_back(v);
		} else if (cmd == "t" || (cmd[0]=='t')) {
#ifdef TEXTURE
			printf("ct\n");
			int a,b;
			if(fscanf(fp,"%i %i\n",&a,&b))
			{
			verti[vtt].tx=a;
			verti[vtt].ty=b;
			printf("loadOBJ: %i %i\n",a,b);
			vtt++;
			}
			//vec2f t;
			//iss >> t.x >> t.y;
			//result.texcoords.push_back(t);
#endif
		} else if (cmd == "f " || (cmd[0] == 'f')) {
			printf("cf\n");
			//iss >> faces[fat][0] >> faces[fat][1] >> faces[fat][2];
			int a,b,c;
			if(fscanf(fp,"%i %i %i \n",&a,&b,&c))
			{
			faces[fat][0]=a-1;
			faces[fat][1]=b-1;
			faces[fat][2]=c-1;
			printf("loadOBJ: %i %i %i\n",a,b,c);
			fat++;
			}
		} else if (cmd == "g") {
			//iss >> faces[fat][0] >> faces[fat][1] >> faces[fat][2];
			fscanf(fp,"%s\n",cmd);
		} else if (cmd == "! " || cmd[0] == '!') {
			printf("c!\n");
			in=0;
		} else fscanf(fp,"\n");
	}
	nver=vat;
	nfac=fat;
	printf("loadOBJ: %i faces and %i verti\n",nfac,nver);
	fclose(fp);
}
};

class cube:public object
{
	public:
	int update()
	{
	
	}
	void hit(object* obj)
	{
	
	}
	cube()
	{
#ifdef TEXTURE
		loadOBJ("cubet.obj");
		tex.settexture(SDL_DisplayFormatAlpha(SDL_LoadBMP("texture.bmp")));
#else
		loadOBJ("cubet.obj");
#endif
	/*	verti[0]=-20;//setting the verti
		verti[1].x=-20;//notice how you can set the x,y,z serperatly, or all at once
		verti[1].y=20;
		verti[1].z=-20;
		verti[2].x=20;
		verti[2].y=20;
		verti[2].z=-20;
		verti[3].x=20;
		verti[3].y=-20;
		verti[3].z=-20;
		verti[4].x=-20;
		verti[4].y=-20;
		verti[4].z=20;
		verti[5].x=20;
		verti[5].y=-20;
		verti[5].z=20;
		verti[6].x=20;
		verti[6].y=20;
		verti[6].z=20;
		verti[7].x=-20;
		verti[7].y=20;
		verti[7].z=20;
		nver=8;//we have 8 verti
		faces[0][0]=0;
		faces[0][1]=1;
		faces[0][2]=2;
		faces[1][0]=2;
		faces[1][1]=3;
		faces[1][2]=0;
		faces[2][0]=4;
		faces[2][1]=5;
		faces[2][2]=6;
		faces[3][0]=6;
		faces[3][1]=7;
		faces[3][2]=4;
		faces[4][0]=0;
		faces[4][1]=3;
		faces[4][2]=5;
		faces[5][0]=5;
		faces[5][1]=4;
		faces[5][2]=0;
		faces[6][0]=3;
		faces[6][1]=2;
		faces[6][2]=6;
		faces[7][0]=6;
		faces[7][1]=5;
		faces[7][2]=3;
		faces[8][0]=2;
		faces[8][1]=1;
		faces[8][2]=7;
		faces[9][0]=7;
		faces[9][1]=6;
		faces[9][2]=2;
		faces[10][0]=1;
		faces[10][1]=0;
		faces[10][2]=4;
		faces[11][0]=4;
		faces[11][1]=7;
		faces[11][2]=1;
		nfac=12;//12 faces*/
	}
};
object * objs[NUMOBJ];//32D's list of objects

// int addobj(object *obj)
// this function will add an object to 32D's list
int addobj(object &obj)
{
	//this cycles through the list of objects until it finds an empty one, then points that one to obj
	int d;
	for(d=0;d<NUMOBJ;d++)
	{
		if(objs[d]==0)
		{
			objs[d]=&obj;
			printf("addobj: Added object at %i\n",d);
			objs[d]->id=d;
			return 1;//we're done
		}
	}
	printf("addobj: failure\n");
	return 0;//FAILURE - we're at the maximum number of objects, if this happens, change NUMOBJ
}

// START VIDEO//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void drawText(SDL_Surface* screen, char* string, int x, int y, int fR, int fG, int fB)
{
	SDL_Color foregroundColor = { fR, fG, fB };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,string, foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
}

void drawTextInt(SDL_Surface* screen, int number, int x, int y, int fR, int fG, int fB)
{
	char tmp_num[16];
	sprintf((char*)tmp_num, "%d", number);
	SDL_Color foregroundColor = { fR, fG, fB };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,tmp_num, foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
}

void drawSprite(SDL_Surface* imageSurface, SDL_Surface* screenSurface, int srcX, int srcY, int dstX, int dstY, int width, int height)
{
	SDL_Rect srcRect;
	srcRect.x = srcX;
	srcRect.y = srcY;
	srcRect.w = width;
	srcRect.h = height;

	SDL_Rect dstRect;
	dstRect.x = dstX;
	dstRect.y = dstY;
	dstRect.w = width;
	dstRect.h = height;

	SDL_BlitSurface(imageSurface, &srcRect, screenSurface, &dstRect);
}
int zbuf[320][240];
int boxA(SDL_Surface * surface, int x1, int y1, int x2, int y2, Uint32 color, Uint8 alpha)
{
    Uint32 Rmask = surface->format->Rmask, Gmask =
	surface->format->Gmask, Bmask = surface->format->Bmask, Amask = surface->format->Amask;
    Uint32 R, G, B, A = 0;
    int x, y;

    	/* Probably 15-bpp or 16-bpp */
	    Uint16 *row, *pixel;
	    Uint32 dR = (color & Rmask), dG = (color & Gmask), dB = (color & Bmask), dA = (color & Amask);

	    for (y = y1; y <= y2; y++) {
		row = (Uint16 *) surface->pixels + y * surface->pitch / 2;
		for (x = x1; x <= x2; x++) {
		    pixel = row + x;

		    R = ((*pixel & Rmask) + ((dR - (*pixel & Rmask)) * alpha >> 8)) & Rmask;
		    G = ((*pixel & Gmask) + ((dG - (*pixel & Gmask)) * alpha >> 8)) & Gmask;
		    B = ((*pixel & Bmask) + ((dB - (*pixel & Bmask)) * alpha >> 8)) & Bmask;
		    //if (Amask)
			A = ((*pixel & Amask) + ((dA - (*pixel & Amask)) * alpha >> 8)) & Amask;

		    *pixel = R | G | B | A;
		}
	    }


    return (0);
}
int boxA(SDL_Surface * surface, int x1, int y1, int x2, int y2, Uint32 color)
{
	SDL_Rect r;
	r.x=x1;
	r.y=y1;
	r.w=x2-x1;
	r.h=y2-y1;
	SDL_FillRect(screen,&r,color);
}

int hlineColor(SDL_Surface * dst, int x1, int x2, int y, Uint32 color)
{
	boxA(dst,x1,y,x2,y+1,color);
}
int hlineTex(SDL_Surface * dst, int x1, int x2, int y, texture *tex)
{
	SDL_Rect r;
	r.x=x1;
	r.y=y;
	r.w=r.h=1;
	int ta,rx=(tex->wm)/(x2-x1);
	int ta,rx=(tex->wm)/(x2-x1);
	for(ta=x1;ta<x2;ta++)
	{
		r.x=ta;
		SDL_FillRect(dst,&r,tex->sample_nearest(ta,y));
	}
}
int hlineColor(SDL_Surface * dst, int x1, int x2, int y, Uint32 color,int a)
{
	boxA(dst,x1,y,x2,y+1,color,a);
}

int gfxPrimitivesCompareInt(const void *a, const void *b);
static int *gfxPrimitivesPolyInts = NULL;
static int gfxPrimitivesPolyAllocated = 0;
int drawpoly(SDL_Surface * dst, const int * vx, const int * vy, int n, Uint32 color)
{
    int result;
    int i;
    int y, xa, xb;
    int miny, maxy;
    int x1, y1;
    int x2, y2;
    int ind1, ind2;
    int ints;
    /*
     * Sanity check 
     */
    if (n < 3) {
	return -1;
    }

    /*
     * Allocate temp array, only grow array 
     */
    if (!gfxPrimitivesPolyAllocated) {
	gfxPrimitivesPolyInts = (int *) malloc(sizeof(int) * n);
	gfxPrimitivesPolyAllocated = n;
    } else {
	if (gfxPrimitivesPolyAllocated < n) {
	    gfxPrimitivesPolyInts = (int *) realloc(gfxPrimitivesPolyInts, sizeof(int) * n);
	    gfxPrimitivesPolyAllocated = n;
	}
    }

    /*
     * Determine Y maxima 
     */
    miny = vy[0];
    maxy = vy[0];
    for (i = 1; (i < n); i++) {
	if (vy[i] < miny) {
	    miny = vy[i];
	} else if (vy[i] > maxy) {
	    maxy = vy[i];
	}
    }

    /*
     * Draw, scanning y 
     */
    result = 0;
    for (y = miny; (y <= maxy); y++) {
	ints = 0;
	for (i = 0; (i < n); i++) {
	    if (!i) {
		ind1 = n - 1;
		ind2 = 0;
	    } else {
		ind1 = i - 1;
		ind2 = i;
	    }
	    y1 = vy[ind1];
	    y2 = vy[ind2];
	    if (y1 < y2) {
		x1 = vx[ind1];
		x2 = vx[ind2];
	    } else if (y1 > y2) {
		y2 = vy[ind1];
		y1 = vy[ind2];
		x2 = vx[ind1];
		x1 = vx[ind2];
	    } else {
		continue;
	    }
	    if ( ((y >= y1) && (y < y2)) || ((y == maxy) && (y > y1) && (y <= y2)) ) {
		gfxPrimitivesPolyInts[ints++] = ((65536 * (y - y1)) / (y2 - y1)) * (x2 - x1) + (65536 * x1);
	    } 
	    
	}
	
	qsort(gfxPrimitivesPolyInts, ints, sizeof(int), gfxPrimitivesCompareInt);

	for (i = 0; (i < ints); i += 2) {
	    xa = gfxPrimitivesPolyInts[i] + 1;
	    xa = (xa >> 16) + ((xa & 32768) >> 15);
	    xb = gfxPrimitivesPolyInts[i+1] - 1;
	    xb = (xb >> 16) + ((xb & 32768) >> 15);
	    result |= hlineColor(dst, xa, xb, y, color);
	}
    }

    return (result);
}
int drawpoly(SDL_Surface * dst, const int * vx, const int * vy, int n,texture *tex)
{
    int result;
    int i;
    int y, xa, xb;
    int miny, maxy;
    int x1, y1;
    int x2, y2;
    int ind1, ind2;
    int ints;
    /*
     * Sanity check 
     */
    if (n < 3) {
	return -1;
    }

    /*
     * Allocate temp array, only grow array 
     */
    if (!gfxPrimitivesPolyAllocated) {
	gfxPrimitivesPolyInts = (int *) malloc(sizeof(int) * n);
	gfxPrimitivesPolyAllocated = n;
    } else {
	if (gfxPrimitivesPolyAllocated < n) {
	    gfxPrimitivesPolyInts = (int *) realloc(gfxPrimitivesPolyInts, sizeof(int) * n);
	    gfxPrimitivesPolyAllocated = n;
	}
    }

    /*
     * Determine Y maxima 
     */
    miny = vy[0];
    maxy = vy[0];
    for (i = 1; (i < n); i++) {
	if (vy[i] < miny) {
	    miny = vy[i];
	} else if (vy[i] > maxy) {
	    maxy = vy[i];
	}
    }

    /*
     * Draw, scanning y 
     */
    result = 0;
    for (y = miny; (y <= maxy); y++) {
	ints = 0;
	for (i = 0; (i < n); i++) {
	    if (!i) {
		ind1 = n - 1;
		ind2 = 0;
	    } else {
		ind1 = i - 1;
		ind2 = i;
	    }
	    y1 = vy[ind1];
	    y2 = vy[ind2];
	    if (y1 < y2) {
		x1 = vx[ind1];
		x2 = vx[ind2];
	    } else if (y1 > y2) {
		y2 = vy[ind1];
		y1 = vy[ind2];
		x2 = vx[ind1];
		x1 = vx[ind2];
	    } else {
		continue;
	    }
	    if ( ((y >= y1) && (y < y2)) || ((y == maxy) && (y > y1) && (y <= y2)) ) {
		gfxPrimitivesPolyInts[ints++] = ((65536 * (y - y1)) / (y2 - y1)) * (x2 - x1) + (65536 * x1);
	    } 
	    
	}
	
	qsort(gfxPrimitivesPolyInts, ints, sizeof(int), gfxPrimitivesCompareInt);

	for (i = 0; (i < ints); i += 2) {
	    xa = gfxPrimitivesPolyInts[i] + 1;
	    xa = (xa >> 16) + ((xa & 32768) >> 15);
	    xb = gfxPrimitivesPolyInts[i+1] - 1;
	    xb = (xb >> 16) + ((xb & 32768) >> 15);
	    result |= hlineTex(dst, xa, xb, y, tex);
	}
    }

    return (result);
}
int drawpoly(SDL_Surface * dst, const int * vx, const int * vy, int n, Uint32 color,int a)
{
    int result;
    int i;
    int y, xa, xb;
    int miny, maxy;
    int x1, y1;
    int x2, y2;
    int ind1, ind2;
    int ints;

    /*
     * Sanity check 
     */
    if (n < 3) {
	return -1;
    }

    /*
     * Allocate temp array, only grow array 
     */
    if (!gfxPrimitivesPolyAllocated) {
	gfxPrimitivesPolyInts = (int *) malloc(sizeof(int) * n);
	gfxPrimitivesPolyAllocated = n;
    } else {
	if (gfxPrimitivesPolyAllocated < n) {
	    gfxPrimitivesPolyInts = (int *) realloc(gfxPrimitivesPolyInts, sizeof(int) * n);
	    gfxPrimitivesPolyAllocated = n;
	}
    }

    /*
     * Determine Y maxima 
     */
    miny = vy[0];
    maxy = vy[0];
    for (i = 1; (i < n); i++) {
	if (vy[i] < miny) {
	    miny = vy[i];
	} else if (vy[i] > maxy) {
	    maxy = vy[i];
	}
    }

    /*
     * Draw, scanning y 
     */
    result = 0;
    for (y = miny; (y <= maxy); y++) {
	ints = 0;
	for (i = 0; (i < n); i++) {
	    if (!i) {
		ind1 = n - 1;
		ind2 = 0;
	    } else {
		ind1 = i - 1;
		ind2 = i;
	    }
	    y1 = vy[ind1];
	    y2 = vy[ind2];
	    if (y1 < y2) {
		x1 = vx[ind1];
		x2 = vx[ind2];
	    } else if (y1 > y2) {
		y2 = vy[ind1];
		y1 = vy[ind2];
		x2 = vx[ind1];
		x1 = vx[ind2];
	    } else {
		continue;
	    }
	    if ( ((y >= y1) && (y < y2)) || ((y == maxy) && (y > y1) && (y <= y2)) ) {
		gfxPrimitivesPolyInts[ints++] = ((65536 * (y - y1)) / (y2 - y1)) * (x2 - x1) + (65536 * x1);
	    } 
	    
	}
	
	qsort(gfxPrimitivesPolyInts, ints, sizeof(int), gfxPrimitivesCompareInt);

	for (i = 0; (i < ints); i += 2) {
	    xa = gfxPrimitivesPolyInts[i] + 1;
	    xa = (xa >> 16) + ((xa & 32768) >> 15);
	    xb = gfxPrimitivesPolyInts[i+1] - 1;
	    xb = (xb >> 16) + ((xb & 32768) >> 15);
	    result |= hlineColor(dst, xa, xb, y, color,a);
	}
    }

    return (result);
}
#define clip_xmin(surface) surface->clip_rect.x
#define clip_xmax(surface) surface->clip_rect.x+surface->clip_rect.w-1
#define clip_ymin(surface) surface->clip_rect.y
#define clip_ymax(surface) surface->clip_rect.y+surface->clip_rect.h-1
int _putPixelAlpha(SDL_Surface * surface, int x, int y, Uint32 color, Uint8 alpha)
{
    Uint32 Rmask = surface->format->Rmask, Gmask =
	surface->format->Gmask, Bmask = surface->format->Bmask, Amask = surface->format->Amask;
    Uint32 R, G, B, A = 0;

    if (x >= clip_xmin(surface) && x <= clip_xmax(surface)
	&& y >= clip_ymin(surface) && y <= clip_ymax(surface)) {

	switch (surface->format->BytesPerPixel) {
	case 1:{		/* Assuming 8-bpp */
		if (alpha == 255) {
		    *((Uint8 *) surface->pixels + y * surface->pitch + x) = color;
		} else {
		    Uint8 *pixel = (Uint8 *) surface->pixels + y * surface->pitch + x;

		    Uint8 dR = surface->format->palette->colors[*pixel].r;
		    Uint8 dG = surface->format->palette->colors[*pixel].g;
		    Uint8 dB = surface->format->palette->colors[*pixel].b;
		    Uint8 sR = surface->format->palette->colors[color].r;
		    Uint8 sG = surface->format->palette->colors[color].g;
		    Uint8 sB = surface->format->palette->colors[color].b;

		    dR = dR + ((sR - dR) * alpha >> 8);
		    dG = dG + ((sG - dG) * alpha >> 8);
		    dB = dB + ((sB - dB) * alpha >> 8);

		    *pixel = SDL_MapRGB(surface->format, dR, dG, dB);
		}
	    }
	    break;

	case 2:{		/* Probably 15-bpp or 16-bpp */
		if (alpha == 255) {
		    *((Uint16 *) surface->pixels + y * surface->pitch / 2 + x) = color;
		} else {
		    Uint16 *pixel = (Uint16 *) surface->pixels + y * surface->pitch / 2 + x;
		    Uint32 dc = *pixel;

		    R = ((dc & Rmask) + (((color & Rmask) - (dc & Rmask)) * alpha >> 8)) & Rmask;
		    G = ((dc & Gmask) + (((color & Gmask) - (dc & Gmask)) * alpha >> 8)) & Gmask;
		    B = ((dc & Bmask) + (((color & Bmask) - (dc & Bmask)) * alpha >> 8)) & Bmask;
		    if (Amask)
			A = ((dc & Amask) + (((color & Amask) - (dc & Amask)) * alpha >> 8)) & Amask;

		    *pixel = R | G | B | A;
		}
	    }
	    break;

	case 3:{		/* Slow 24-bpp mode, usually not used */
		Uint8 *pix = (Uint8 *) surface->pixels + y * surface->pitch + x * 3;
		Uint8 rshift8 = surface->format->Rshift / 8;
		Uint8 gshift8 = surface->format->Gshift / 8;
		Uint8 bshift8 = surface->format->Bshift / 8;
		Uint8 ashift8 = surface->format->Ashift / 8;


		if (alpha == 255) {
		    *(pix + rshift8) = color >> surface->format->Rshift;
		    *(pix + gshift8) = color >> surface->format->Gshift;
		    *(pix + bshift8) = color >> surface->format->Bshift;
		    *(pix + ashift8) = color >> surface->format->Ashift;
		} else {
		    Uint8 dR, dG, dB, dA = 0;
		    Uint8 sR, sG, sB, sA = 0;

		    pix = (Uint8 *) surface->pixels + y * surface->pitch + x * 3;

		    dR = *((pix) + rshift8);
		    dG = *((pix) + gshift8);
		    dB = *((pix) + bshift8);
		    dA = *((pix) + ashift8);

		    sR = (color >> surface->format->Rshift) & 0xff;
		    sG = (color >> surface->format->Gshift) & 0xff;
		    sB = (color >> surface->format->Bshift) & 0xff;
		    sA = (color >> surface->format->Ashift) & 0xff;

		    dR = dR + ((sR - dR) * alpha >> 8);
		    dG = dG + ((sG - dG) * alpha >> 8);
		    dB = dB + ((sB - dB) * alpha >> 8);
		    dA = dA + ((sA - dA) * alpha >> 8);

		    *((pix) + rshift8) = dR;
		    *((pix) + gshift8) = dG;
		    *((pix) + bshift8) = dB;
		    *((pix) + ashift8) = dA;
		}
	    }
	    break;

	case 4:{		/* Probably 32-bpp */
		if (alpha == 255) {
		    *((Uint32 *) surface->pixels + y * surface->pitch / 4 + x) = color;
		} else {
		    Uint32 Rshift, Gshift, Bshift, Ashift;
		    Uint32 *pixel = (Uint32 *) surface->pixels + y * surface->pitch / 4 + x;
		    Uint32 dc = *pixel;

		    Rshift = surface->format->Rshift;
		    Gshift = surface->format->Gshift;
		    Bshift = surface->format->Bshift;
		    Ashift = surface->format->Ashift;

		    R = ((dc & Rmask) + (((((color & Rmask) - (dc & Rmask)) >> Rshift) * alpha >> 8) << Rshift)) & Rmask;
		    G = ((dc & Gmask) + (((((color & Gmask) - (dc & Gmask)) >> Gshift) * alpha >> 8) << Gshift)) & Gmask;
		    B = ((dc & Bmask) + (((((color & Bmask) - (dc & Bmask)) >> Bshift) * alpha >> 8) << Bshift)) & Bmask;
		    if (Amask)
			A = ((dc & Amask) + (((((color & Amask) - (dc & Amask)) >> Ashift) * alpha >> 8) << Ashift)) & Amask;

		    *pixel = R | G | B | A;
		}
	    }
	    break;
	}
    }

    return (0);
}
int pixelColorNolock(SDL_Surface * dst, int x, int y, Uint32 color)
{
    Uint8 alpha;
    Uint32 mcolor;
    int result = 0;

    /*
     * Setup color 
     */
    alpha = color & 0x000000ff;
    mcolor =
	SDL_MapRGBA(dst->format, (color & 0xff000000) >> 24,
		    (color & 0x00ff0000) >> 16, (color & 0x0000ff00) >> 8, alpha);

    /*
     * Draw 
     */
    result = _putPixelAlpha(dst, x, y, mcolor, alpha);

    return (result);
}
int pixelColor(SDL_Surface * dst, int x, int y, Uint32 color)
{
    Uint8 alpha;
    Uint32 mcolor;
    int result = 0;

    /*
     * Lock the surface 
     */
    if (SDL_MUSTLOCK(dst)) {
	if (SDL_LockSurface(dst) < 0) {
	    return (-1);
	}
    }

    /*
     * Setup color 
     */
    alpha = color & 0x000000ff;
    mcolor =
	SDL_MapRGBA(dst->format, (color & 0xff000000) >> 24,
		    (color & 0x00ff0000) >> 16, (color & 0x0000ff00) >> 8, alpha);

    /*
     * Draw 
     */
    result = _putPixelAlpha(dst, x, y, mcolor, alpha);

    /*
     * Unlock the surface 
     */
    if (SDL_MUSTLOCK(dst)) {
	SDL_UnlockSurface(dst);
    }

    return (result);
}

#define CLIP_LEFT_EDGE   0x1
#define CLIP_RIGHT_EDGE  0x2
#define CLIP_BOTTOM_EDGE 0x4
#define CLIP_TOP_EDGE    0x8
#define CLIP_INSIDE(a)   (!a)
#define CLIP_REJECT(a,b) (a&b)
#define CLIP_ACCEPT(a,b) (!(a|b))
#define ABS(a) (((a)<0) ? -(a) : (a))
static int clipEncode(int x, int y, int left, int top, int right, int bottom)
{
    int code = 0;

    if (x < left) {
	code |= CLIP_LEFT_EDGE;
    } else if (x > right) {
	code |= CLIP_RIGHT_EDGE;
    }
    if (y < top) {
	code |= CLIP_TOP_EDGE;
    } else if (y > bottom) {
	code |= CLIP_BOTTOM_EDGE;
    }
    return code;
}

int VLineAlpha(SDL_Surface * dst, int x, int y1, int y2, Uint32 color)
{
    return (boxA(dst, x, y1, x, y2, color));
}

int vlineColor(SDL_Surface * dst, int x, int y1, int y2, Uint32 color)
{
    int left, right, top, bottom;
    Uint8 *pixel, *pixellast;
    int dy;
    int pixx, pixy;
    int h;
    int ytmp;
    int result = -1;
    Uint8 *colorptr;

    /*
     * Get clipping boundary 
     */
    left = dst->clip_rect.x;
    right = dst->clip_rect.x + dst->clip_rect.w - 1;
    top = dst->clip_rect.y;
    bottom = dst->clip_rect.y + dst->clip_rect.h - 1;

    /*
     * Check visibility of vline 
     */
    if ((x<left) || (x>right)) {
     return (0);
    }
    if ((y1<top) && (y2<top)) {
     return(0);
    }
    if ((y1>bottom) && (y2>bottom)) {
     return(0);
    }

    /*
     * Clip y 
     */
    if (y1 < top) {
	y1 = top;
    }
    if (y2 > bottom) {
	y2 = bottom;
    }

    /*
     * Swap y1, y2 if required 
     */
    if (y1 > y2) {
	ytmp = y1;
	y1 = y2;
	y2 = ytmp;
    }

    /*
     * Calculate height 
     */
    h = y2 - y1;

    /*
     * Sanity check on height 
     */
    if (h < 0) {
	return (0);
    }

    /*
     * Alpha check 
     */
    if ((color & 255) == 255) {

	/*
	 * No alpha-blending required 
	 */

	/*
	 * Setup color 
	 */
	colorptr = (Uint8 *) & color;
	if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {
	    color = SDL_MapRGBA(dst->format, colorptr[0], colorptr[1], colorptr[2], colorptr[3]);
	} else {
	    color = SDL_MapRGBA(dst->format, colorptr[3], colorptr[2], colorptr[1], colorptr[0]);
	}

	/*
	 * Lock surface 
	 */
	SDL_LockSurface(dst);

	/*
	 * More variable setup 
	 */
	dy = h;
	pixx = dst->format->BytesPerPixel;
	pixy = dst->pitch;
	pixel = ((Uint8 *) dst->pixels) + pixx * (int) x + pixy * (int) y1;
	pixellast = pixel + pixy * dy;

	/*
	 * Draw 
	 */
	switch (dst->format->BytesPerPixel) {
	case 1:
	    for (; pixel <= pixellast; pixel += pixy) {
		*(Uint8 *) pixel = color;
	    }
	    break;
	case 2:
	    for (; pixel <= pixellast; pixel += pixy) {
		*(Uint16 *) pixel = color;
	    }
	    break;
	case 3:
	    for (; pixel <= pixellast; pixel += pixy) {
		if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {
		    pixel[0] = (color >> 16) & 0xff;
		    pixel[1] = (color >> 8) & 0xff;
		    pixel[2] = color & 0xff;
		} else {
		    pixel[0] = color & 0xff;
		    pixel[1] = (color >> 8) & 0xff;
		    pixel[2] = (color >> 16) & 0xff;
		}
	    }
	    break;
	default:		/* case 4 */
	    for (; pixel <= pixellast; pixel += pixy) {
		*(Uint32 *) pixel = color;
	    }
	    break;
	}

	/*
	 * Unlock surface 
	 */
	SDL_UnlockSurface(dst);

	/*
	 * Set result code 
	 */
	result = 0;

    } else {

	/*
	 * Alpha blending blit 
	 */

	result = VLineAlpha(dst, x, y1, y1 + h, color);

    }

    return (result);
}
static int clipLine(SDL_Surface * dst, int * x1, int * y1, int * x2, int * y2)
{
    int left, right, top, bottom;
    int code1, code2;
    int draw = 0;
    int swaptmp;
    float m;

    /*
     * Get clipping boundary 
     */
    left = dst->clip_rect.x;
    right = dst->clip_rect.x + dst->clip_rect.w - 1;
    top = dst->clip_rect.y;
    bottom = dst->clip_rect.y + dst->clip_rect.h - 1;

    while (1) {
	code1 = clipEncode(*x1, *y1, left, top, right, bottom);
	code2 = clipEncode(*x2, *y2, left, top, right, bottom);
	if (CLIP_ACCEPT(code1, code2)) {
	    draw = 1;
	    break;
	} else if (CLIP_REJECT(code1, code2))
	    break;
	else {
	    if (CLIP_INSIDE(code1)) {
		swaptmp = *x2;
		*x2 = *x1;
		*x1 = swaptmp;
		swaptmp = *y2;
		*y2 = *y1;
		*y1 = swaptmp;
		swaptmp = code2;
		code2 = code1;
		code1 = swaptmp;
	    }
	    if (*x2 != *x1) {
		m = (*y2 - *y1) / (float) (*x2 - *x1);
	    } else {
		m = 1.0f;
	    }
	    if (code1 & CLIP_LEFT_EDGE) {
		*y1 += (int) ((left - *x1) * m);
		*x1 = left;
	    } else if (code1 & CLIP_RIGHT_EDGE) {
		*y1 += (int) ((right - *x1) * m);
		*x1 = right;
	    } else if (code1 & CLIP_BOTTOM_EDGE) {
		if (*x2 != *x1) {
		    *x1 += (int) ((bottom - *y1) / m);
		}
		*y1 = bottom;
	    } else if (code1 & CLIP_TOP_EDGE) {
		if (*x2 != *x1) {
		    *x1 += (int) ((top - *y1) / m);
		}
		*y1 = top;
	    }
	}
    }

    return draw;
}
int lineColor(SDL_Surface * dst, int x1, int y1, int x2, int y2, Uint32 color)
{
    int pixx, pixy;
    int x, y;
    int dx, dy;
    int ax, ay;
    int sx, sy;
    int swaptmp;
    Uint8 *pixel;
    Uint8 *colorptr;

    /*
     * Clip line and test if we have to draw 
     */
    if (!(clipLine(dst, &x1, &y1, &x2, &y2))) {
	return (0);
    }

    /*
     * Test for special cases of straight lines or single point 
     */
    if (x1 == x2) {
	if (y1 < y2) {
	    return (vlineColor(dst, x1, y1, y2, color));
	} else if (y1 > y2) {
	    return (vlineColor(dst, x1, y2, y1, color));
	} else {
	    return (pixelColor(dst, x1, y1, color));
	}
    }
    if (y1 == y2) {
	if (x1 < x2) {
	    return (hlineColor(dst, x1, x2, y1, color));
	} else if (x1 > x2) {
	    return (hlineColor(dst, x2, x1, y1, color));
	}
    }

    /*
     * Variable setup 
     */
    dx = x2 - x1;
    dy = y2 - y1;
    sx = (dx >= 0) ? 1 : -1;
    sy = (dy >= 0) ? 1 : -1;

    /* Lock surface */
    if (SDL_MUSTLOCK(dst)) {
	if (SDL_LockSurface(dst) < 0) {
	    return (-1);
	}
    }

    /*
     * Check for alpha blending 
     */
    if ((color & 255) == 255) {

	/*
	 * No alpha blending - use fast pixel routines 
	 */

	/*
	 * Setup color 
	 */
	colorptr = (Uint8 *) & color;
	if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {
	    color = SDL_MapRGBA(dst->format, colorptr[0], colorptr[1], colorptr[2], colorptr[3]);
	} else {
	    color = SDL_MapRGBA(dst->format, colorptr[3], colorptr[2], colorptr[1], colorptr[0]);
	}

	/*
	 * More variable setup 
	 */
	dx = sx * dx + 1;
	dy = sy * dy + 1;
	pixx = dst->format->BytesPerPixel;
	pixy = dst->pitch;
	pixel = ((Uint8 *) dst->pixels) + pixx * (int) x1 + pixy * (int) y1;
	pixx *= sx;
	pixy *= sy;
	if (dx < dy) {
	    swaptmp = dx;
	    dx = dy;
	    dy = swaptmp;
	    swaptmp = pixx;
	    pixx = pixy;
	    pixy = swaptmp;
	}

	/*
	 * Draw 
	 */
	x = 0;
	y = 0;
	switch (dst->format->BytesPerPixel) {
	case 1:
	    for (; x < dx; x++, pixel += pixx) {
		*pixel = color;
		y += dy;
		if (y >= dx) {
		    y -= dx;
		    pixel += pixy;
		}
	    }
	    break;
	case 2:
	    for (; x < dx; x++, pixel += pixx) {
		*(Uint16 *) pixel = color;
		y += dy;
		if (y >= dx) {
		    y -= dx;
		    pixel += pixy;
		}
	    }
	    break;
	case 3:
	    for (; x < dx; x++, pixel += pixx) {
		if (SDL_BYTEORDER == SDL_BIG_ENDIAN) {
		    pixel[0] = (color >> 16) & 0xff;
		    pixel[1] = (color >> 8) & 0xff;
		    pixel[2] = color & 0xff;
		} else {
		    pixel[0] = color & 0xff;
		    pixel[1] = (color >> 8) & 0xff;
		    pixel[2] = (color >> 16) & 0xff;
		}
		y += dy;
		if (y >= dx) {
		    y -= dx;
		    pixel += pixy;
		}
	    }
	    break;
	default:		/* case 4 */
	    for (; x < dx; x++, pixel += pixx) {
		*(Uint32 *) pixel = color;
		y += dy;
		if (y >= dx) {
		    y -= dx;
		    pixel += pixy;
		}
	    }
	    break;
	}

    } else {

	/*
	 * Alpha blending required - use single-pixel blits 
	 */

	ax = ABS(dx) << 1;
	ay = ABS(dy) << 1;
	x = x1;
	y = y1;
	if (ax > ay) {
	    int d = ay - (ax >> 1);

	    while (x != x2) {
		pixelColorNolock (dst, x, y, color);
		if (d > 0 || (d == 0 && sx == 1)) {
		    y += sy;
		    d -= ax;
		}
		x += sx;
		d += ay;
	    }
	} else {
	    int d = ax - (ay >> 1);

	    while (y != y2) {
		pixelColorNolock (dst, x, y, color);
		if (d > 0 || ((d == 0) && (sy == 1))) {
		    x += sx;
		    d -= ay;
		}
		y += sy;
		d += ax;
	    }
	}
	pixelColorNolock (dst, x, y, color);

    }

    /* Unlock surface */
    if (SDL_MUSTLOCK(dst)) {
	SDL_UnlockSurface(dst);
    }

    return (0);
}
int polygonColor(SDL_Surface * dst, const int * vx, const int * vy, int n, Uint32 color)
{
    int result;
    int i;
    const int *x1, *y1, *x2, *y2;

    /*
     * Sanity check 
     */
    if (n < 3) {
	return (-1);
    }

    /*
     * Pointer setup 
     */
    x1 = x2 = vx;
    y1 = y2 = vy;
    x2++;
    y2++;

    /*
     * Draw 
     */
    result = 0;
    for (i = 1; i < n; i++) {
	result |= lineColor(dst, *x1, *y1, *x2, *y2, color);
	x1 = x2;
	y1 = y2;
	x2++;
	y2++;
    }
    result |= lineColor(dst, *x1, *y1, *vx, *vy, color);

    return (result);
}
int gfxPrimitivesCompareInt(const void *a, const void *b)
{
    return (*(const int *) a) - (*(const int *) b);
}

int drawtri(SDL_Surface * srf,int x1,int y1,int x2,int y2,int x3,int y3,int r,int g,int b)
{
	int vx[3]; 
	int vy[3];
	vx[0]=x1;
	vx[1]=x2;
	vx[2]=x3;
	vy[0]=y1;
	vy[1]=y2;
	vy[2]=y3; 
	drawpoly(srf,vx,vy,3,SDL_MapRGB(screen->format,r,g,b));
	polygonColor(srf,vx,vy,3,SDL_MapRGB(screen->format,255,255,255));
}
int drawtri(SDL_Surface * srf,int x1,int y1,int x2,int y2,int x3,int y3,texture *tex)
{
	int vx[3]; 
	int vy[3];
	vx[0]=x1;
	vx[1]=x2;
	vx[2]=x3;
	vy[0]=y1;
	vy[1]=y2;
	vy[2]=y3; 
	drawpoly(srf,vx,vy,3,tex);
	//polygonColor(srf,vx,vy,3,SDL_MapRGB(screen->format,255,255,255));
}
int drawtri(SDL_Surface * srf,int x1,int y1,int x2,int y2,int x3,int y3,int r,int g,int b,int a)
{
	int vx[3]; 
	int vy[3];
	vx[0]=x1;
	vx[1]=x2;
	vx[2]=x3;
	vy[0]=y1;
	vy[1]=y2;
	vy[2]=y3;
	drawpoly(srf,vx,vy,3,SDL_MapRGB(screen->format,r,g,b),a);
}

int vid_init()
{
	SDL_Init(SDL_INIT_VIDEO);
	#ifndef GP2X
	screen=SDL_SetVideoMode(320,240,16,SDL_SWSURFACE);
	SDL_WM_SetCaption( "32D", 0 );	
	#else
	screen=SDL_SetVideoMode(320,240,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
	SDL_ShowCursor(SDL_DISABLE);															// Disable mouse cursor on gp2x
	#endif
	TTF_Init();
	font = TTF_OpenFont("arial.ttf", 12);
	backcolor=SDL_MapRGB(screen->format,0,0,0);
	SDL_FillRect(screen,NULL,backcolor);
}

vertex project(vertex ver)
{
	vertex ret;
	ret.x=((ver.x)*hpc/ver.z)+160;
	ret.y=-((ver.y)*vpc*(Fixed)1.3333333333333333333333333333333/ver.z)+120;
	ret.z=ver.z;
	return ret;
}
class face
{
	public:
	int z;
	int verti[3];
};
typedef int (*qsortfnc)(const void *, const void *);
int compare (const face * a, const face * b)
{
  if(a->z<b->z) return 1;
  if(a->z>b->z) return -1;
  return 0;
}
int vid_update()
{
	SDL_FillRect(screen,NULL,backcolor);
	bool done=0;
	int objat=0;
	int tx[3],ty[3];
	printf("vid_update: ready\n");
	vertex ver[1000];
	vertex tver[1000];
	
	for(i=0;i<objs[objat]->nver;i++)
		tver[i]=project(vertexmulmatrix4x3(objs[objat]->verti[i],objs[objat]->local));
	for(i=0;i<objs[objat]->nfac;i++)
	{
#ifdef TEXTURE
		drawtri(screen,tver[objs[objat]->faces[i][0]].x,tver[objs[objat]->faces[i][0]].y,tver[objs[objat]->faces[i][1]].x,tver[objs[objat]->faces[i][1]].y,tver[objs[objat]->faces[i][2]].x,tver[objs[objat]->faces[i][2]].y,&objs[objat]->tex);
#else
		drawtri(screen,tver[objs[objat]->faces[i][0]].x,tver[objs[objat]->faces[i][0]].y,tver[objs[objat]->faces[i][1]].x,tver[objs[objat]->faces[i][1]].y,tver[objs[objat]->faces[i][2]].x,tver[objs[objat]->faces[i][2]].y,objs[objat]->faces[i][3],objs[objat]->faces[i][4],objs[objat]->faces[i][5]);
#endif
	}
	/*SDL_FillRect(screen,NULL,backcolor);  //BROKEN(I THINK) PAINTER'S ALGORITHIM CODE
	bool done=0;
	int objat=0;
	vertex ver[1000];
	vertex tver[1000];
	face faces[1500];	
	for(i=0;i<objs[objat]->nver;i++)
		ver[i]=project(vertexmulmatrix4x3(objs[objat]->verti[i],objs[objat]->local));
	for(i=0;i<objs[objat]->nfac;i++)
	{
		if(objs[objat]->verti[objs[objat]->faces[i][0]].z>=objs[objat]->verti[objs[objat]->faces[i][1]].z && objs[objat]->verti[objs[objat]->faces[i][0]].z>=objs[objat]->verti[objs[objat]->faces[i][2]].z)
			faces[i].z=objs[objat]->verti[objs[objat]->faces[i][0]].z;
		else
		if(objs[objat]->verti[objs[objat]->faces[i][1]].z>=objs[objat]->verti[objs[objat]->faces[i][0]].z && objs[objat]->verti[objs[objat]->faces[i][1]].z>=objs[objat]->verti[objs[objat]->faces[i][2]].z)
			faces[i].z=objs[objat]->verti[objs[objat]->faces[i][1]].z;
		else
		if(objs[objat]->verti[objs[objat]->faces[i][2]].z>=objs[objat]->verti[objs[objat]->faces[i][1]].z && objs[objat]->verti[objs[objat]->faces[i][2]].z>=objs[objat]->verti[objs[objat]->faces[i][0]].z)
			faces[i].z=objs[objat]->verti[objs[objat]->faces[i][2]].z;
		faces[i].verti[0]=objs[objat]->faces[i][0];
		faces[i].verti[1]=objs[objat]->faces[i][1];
		faces[i].verti[2]=objs[objat]->faces[i][2];
		printf("vid_update: z=%i\n",faces[i].z);
	}
	qsort (faces,objs[objat]->nfac, sizeof(face), (qsortfnc)compare);
	for(i=0;i<objs[objat]->nfac;i++)
	{
		printf("vid_update: z2=%i\n",faces[i].z);
		drawtri(screen,ver[faces[i].verti[0]].x,ver[faces[i].verti[0]].y,ver[faces[i].verti[1]].x,ver[faces[i].verti[1]].y,ver[faces[i].verti[2]].x,ver[faces[i].verti[2]].y,objs[objat]->faces[i][3],objs[objat]->faces[i][4],objs[objat]->faces[i][5]);
	}*/
}

// END VIDEO//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int inputwait()
{
bool quit=0;
SDL_Event ev;
while(!quit)
      while(SDL_PollEvent(&ev))
     {
       switch(ev.type)
       {
         case SDL_KEYDOWN:
		 quit=1;
		 break;
		 }
		 }
  }
int main(int argc, char **argv)
{
	vid_init();
	for(i=0;i<360;i++)
	{
		fcos[i]=(Fixed)cos(i*PI/180);
		fsin[i]=(Fixed)sin(i*PI/180);
		ftan[i]=(Fixed)tan(i*PI/180);
	}
	hpc=(Fixed)160/ftan(30);
	vpc=(Fixed)120/ftan(30);
	printf("main: hpc=%d,vpc=%d\n",(double)hpc,(double)vpc);
	aspect=1;
	cube Cube;	
	addobj(Cube);
	Cube.MoveAlongZ(40);
	//Cube.RotateAroundX(90);
	
	printf("main: starting\n");
	vid_update();
	SDL_Flip(screen);
	SDL_Event ev;
	//Cube.RotateAroundZ(450);
	unsigned zm,ym,xm;
	int at;
	bool quit=0;
	int start;
struct timeval tv;
gettimeofday(&tv,NULL);
start=tv.tv_sec;
	int totalfps=0;
while(!quit)
{
#ifndef GP2X
      while(SDL_PollEvent(&ev))
     {
       switch(ev.type)
       {
         case SDL_KEYDOWN:
		 switch(ev.key.keysym.sym)
		 {
			case SDLK_UP:
			 Cube.RotateAroundX(5);
			break;
			case SDLK_DOWN:
			 Cube.RotateAroundX(365);
			break;
			case SDLK_RIGHT:
			 Cube.RotateAroundY(5);
			break;
			case SDLK_LEFT:
			 Cube.RotateAroundY(365);
			break;
			case SDLK_o:
			 Cube.RotateAroundZ(5);
			break;
			case SDLK_p:
			 Cube.RotateAroundZ(365);
			break;
			case SDLK_w:
			Cube.MoveAlongY(5);
			break;
			case SDLK_s:
			Cube.MoveAlongY(5);
			break;
			case SDLK_a:
			Cube.MoveAlongX(-5);
			break;
			case SDLK_d:
			Cube.MoveAlongX(5);
			break;
			case SDLK_r:
			Cube.MoveAlongZ(5);
			break;
			case SDLK_f:
			Cube.MoveAlongZ(-5);
			break;
			case SDLK_ESCAPE:
			quit=1;
			break;
			
		}
		 break;
		 case SDL_KEYUP:
		 switch(ev.key.keysym.sym)
		 {
			case SDLK_UP:
			xm=0;
			break;
			case SDLK_DOWN:
			xm=0;
			break;
			case SDLK_RIGHT:
			ym=0;
			break;
			case SDLK_LEFT:
			ym=0;
			break;
			case SDLK_o:
			zm=0;
			break;
			case SDLK_p:
			zm=0;
			break;
			
		}
		 break;
		 }
		 }
		 #endif
		//  Cube.RotateAroundZ(4);
	//	  Cube.RotateAroundY(1);
		//  Cube.RotateAroundX(4);
		  gettimeofday(&tv,NULL);
		  at++;
		 /* if(at%1000==0)
		  {
			
			printf("main: fps=%i\n",at/(tv.tv_sec-start));
		}*/
	//	 Cube.RotateAroundZ(zm);
	//	 Cube.RotateAroundY(ym);
	//	 Cube.RotateAroundX(xm);
		 	vid_update();
			drawTextInt(screen,at/(tv.tv_sec -start+1),0,0,255,255,255);
	SDL_Flip(screen);
//	SDL_Delay(75);
		 }
	SDL_Quit();
}
