//#define TEX
#ifndef GP2X
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_framerate.h>
#include <SDL/SDL_gfxPrimitives.h>
#define in1 SDL_KEYDOWN
#define in2 ev.key.keysym.sym
#define in3 SDL_KEYUP

#define GP2X_BUTTON_UP              SDLK_UP
#define GP2X_BUTTON_DOWN            SDLK_DOWN
#define GP2X_BUTTON_LEFT            SDLK_LEFT
#define GP2X_BUTTON_RIGHT           SDLK_RIGHT
#define GP2X_BUTTON_UPLEFT          (1)
#define GP2X_BUTTON_UPRIGHT         (7)
#define GP2X_BUTTON_DOWNLEFT        (3)
#define GP2X_BUTTON_DOWNRIGHT       (5)
#define GP2X_BUTTON_CLICK           SDLK_4
#define GP2X_BUTTON_A               SDLK_a
#define GP2X_BUTTON_B               SDLK_d
#define GP2X_BUTTON_X               SDLK_s
#define GP2X_BUTTON_Y               SDLK_w
#define GP2X_BUTTON_L               SDLK_z
#define GP2X_BUTTON_R               SDLK_x
#define GP2X_BUTTON_START           SDLK_ESCAPE
#define GP2X_BUTTON_SELECT          SDLK_RSHIFT
#define GP2X_BUTTON_VOLUP           SDLK_r
#define GP2X_BUTTON_VOLDOWN         SDLK_f
#else
#include "SDL.h"
#include "SDL_gfxPrimitives.h"
#include "SDL_rotoZoom.h"
#include "SDL_framerate.h"
#include "SDL_ttf.h"
#include "SDL_mixer.h"
#include "SDL_image.h"
#include "SDL_joystick.h"
#include <sys/mman.h>
#include <sys/ioctl.h>
#define in1 SDL_JOYBUTTONDOWN
#define in3 SDL_JOYBUTTONUP
#define in2 ev.jbutton.button

#define GP2X_BUTTON_UP              (0)
#define GP2X_BUTTON_DOWN            (4)
#define GP2X_BUTTON_LEFT            (2)
#define GP2X_BUTTON_RIGHT           (6)
#define GP2X_BUTTON_UPLEFT          (1)
#define GP2X_BUTTON_UPRIGHT         (7)
#define GP2X_BUTTON_DOWNLEFT        (3)
#define GP2X_BUTTON_DOWNRIGHT       (5)
#define GP2X_BUTTON_CLICK           (18)
#define GP2X_BUTTON_A               (12)
#define GP2X_BUTTON_B               (13)
#define GP2X_BUTTON_X               (14)
#define GP2X_BUTTON_Y               (15)
#define GP2X_BUTTON_L               (11)
#define GP2X_BUTTON_R               (10)
#define GP2X_BUTTON_START           (8)
#define GP2X_BUTTON_SELECT          (9)
#define GP2X_BUTTON_VOLUP           (16)
#define GP2X_BUTTON_VOLDOWN         (17)

#endif
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <sstream>
#include <iostream>
#include <vector>

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <string>
#include <map>
#include "fixed.h"
#define PI 3.1415
#define sgn(x) ((x)>0 ? 1 : ((x)==0 ? 0:(-1)))
FPSmanager FPS;
Fixed fcos[360];
Fixed fsin[360];
Fixed ftan[360];
Fixed hpc,vpc;
SDL_Surface* screen;
TTF_Font* font;
Fixed divi[4000];
class vec
{
	public:
	Fixed x,y,z;
	vec(Fixed X,Fixed Y,Fixed Z)
	{
		x=X;
		y=Y;
		z=Z;
	}
	vec()
	{
		x=y=z=0;
	}		
vec cross( const vec &b ) const
{
vec result;

   result.x = y* b.z -z*b.y;
   result.y = z* b.x  -  x* b.z ;
   result.z = x* b.y  -  y* b.x;

   return result;
}
//cube: c
//car: 445
Fixed dot( const vec &b )
{
   return x*b.x+y*b.y+z*b.z;
}
Fixed magnitude( void )
{
float f;
   f  = ((float)x*(float)x+(float)y*(float)y+(float)z*(float)z);
   printf("Mangitude: %f %f,%f,%f\n",(float)f,(float)x,(float)y,(float)z);
   return ((Fixed) ( sqrt( f ) ) );
}

int magnitudesquared( void )
{
  return (int) (  ( z* z )
                          + ( y* y )
                          + ( z*  z ) );
}
void normalize( void )
{
Fixed Magnitude = magnitude();
printf("Normalize: magnitude: %i  %f,%f,%i\n",(int)Magnitude,(float)x,(float)y,(float)z);
   if(Magnitude!=0)
   {
   x =  x/ Magnitude ;
   y =( y/ Magnitude );
   z =( z/ Magnitude );
   }
		else
		{
			x=y=z=0;
		}
}
	vec operator -(vec& a)
	{ 
		return vec(x-a.x,y-a.y,z-a.z); 
	}	
	vec operator +(vec& a)
	{ 
		return vec(x+a.x,y+a.y,z+a.z); 
	}	

};
class Face
{
	public:
	int p1,p2,p3;
	int r,g,b;
	vec t[2];
	vec norm;
	int constant;
	Face()
	{
		p1=p2=p3=0;
	}
};
class Object
{
	public:
	vec pos;
	vec rot;
	std::vector<vec> verti;
	std::vector<Face> faces;
	int nver,nfac;
	void loadOBJ(const char *filename)  // Loads a Wavefront .OBJ 3D model from filename NOTE: You must add a line with just ! at the end of your file
	{
		verti.resize(0);
		faces.resize(0);
		FILE *fp;
		fp=fopen(filename,"r");
		bool in=1;
		int vat=0,fat=0,vtt=0;//what # vertice and face we're on
		vec ver;
		Face fac;
		while (in) {
			char cmd[99];
			fscanf(fp,"%s ",&cmd);	
			printf("Command: %s\n",cmd);
			if (cmd[0] == '#')
			{		
				printf("c#\n");
				fscanf(fp,"\n");
				continue;
			}
			else if (cmd == "v " || cmd[0] == 'v') {
				printf("cv\n");
				float x,y,z;
				if(fscanf(fp,"%f %f %f\n",&x,&y,&z))
				{
					ver.x=x;
					ver.y=y;
					ver.z=z;
					verti.push_back(ver);
					printf("loadOBJ: %f %f %f\n",x,y,z);
					vat++;
				}
			} else if (cmd == "vn") {
			} else if (cmd == "cr") {
			} else if (cmd == "t" || cmd[0]=='t') {	
			} else if (cmd == "f " || (cmd[0] == 'f')) {
				printf("cf\n");
				int a,b,c;
				if(fscanf(fp,"%i %i %i \n",&a,&b,&c))
				{
					fac.p1=a-1;
					fac.p2=b-1;
					fac.p3=c-1;
					faces.push_back(fac);
					printf("loadOBJ: %i %i %i\n",a,b,c);
					fat++;
				}
			} else if (cmd == "g") {
				fscanf(fp,"%s\n",cmd);
			} else if (cmd == "! " || cmd[0] == '!') {
				printf("c!\n");
				in=0;
			} else fscanf(fp,"\n");
		}
		nver=vat;
		nfac=fat;
		printf("loadOBJ: %i faces and %i verti\n",nfac,nver);
		fclose(fp);
		vec s1,s2;
		int i;
		for(i=0;i<nfac;i++)
		{
			s1=vec(verti[faces[i].p2].x-verti[faces[i].p1].x,verti[faces[i].p2].y-verti[faces[i].p1].y,verti[faces[i].p2].z-verti[faces[i].p1].z);
			s2=vec(verti[faces[i].p3].x-verti[faces[i].p2].x,verti[faces[i].p3].y-verti[faces[i].p2].y,verti[faces[i].p3].z-verti[faces[i].p2].z);
			printf("loadOBJ: sides %f,%f,%f\n",(float)s1.x,(float)s1.y,(float)s1.z);
			printf("loadOBJ: sides %f,%f,%f\n",(float)s2.x,(float)s2.y,(float)s2.z);
			faces[i].norm=s1.cross(s2);
			printf("loadOBJ: crossed %f,%f,%f\n",(float)faces[i].norm.x,(float)faces[i].norm.y,(float)faces[i].norm.z);
			faces[i].norm.normalize();
			printf("loadOBJ: normalized  %f,%f,%f\n",(float)faces[i].norm.x,(float)faces[i].norm.y,(float)faces[i].norm.z);
			faces[i].constant=-(int)(faces[i].norm.dot(verti[faces[i].p1]));
			printf("loadOBJ: face %i computed\n",i);
			faces[i].r=255;
			faces[i].g=0;
			faces[i].b=0;
		}		
	}
};

vec light((Fixed)10,(Fixed)10,(Fixed)10);
int drawText(SDL_Surface* screen, char* string, int x, int y, int fR, int fG, int fB)
{
	#ifdef GP2X
	y+=2;
	#endif
	SDL_Color foregroundColor = { fR, fG, fB };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,string, foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
	return 0;
}
int drawTextInt(SDL_Surface* screen, int number, int x, int y, int fR, int fG, int fB)
{
	#ifdef GP2X
	y+=2;
	#endif
	char tmp_num[16];
	sprintf((char*)tmp_num, "%d", number);
	SDL_Color foregroundColor = { fR, fG, fB };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,tmp_num, foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
	return 0;
}
SDL_Surface* zbuffer;
inline void pixel(SDL_Surface* screen,int x,int y,int r,int g,int b)
{
	unsigned short *ptr = (unsigned short*)((Uint8*)(screen->pixels) + (x<<1) + y * screen->pitch);
	*ptr=SDL_MapRGB(screen->format,r,g,b);
}
inline void pixel(SDL_Surface* screen,int x,int y,Uint32 color)
{
	unsigned short *ptr = (unsigned short*)((Uint8*)(screen->pixels) + (x<<1) + y * screen->pitch);
	*ptr=color;
}
inline unsigned short getz(int x,int y)
{
	unsigned short *ptr = (unsigned short*)((Uint8*)(zbuffer->pixels) + (x<<1) + y * zbuffer->pitch);
	return *ptr;
}
inline void zpixel(SDL_Surface* screen,int x,int y,int z,Uint32 color)
{
	if(z<getz(x,y))
	{
		unsigned short *ptr = (unsigned short*)((Uint8*)(screen->pixels) + (x<<1) + y * screen->pitch);
		*ptr=color;
		pixel(zbuffer,x,y,z);
	}
}
inline void hline(SDL_Surface* screen,int x1,int x2,int y,int r,int g,int b)
{
	SDL_Rect r2;
	r2.x=x1;
	r2.y=y;
	r2.w=x2-x1;
	r2.h=1;
	SDL_FillRect(screen,&r2,SDL_MapRGB(screen->format,r,g,b));
}
inline void zhline(SDL_Surface* screen,int x1,int x2,int y,int z,int r,int g,int b)
{
	int x;
	for(x=x1;x<=x2;x++)
		if (z<getz(x,y))
        {
            pixel(zbuffer,x,y,z);
            pixel(screen,x,y,r,g,b);
        }
}
inline void zhline(SDL_Surface* screen,int x1,int x2,int y,int z,Uint32 color)
{
	int x;
	for(x=x1;x<=x2;x++)
		if (z<getz(x,y))
        {
            pixel(zbuffer,x,y,z);
            pixel(screen,x,y,color);
        }
}
inline void vline(SDL_Surface* screen,int y1,int y2,int x,int r,int g,int b)
{
	SDL_Rect r2;
	r2.x=x;
	r2.y=y1;
	r2.w=1;
	r2.h=y2-y1;
	SDL_FillRect(screen,&r2,SDL_MapRGB(screen->format,r,g,b));
}
inline void zline (SDL_Surface* screen,int x1,int y1,int x2,int y2,int z,int r,int g,int b)
{
	int lg_delta, sh_delta, cycle, lg_step, sh_step;
	Uint32 color=SDL_MapRGB(screen->format,r,g,b);	
	lg_delta = x2 - x1;
	sh_delta = y2 - y1;
	lg_step = sgn(lg_delta);
	lg_delta = abs(lg_delta);
	sh_step = sgn(sh_delta);
	sh_delta = abs(sh_delta);
	if (sh_delta < lg_delta) {
		cycle = lg_delta >> 1;
		while (x1 != x2) {
			if(z<getz(x1,y1))
			{
				pixel(screen,x1, y1, color);
				pixel(zbuffer,x1, y1, z);
			}
			cycle += sh_delta;
			if (cycle > lg_delta) {
				cycle -= lg_delta;
				y1 += sh_step;
			}
			x1 += lg_step;
		}
		if(z<getz(x1,y1))
		{
			pixel(screen,x1, y1, color);
			pixel(zbuffer,x1, y1, z);
		}
	}
	cycle = sh_delta >> 1;
	while (y1 != y2) {
		if(z<getz(x1,y1))
		{
			pixel(screen,x1, y1, color);
			pixel(zbuffer,x1, y1, z);
		}
		cycle += lg_delta;
		if (cycle > sh_delta) {
			cycle -= sh_delta;
			x1 += lg_step;
		}
		y1 += sh_step;
	}
	if(z<getz(x1,y1))
	{
		pixel(screen,x1, y1, color);
		pixel(zbuffer,x1, y1,z);
	}
}
inline void line (SDL_Surface* screen,int x1, int y1, int x2, int y2, int r,int g,int b)
{
	int lg_delta, sh_delta, cycle, lg_step, sh_step;
	Uint32 color=SDL_MapRGB(screen->format,r,g,b);	
	lg_delta = x2 - x1;
	sh_delta = y2 - y1;
	lg_step = sgn(lg_delta);
	lg_delta = abs(lg_delta);
	sh_step = sgn(sh_delta);
	sh_delta = abs(sh_delta);
	if (sh_delta < lg_delta) {
		cycle = lg_delta >> 1;
		while (x1 != x2) {
			pixel(screen,x1, y1, color);
			cycle += sh_delta;
			if (cycle > lg_delta) {
				cycle -= lg_delta;
				y1 += sh_step;
			}
			x1 += lg_step;
		}
		pixel(screen,x1, y1, color);
	}
	cycle = sh_delta >> 1;
	while (y1 != y2) {
		pixel(screen,x1, y1, color);
		cycle += lg_delta;
		if (cycle > sh_delta) {
			cycle -= sh_delta;
			x1 += lg_step;
		}
		y1 += sh_step;
	}
	pixel(screen,x1, y1, color);
}
inline void tri(SDL_Surface* screen,vec a,vec b,vec c,int r,int g,int b2)
{
	Fixed x0 =a.x; Fixed y0 =a.y;
Fixed x1 =b.x; Fixed y1 =b.y;
Fixed x2 =c.x; Fixed y2 =c.y;
/*
if ((x0<-8 || x0>320+8 || y0<-8 || y0>240+8) && 
    (x1<-8 || x1>320+8 || y1<-8 || y1>240+8) && 
    (x2<-8 || x2>320+8 || y2<-8 || y2>240+8)) return;*/

//156-187
// ===== Sort =====

Fixed temp;
if (y1<y0)
{
    temp = x0; x0 = x1; x1 = temp;
    temp = y0; y0 = y1; y1 = temp;
}
if (y2<y0)
{
    temp = x0; x0 = x2; x2 = temp;
    temp = y0; y0 = y2; y2 = temp;
}
if (y2<y1)
{
    temp = x1; x1 = x2; x2 = temp;
    temp = y1; y1 = y2; y2 = temp;
}

// ===== Fixederpolation variables =====

//Fixed n, fp = 8;
Fixed lx01=0, lx12=0, lx02=0;

Fixed dx01 = x1 - x0;
Fixed dy01 = y1 - y0;

    if (dy01!=0)
        lx01 = ((dx01)/dy01);

Fixed dx12 = x2 - x1;
Fixed dy12 = y2 - y1;

    if (dy12!=0)
        lx12 = ((dx12)/dy12);

Fixed dx02 = x2 - x0;
Fixed dy02 = y2 - y0;

    if (dy02!=0)
        lx02 = ((dx02)/dy02);

Fixed x, y;

Fixed x01 = x0;
Fixed x02 = x01;

int sx1, sx2;
    for (y = y0; y<y1; y+=1)
    {
        sx1 = x01;
        sx2 = x02;
        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
        }
		hline(screen,sx1,sx2,y,r,g,b2);
        x01+=lx01;
        x02+=lx02;
    }
    x01 = x1;
    for (y = y1; y<y2; y+=1)
    {
        sx1 = x01;
        sx2 = x02;
        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
        }
		hline(screen,sx1,sx2,y,r,g,b2);
        x01+=lx12;
        x02+=lx02;
    }
}

inline void ztri(SDL_Surface* screen,vec a,vec b,vec c,int r,int g,int b2)
{
		Fixed x0 =a.x; Fixed y0 =a.y;
Fixed x1 =b.x; Fixed y1 =b.y;
Fixed x2 =c.x; Fixed y2 =c.y;
Fixed z=(a.z+b.z+c.z)*0.33333333333333333333333333333333;
Uint32 color=SDL_MapRGB(screen->format,r,g,b2);
if ((x0<-8 || x0>320+8 || y0<-8 || y0>240+8) && 
    (x1<-8 || x1>320+8 || y1<-8 || y1>240+8) && 
    (x2<-8 || x2>320+8 || y2<-8 || y2>240+8)) return;

//156-187
// ===== Sort =====

Fixed temp;
if (y1<y0)
{
    temp = x0; x0 = x1; x1 = temp;
    temp = y0; y0 = y1; y1 = temp;
}
if (y2<y0)
{
    temp = x0; x0 = x2; x2 = temp;
    temp = y0; y0 = y2; y2 = temp;
}
if (y2<y1)
{
    temp = x1; x1 = x2; x2 = temp;
    temp = y1; y1 = y2; y2 = temp;
}

// ===== Fixederpolation variables =====

//Fixed n, fp = 8;
Fixed lx01=0, lx12=0, lx02=0;

Fixed dx01 = x1 - x0;
Fixed dy01 = y1 - y0;

    if (dy01!=0)
        lx01 = ((dx01)*divi[dy01]);

Fixed dx12 = x2 - x1;
Fixed dy12 = y2 - y1;

    if (dy12!=0)
        lx12 = ((dx12)/dy12);

Fixed dx02 = x2 - x0;
Fixed dy02 = y2 - y0;

    if (dy02!=0)
        lx02 = ((dx02)/dy02);

Fixed x, y;

Fixed x01 = x0;
Fixed x02 = x01;

int sx1, sx2;
    for (y = y0; y<y1; y+=1)
    {
        sx1 = x01;
        sx2 = x02;
        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
        }
		zhline(screen,sx1,sx2,y,z,color);
        x01+=lx01;
        x02+=lx02;
    }
    x01 = x1;
    for (y = y1; y<y2; y+=1)
    {
        sx1 = x01;
        sx2 = x02;
        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
        }
		zhline(screen,sx1,sx2,y,z,color);
        x01+=lx12;
        x02+=lx02;
    }
}
SDL_Joystick *joy;
int main(int argc, char **argv)
{
	int i;
	for(i=0;i<360;i++)
	{
		fcos[i]=(Fixed)cos(i*PI/180);
		fsin[i]=(Fixed)sin(i*PI/180);
		ftan[i]=(Fixed)tan(i*PI/180);
	}
	hpc=(Fixed)160/ftan[30];
	vpc=((Fixed)160/ftan[30]);
	for(i=0;i<4000;i++)
	{
		divi[i]=(Fixed)(1.0f/(float)i);
	}
	printf("start\n");
	SDL_Init( SDL_INIT_JOYSTICK | SDL_INIT_VIDEO|SDL_INIT_TIMER|SDL_INIT_AUDIO);
	SDL_WM_SetCaption( "3ngine", 0 );
	screen=SDL_SetVideoMode(320,240,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
	zbuffer=SDL_CreateRGBSurface(SDL_HWSURFACE, 320, 240, 16, 0, 0, 0, 0);
	TTF_Init();
	#ifdef GP2X
	SDL_ShowCursor(SDL_DISABLE);	
	joy = SDL_JoystickOpen(0);		
	#endif
	font = TTF_OpenFont("arial.ttf", 12);
	Object cube;
	int curobj=0;
	cube.loadOBJ("cube.obj");
	cube.pos.z=157;
	cube.rot.z=208;
	cube.rot.x=90;
	cube.rot.y=0;
	SDL_initFramerate(&FPS);
	SDL_setFramerate(&FPS,30);
	bool quit=0;
	int at=0;
	bool aut=0;
	light.x=-10;
	light.y=10;
	light.z=-100;
	light.normalize();
	vec cubemove(0,0,0);
	vec lightmove(0,0,0);
	int atime,nfrm,pfrm;
	Fixed fps;
	int projm=0;
	int ppos=0;
	while(!quit)
	{
		SDL_FillRect(screen,NULL,NULL);
		SDL_FillRect(zbuffer,NULL,10000);
		int j;
		SDL_Event ev;
		while(SDL_PollEvent(&ev))
		{
			switch(ev.type)
			{
				case in1:
					switch(in2)
					{
						case GP2X_BUTTON_START:
							quit=1;
							break;
						case GP2X_BUTTON_LEFT:
							cubemove.x=-1;
							break;
						case GP2X_BUTTON_RIGHT:
							cubemove.x=1;
							break;
						case GP2X_BUTTON_UP:
							cubemove.y=1;
							break;
						case GP2X_BUTTON_DOWN:
							cubemove.y=-1;
							break;
						case GP2X_BUTTON_VOLUP:
							cubemove.z=1;
							break;
						case GP2X_BUTTON_VOLDOWN:
							cubemove.z=-1;
							break;
						case GP2X_BUTTON_SELECT:
							aut=!aut;
							break;
						case GP2X_BUTTON_A:
							lightmove.x=-1;
							break;
						case GP2X_BUTTON_B:
							lightmove.x=1;
							break;
						case GP2X_BUTTON_Y:
							lightmove.y=1;
							break;
						case GP2X_BUTTON_X:
							lightmove.y=-1;
							break;
						case GP2X_BUTTON_1:
							ppos++;
							if(ppos>2) ppos=0;
							break;
						case GP2X_BUTTON_2:
							ppos--;
							if(ppos<0) ppos=2;
							break;	
						case GP2X_BUTTON_R:
						//lightmove.z=1;
							switch(curobj)
							{
								case 0:
									cube.loadOBJ("cylinder.obj");
									curobj=1;
									break;
								case 1:
									cube.loadOBJ("geometry.obj");
									curobj++;
									break;
								case 2:
									cube.loadOBJ("geosphere.obj");
									curobj++;
									break;
								case 3:
									cube.loadOBJ("porshe.obj");
									curobj++;
									break;
								case 4:
									cube.loadOBJ("pyramid.obj");
									curobj++;
									break;
								case 5:
									cube.loadOBJ("sphere.obj");
									curobj++;
									break;
								case 6:
									cube.loadOBJ("teapot.obj");
									curobj++;
									break;
								case 7:
									cube.loadOBJ("z.obj");
									curobj=8;
									break;
								case 8:
									cube.loadOBJ("cube.obj");
									curobj=0;
									break;
							}
							break;
						case GP2X_BUTTON_L:
							projm++;
							if(projm>3)
								projm=0;
							break;
					}
					break;
				case in3:
					switch(in2)
					{
						case GP2X_BUTTON_START:
							quit=0;
							break;
						case GP2X_BUTTON_LEFT:
							cubemove.x=0;
							break;
						case GP2X_BUTTON_RIGHT:
							cubemove.x=0;
							break;
						case GP2X_BUTTON_UP:
							cubemove.y=0;
							break;
						case GP2X_BUTTON_DOWN:
							cubemove.y=0;
							break;
						case GP2X_BUTTON_VOLUP:
							cubemove.z=0;
							break;
						case GP2X_BUTTON_VOLDOWN:
							cubemove.z=-0;
							break;
						case GP2X_BUTTON_A:
							lightmove.x=-0;
							break;
						case GP2X_BUTTON_B:
							lightmove.x=0;
							break;
						case GP2X_BUTTON_Y:
							lightmove.y=0;
							break;
						case GP2X_BUTTON_X:
							lightmove.y=-0;
							break;
						case GP2X_BUTTON_R:
							//lightmove.z=0;
							break;
						case GP2X_BUTTON_L:
							//lightmove.z=0;
							break;
					}
					break;
			}
		}
		if(aut)
		{
			cube.rot.x+=2;
			cube.rot.y+=3;
			cube.rot.z+=1;	
		}
		cube.pos=cube.pos+cubemove;
		cube.rot=cube.rot+lightmove;
		if(cube.rot.x>=360)
			{
				cube.rot.x=1;
				
			}
			if(cube.rot.y>=360)
			{
				cube.rot.y=1;
				
			}
			if(cube.rot.z>=360)
			{
				cube.rot.z=1;
				
			}
			if(cube.rot.x<0)
			{
				cube.rot.x=359;
				
			}
			if(cube.rot.y<0)
			{
				cube.rot.y=359;
				
			}
			if(cube.rot.z<0)
			{
				cube.rot.z=359;
				
			}		
		int i;
		vec proj[cube.nver];
		printf("MATH\n");
		Fixed cx,cy,cz,sx,sy,sz;
		if(ppos==0)
		{
		cx=fcos[0];
		cy=fcos[0];
		cz=fcos[0];
		sx=fsin[0];
		sy=fsin[0];
		sz=fsin[0];
		}
		if(ppos==0)
		{
		cx=fcos[95];
		cy=fcos[95];
		cz=fcos[95];
		sx=fsin[95];
		sy=fsin[95];
		sz=fsin[95];
		}
		/*(cx=fcos[cube.rot.x];
		cy=fcos[cube.rot.y];
		cz=fcos[cube.rot.z];
		sx=fsin[cube.rot.x];
		sy=fsin[cube.rot.y];
		sz=fsin[cube.rot.z];*/
		Fixed czsx=cz * sx;
		Fixed cxsz=cx * sz;
		Fixed sxsz=sx * sz;
		Fixed cxcz=cx * cz;
		Fixed cycz=cy*cz;
		Fixed cysz=cy*sz;
		Fixed czsxsy=czsx * sy;
		Fixed sxszsy=sxsz * sy;
		Fixed cysx=cy * sx;
		Fixed cxczsy=cxcz * sy;
		Fixed cxszsy=cxsz * sy;
		Fixed cxcy=cx * cy;
		for(i=0;i<cube.nver;i++)
		{
			Fixed x=cube.verti[i].x;
			Fixed y=cube.verti[i].y;
			Fixed z=cube.verti[i].z;
			proj[i].x = x * (cycz) + y * (cysz) + z * (-sy) + cube.pos.x;
			proj[i].y = x * ((czsxsy) + (-cxsz)) + y * ((sxszsy) + (cxcz)) + z * (cysx) + cube.pos.y;
			proj[i].z = x * ((cxczsy) + (sxsz)) + y * ((cxszsy) + (-czsx)) + z * (cxcy) + cube.pos.z;		
			vec r;
		/*	switch(projm)
			{
				case 0:
					r.x=(proj[i].x*hpc)/proj[i].z+160;
					r.y=-(proj[i].y*vpc)/proj[i].z+120;
					break;
				case 1:				
					r.x.g=((proj[i].x.g<<8));
					r.y.g=(-(proj[i].y.g<<8));
					r.x/=(int)proj[i].z;
					r.y/=(int)proj[i].z;
					r.x+=160;
					r.y+=120;
					break;
				case 2:*/
					r.x=((int)proj[i].x<<8)/(int)proj[i].z+160;
					r.y=-((int)proj[i].y<<8)/(int)proj[i].z+120;
					//break;
			/*	case 3:
					r.x=(Fixed)((int)proj[i].x<<8)/proj[i].z+160;
					r.y=-(Fixed)((int)proj[i].y<<8)/proj[i].z+120;
					break;
			}*///OTHER PROJECTION TYPES...  THEY HAVE PROBLEMS WITH BEING OFF BY A PIXEL SOMETIMES, BUT GIVE EXACT COORDS(NO ROUNDING)
			r.z=proj[i].z;
			proj[i].x=r.x;
			proj[i].y=r.y;
			proj[i].z=r.z;
		}
		printf("Drawing\n");
		Fixed x1=light.x;
		Fixed y1=light.y;
		Fixed z1=light.z;
		vec nlight;
		nlight.x = x1 * cycz + y1 * ((czsxsy) + (-cxsz)) + z1 * ((cxczsy) + (sxsz));
        nlight.y = x1 * (cysz) + y1 * ((sxszsy) + (cxcz)) + z1 * ((cxszsy) + (-czsx));
        nlight.z = x1 * (-sy) + y1 * (cysx) + z1 * (cxcy);
		//nlight.normalize();
		printf("n%f,%f,%f\n",(float)nlight.x,(float)nlight.y,(float)nlight.z);
		for(i=0;i<cube.nfac;i++)
		{
			if(proj[cube.faces[i].p1].z<2||proj[cube.faces[i].p2].z<2||proj[cube.faces[i].p3].z<2)
			{
			}
			else
			{
				int vx0,vy0,vx1,vy1,n;
				vx0 = proj[cube.faces[i].p1].x - proj[cube.faces[i].p2].x;
				vy0 = proj[cube.faces[i].p1].y - proj[cube.faces[i].p2].y;
				vx1 = proj[cube.faces[i].p3].x - proj[cube.faces[i].p2].x;
				vy1 = proj[cube.faces[i].p3].y - proj[cube.faces[i].p2].y;
				n = vx0 * vy1 - vx1 * vy0;
				if(n<0)
				{						 		
					int shade;
					shade=128-(int)(nlight.dot(cube.faces[i].norm)*(Fixed)128);
					printf("s%f %f,%f,%f %f,%f,%f\n",(float)shade,(float)nlight.x,(float)nlight.y,(float)nlight.z,(float)cube.faces[i].norm.x,(float)cube.faces[i].norm.y,(float)cube.faces[i].norm.z);
					if (shade<0) shade = 0;
					if (shade>255) shade = 255;
					int r,g,b;
					r=cube.faces[i].r-(int)shade;
					g=cube.faces[i].g-(int)shade;
					b=cube.faces[i].b-(int)shade;
					if (r<0) r = 0;
					if (r>255) r = 255;
						if (g<0) g = 0;
					if (g>255) g = 255;
						if (b<0)b = 0;
					if (b>255) b = 255;
					ztri(screen,proj[cube.faces[i].p1],proj[cube.faces[i].p2],proj[cube.faces[i].p3],r,g,b);
				}
			}
		}
		j=0;
		if (SDL_GetTicks()-atime>=1000)
		{
			atime = SDL_GetTicks();
			fps=(at-pfrm);
			pfrm=at;
		}
		drawTextInt(screen,(int)(fps),0,0,255,255,255);
		drawTextInt(screen,(int)(cube.nfac),0,12,255,255,255);
		drawTextInt(screen,(int)(cube.nver),0,24,255,255,255);
		drawTextInt(screen,(int)(projm),0,36,255,255,255);
		drawTextInt(screen,(int)(cube.pos.x),0,48,255,255,255);
		drawTextInt(screen,(int)(cube.pos.y),0,60,255,255,255);
		drawTextInt(screen,(int)(cube.pos.z),0,72,255,255,255);
		drawTextInt(screen,(int)(cube.rot.x),0,84,255,255,255);
		drawTextInt(screen,(int)(cube.rot.y),0,96,255,255,255);
		drawTextInt(screen,(int)(cube.rot.z),0,108,255,255,255);
		SDL_Flip(screen);
		//SDL_framerateDelay(&FPS);
		at++;
	}
	SDL_Quit();
	printf("%ffps\n",(float)(at/(SDL_GetTicks()/1000.f)));
}
