//#define TEX
#ifndef GP2X
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_framerate.h>
#include <SDL/SDL_gfxPrimitives.h>
#else
#include "SDL.h"
#include "SDL_gfxPrimitives.h"
#include "SDL_rotoZoom.h"
#include "SDL_framerate.h"
#include "SDL_ttf.h"
#include "SDL_mixer.h"
#include "SDL_image.h"
#include "SDL_joystick.h"
#include <sys/mman.h>
#include <sys/ioctl.h>
#endif
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <math.h>
#include <sstream>
#include <iostream>


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/time.h>
#include <string>
#include <map>
#include "fixed.h"
#define PI 3.1415
FPSmanager fps;
Fixed fcos[360];
Fixed fsin[360];
SDL_Surface* screen;
TTF_Font* font;
class vector
{
	public:
	Fixed x,y,z;
	vector(Fixed X,Fixed Y,Fixed Z)
	{
		x=X;
		y=Y;
		z=Z;
	}
	vector()
	{
		x=y=z=0;
	}
	vector cross(vector &b)
	{
		vector n;
		n.x=(y*b.z)-(z*b.y);
		n.y=(y*b.x)-(x*b.z);
		n.z=(x*b.y)-(y*b.x);
		return n;
	}
	Fixed dot(vector &b)
	{
		return ((x*b.x)+(y*b.y)+(z,b.z));
	}
	Fixed magnitude()
	{
		float f;
		f=x*x+y*y+z*z;
		return sqrt(f);
	}
	void normalize()
	{
		Fixed mag=magnitude();
		printf("%i,%i,%i,%i\n",(int)x,(int)y,(int)z,(int)mag);
		x=x/mag;
		y=y/mag;
		z=z/mag;
	}
	vector operator -(vector& a)
	{ 
		return vector(x-a.x,y-a.y,z-a.z); 
	}	
	vector operator +(vector& a)
	{ 
		return vector(x+a.x,y+a.y,z+a.z); 
	}	

};
class Face
{
	public:
	int p1,p2,p3;
	Uint32 color;
	vector norm;
	int constant;
	Face()
	{
		p1=p2=p3=0;
	}
};
class Object
{
	public:
	vector pos;
	vector rot;
	vector verti[500];
	Face faces[500];
	int nver,nfac;
	void loadOBJ(const char *filename)  // Loads a Wavefront .OBJ 3D model from filename NOTE: You must add a line with just ! at the end of your file
	{
		FILE *fp;
		fp=fopen(filename,"r");
		bool in=1;
		int vat=0,fat=0,vtt=0;//what # vertice and face we're on
		while (in) {
			char cmd[99];
			fscanf(fp,"%s ",&cmd);	
			printf("Command: %s\n",cmd);
			if (cmd[0] == '#')
			{		
				printf("c#\n");
				fscanf(fp,"\n");
				continue;
			}
			else if (cmd == "v " || cmd[0] == 'v') {
				printf("cv\n");
				float x,y,z;
				if(fscanf(fp,"%f %f %f\n",&x,&y,&z))
				{
					verti[vat].x=x;
					verti[vat].y=y;
					verti[vat].z=z;
					printf("loadOBJ: %f %f %f\n",x,y,z);
					vat++;
				}
			} else if (cmd == "vn") {
			} else if (cmd == "cr") {
			} else if (cmd == "t" || cmd[0]=='t') {	
			} else if (cmd == "f " || (cmd[0] == 'f')) {
				printf("cf\n");
				int a,b,c;
				if(fscanf(fp,"%i %i %i \n",&a,&b,&c))
				{
					faces[fat].p1=a-1;
					faces[fat].p2=b-1;
					faces[fat].p3=c-1;
					printf("loadOBJ: %i %i %i\n",a,b,c);
					fat++;
				}
			} else if (cmd == "g") {
				fscanf(fp,"%s\n",cmd);
			} else if (cmd == "! " || cmd[0] == '!') {
				printf("c!\n");
				in=0;
			} else fscanf(fp,"\n");
		}
		nver=vat;
		nfac=fat;
		printf("loadOBJ: %i faces and %i verti\n",nfac,nver);
		fclose(fp);
		vector s1,s2;
		int i;
		for(i=0;i<nfac;i++)
		{
			s1=verti[faces[i].p2]-verti[faces[i].p1];
			s2=verti[faces[i].p3]-verti[faces[i].p2];
			printf("loadOBJ: sides\n");
			faces[i].norm=s1.cross(s2);
			printf("loadOBJ: crossed\n");
			faces[i].norm.normalize();
			printf("loadOBJ: normalized\n");
			faces[i].constant=-(int)(faces[i].norm.dot(verti[faces[i].p1]));
			printf("loadOBJ: face %i computed\n",i);
		}		
	}
};
int drawText(SDL_Surface* screen, char* string, int x, int y, int fR, int fG, int fB)
{
	#ifdef GP2X
	y+=2;
	#endif
	SDL_Color foregroundColor = { fR, fG, fB };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,string, foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
	return 0;
}
int drawTextInt(SDL_Surface* screen, int number, int x, int y, int fR, int fG, int fB)
{
	#ifdef GP2X
	y+=2;
	#endif
	char tmp_num[16];
	sprintf((char*)tmp_num, "%d", number);
	SDL_Color foregroundColor = { fR, fG, fB };
	SDL_Surface* textSurface =  TTF_RenderText_Blended(font,tmp_num, foregroundColor);
	SDL_Rect textLocation = { x, y, 0, 0 };
	SDL_BlitSurface(textSurface, NULL, screen, &textLocation);
	SDL_FreeSurface(textSurface);
	return 0;
}
void pixel(SDL_Surface* screen,int x,int y,int r,int g,int b)
{
	SDL_Rect r2;
	r2.x=x;
	r2.y=y;
	r2.w=1;
	r2.h=1;
	SDL_FillRect(screen,&r2,SDL_MapRGB(screen->format,r,g,b));
}
void hline(SDL_Surface* screen,int x1,int x2,int y,int r,int g,int b)
{
	SDL_Rect r2;
	r2.x=x1;
	r2.y=y;
	r2.w=x2-x1;
	r2.h=1;
	SDL_FillRect(screen,&r2,SDL_MapRGB(screen->format,r,g,b));
}
void vline(SDL_Surface* screen,int y1,int y2,int x,int r,int g,int b)
{
	SDL_Rect r2;
	r2.x=x;
	r2.y=y1;
	r2.w=1;
	r2.h=y2-y1;
	SDL_FillRect(screen,&r2,SDL_MapRGB(screen->format,r,g,b));
}
bool behind(vector point,vector norm,Fixed pc)
{
	if(point.dot(norm)+pc>=0)
		return 0;	
	else
	return 1;
}
void line(SDL_Surface* screen,int x1,int y1,int x2,int y2,int r,int g,int b)
{
	int temp;
	if(x2<x1)
	{
		temp=x1;
		x1=x2;
		x2=temp;
	}
	if(y2<y1)
	{
		temp=y1;
		y1=y2;
		y2=temp;
	}
	Fixed w=x2-x1;
    Fixed h=(y2-y1);
	Fixed dx,dy;
	Fixed x;
	Fixed y;
//	printf("line: starting%i,%i %i,%i %i,%i\n",x1,y1,x2,y2,w,h);
	if(w<=1) return vline(screen,y1,y2,x1,r,g,b);
	if(h<=1) return hline(screen,x1,x2,y1,r,g,b);
	if(w>=h)
	{
		dy=1; 
		dx=w/h;
		x=x1;
		for(y=y1;y<=y2;y+=1)
		{
			hline(screen,x,x+dx,y,r,g,b);
			x+=dx;
		}
	}
	else
	{
		dx=1;
		dy=h/w;
		y=y1;
		for(x=x1;x<=x2;x+=1)
		{
			vline(screen,y,y+dy,x,r,g,b);
			y+=dy;
		}
	}
}
void tri1(SDL_Surface* screen,vector a,vector b,vector c,int r,int g,int b2)
{
	Fixed x0 =a.x; Fixed y0 =a.y;
Fixed x1 =b.x; Fixed y1 =b.y;
Fixed x2 =c.x; Fixed y2 =c.y;
/*
if ((x0<-8 || x0>320+8 || y0<-8 || y0>240+8) && 
    (x1<-8 || x1>320+8 || y1<-8 || y1>240+8) && 
    (x2<-8 || x2>320+8 || y2<-8 || y2>240+8)) return;*/

//156-187
// ===== Sort =====

Fixed temp;
if (y1<y0)
{
    temp = x0; x0 = x1; x1 = temp;
    temp = y0; y0 = y1; y1 = temp;
}
if (y2<y0)
{
    temp = x0; x0 = x2; x2 = temp;
    temp = y0; y0 = y2; y2 = temp;
}
if (y2<y1)
{
    temp = x1; x1 = x2; x2 = temp;
    temp = y1; y1 = y2; y2 = temp;
}

// ===== Fixederpolation variables =====

//Fixed n, fp = 8;
Fixed lx01=0, lx12=0, lx02=0;

Fixed dx01 = x1 - x0;
Fixed dy01 = y1 - y0;

    if (dy01!=0)
        lx01 = ((dx01)/dy01);

Fixed dx12 = x2 - x1;
Fixed dy12 = y2 - y1;

    if (dy12!=0)
        lx12 = ((dx12)/dy12);

Fixed dx02 = x2 - x0;
Fixed dy02 = y2 - y0;

    if (dy02!=0)
        lx02 = ((dx02)/dy02);

Fixed x, y;

Fixed x01 = x0;
Fixed x02 = x01;

int sx1, sx2;
    for (y = y0; y<y1; y+=1)
    {
        sx1 = x01;
        sx2 = x02;
        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
        }
		hline(screen,sx1,sx2,y,r,g,b2);
        x01+=lx01;
        x02+=lx02;
    }
    x01 = x1;
    for (y = y1; y<y2; y+=1)
    {
        sx1 = x01;
        sx2 = x02;
        if (sx1>sx2)
        {
            temp = sx1; sx1 = sx2; sx2 = temp;
        }
		hline(screen,sx1,sx2,y,r,g,b2);
        x01+=lx12;
        x02+=lx02;
    }
}

void tri(SDL_Surface* screen,vector a,vector b,vector c,int r,int g,int b2)
{

}

vector project(vector a)
{
	vector r;
	Fixed x=a.x;
	Fixed y=a.y;
	Fixed z=a.z;
	r.x=((int)x<<8)/(int)z+160;
	r.y=-((int)y<<8)/(int)z+120;
	r.z=z;
	return r;
}
int main(int argc, char **argv)
{
	int i;
	for(i=0;i<360;i++)
	{
		fcos[i]=(Fixed)cos(i*PI/180);
		fsin[i]=(Fixed)sin(i*PI/180);
	}
	//hpc=(Fixed)160/ftan(30);
	//	vpc=((Fixed)120/ftan(30))*1.3333333333333333333333;
	SDL_Init( SDL_INIT_JOYSTICK | SDL_INIT_VIDEO|SDL_INIT_TIMER|SDL_INIT_AUDIO);
	SDL_WM_SetCaption( "3ngine", 0 );
	screen=SDL_SetVideoMode(320,240,16,SDL_SWSURFACE);
	TTF_Init();
	font = TTF_OpenFont("arial.ttf", 12);
	Object cube;
	cube.loadOBJ("cube1.obj");
	cube.pos.z=100;
	cube.rot.z=0;
	cube.rot.x=0;
	cube.rot.y=0;
	SDL_initFramerate(&fps);
	SDL_setFramerate(&fps,30);
	bool quit=0;
	int at=0;
	bool aut=0;
	while(!quit)
	{
		SDL_FillRect(screen,NULL,NULL);
		SDL_Event ev;
		while(SDL_PollEvent(&ev))
		{
			switch(ev.type)
			{
				case SDL_KEYDOWN:
					switch(ev.key.keysym.sym)
					{
						case SDLK_ESCAPE:
							quit=1;
							break;
						case SDLK_w:
							cube.pos.y+=5;
							break;
						case SDLK_s:
							cube.pos.y-=5;
							break;
						case SDLK_a:
							cube.pos.x-=5;
							break;
						case SDLK_d:
							cube.pos.x+=5;
							break;
						case SDLK_r:
							cube.pos.z+=5;
							break;
						case SDLK_f:
							cube.pos.z-=5;
							break;
						case SDLK_UP:
							cube.rot.x+=5;
							break;
						case SDLK_DOWN:
							cube.rot.x-=5;
							break;
						case SDLK_LEFT:
							cube.rot.y+=5;
							break;
						case SDLK_RIGHT:
							cube.rot.y-=5;
							break;
						case SDLK_o:
							cube.rot.z-=5;
							break;
						case SDLK_p:
							cube.rot.z+=5;
							break;
						case SDLK_RSHIFT:
							aut=!aut;
							break;
					}
					break;
			}
		}
		if(aut)
		{
			cube.rot.x+=2;
			cube.rot.y+=3;
			cube.rot.z+=1;
			
		}
		if(cube.rot.x>=360)
			{
				cube.rot.x=0;
				
			}
			if(cube.rot.y>=360)
			{
				cube.rot.y=0;
				
			}
			if(cube.rot.z>=360)
			{
				cube.rot.z=0;
				
			}
		int i;
		vector proj[500];
		printf("MATH\n");
		Fixed cx,cy,cz,sx,sy,sz;
		cx=fcos[cube.rot.x];
		cy=fcos[cube.rot.y];
		cz=fcos[cube.rot.z];
		sx=fsin[cube.rot.x];
		sy=fsin[cube.rot.y];
		sz=fsin[cube.rot.z];
		Fixed czsx=cz * sx;
		Fixed cxsz=cx * sz;
		Fixed sxsz=sx * sz;
		Fixed cxcz=cx * cz;
		for(i=0;i<cube.nver;i++)
		{
			Fixed x=cube.verti[i].x;
			Fixed y=cube.verti[i].y;
			Fixed z=cube.verti[i].z;
			proj[i].x = x * (cy * cz) + y * (cy * sz) + z * (-sy) + cube.pos.x;
			proj[i].y = x * ((czsx * sy) + (-cxsz)) + y * ((sxsz * sy) + (cxcz)) + z * (cy * sx) + cube.pos.y;
			proj[i].z = x * ((cxcz * sy) + (sxsz)) + y * ((cxsz * sy) + (-czsx)) + z * (cx * cy) + cube.pos.z;		
			vector r;
			r.x=((int)proj[i].x<<8)/(int)proj[i].z+160;
			r.y=-((int)proj[i].y<<8)/(int)proj[i].z+120;
			r.z=proj[i].z;
			proj[i].x=r.x;
			proj[i].y=r.y;
			proj[i].z=r.z;
		}
		printf("Drawing\n");
		int j;
		for(i=0;i<cube.nfac;i++)
		{
			int vx0,vy0,vx1,vy1,n;
			vx0 = proj[cube.faces[i].p1].x - proj[cube.faces[i].p2].x;
			vy0 = proj[cube.faces[i].p1].y - proj[cube.faces[i].p2].y;
			vx1 = proj[cube.faces[i].p3].x - proj[cube.faces[i].p2].x;
			vy1 = proj[cube.faces[i].p3].y - proj[cube.faces[i].p2].y;
			n = vx0 * vy1 - vx1 * vy0;
			if(n<0)
			{
				tri1(screen,proj[cube.faces[i].p1],proj[cube.faces[i].p2],proj[cube.faces[i].p3],255,255,255);
			//	lineRGBA(screen,proj[cube.faces[i].p1].x,proj[cube.faces[i].p1].y,proj[cube.faces[i].p2].x,proj[cube.faces[i].p2].y,0,255,0,255);
			//	lineRGBA(screen,proj[cube.faces[i].p2].x,proj[cube.faces[i].p2].y,proj[cube.faces[i].p3].x,proj[cube.faces[i].p3].y,255,0,0,255);
			//	lineRGBA(screen,proj[cube.faces[i].p1].x,proj[cube.faces[i].p1].y,proj[cube.faces[i].p3].x,proj[cube.faces[i].p3].y,0,0,255,255);
			}
		}
		j=0;
		drawTextInt(screen,(int)(at/(SDL_GetTicks()/1000.f)),0,0,255,255,255);
		drawTextInt(screen,(int)(cube.rot.x),0,12,255,255,255);
		drawTextInt(screen,(int)(cube.rot.y),0,24,255,255,255);
		drawTextInt(screen,(int)(cube.rot.z),0,36,255,255,255);
		SDL_Flip(screen);
		SDL_framerateDelay(&fps);
		at++;
	}
	SDL_Quit();
	printf("%ffps\n",(float)(at/(SDL_GetTicks()/1000.f)));
}
