#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include "engine3d.h"
#include "generate3d.h"
#include "ZeEngineGP2X.h"

object3d object[256];

extern unsigned char beet3do[];
extern unsigned char teapot[];
extern unsigned char cow3do[];
extern unsigned char face3do[];

unsigned char addtimes[MAXDATA];

extern unsigned int maxobj;

void CalcNorms(object3d *obj, int neg)
{
    vector3d v1,v2;

    obj->normal = new vector3d[obj->npls];//(vector3d*)malloc(obj->npls * sizeof(vector3d));

    int i;
    for (i=0; i<obj->npls; i++)
    {
        v1.x = obj->point[obj->poly[i].p2].x - obj->point[obj->poly[i].p1].x;
        v1.y = obj->point[obj->poly[i].p2].y - obj->point[obj->poly[i].p1].y;
        v1.z = obj->point[obj->poly[i].p2].z - obj->point[obj->poly[i].p1].z;

        v2.x = obj->point[obj->poly[i].p1].x - obj->point[obj->poly[i].p0].x;
        v2.y = obj->point[obj->poly[i].p1].y - obj->point[obj->poly[i].p0].y;
        v2.z = obj->point[obj->poly[i].p1].z - obj->point[obj->poly[i].p0].z;

        obj->normal[i] = Normalize(CrossProduct(v1,v2));
        if (neg==1) obj->normal[i] = NegVec(obj->normal[i]);
    }
}

void CalcPtNorms(object3d *obj)
{
    obj->pt_normal = new vector3d[obj->npts];//(vector3d*)malloc(obj->npts * sizeof(vector3d));
//printf("malloc\n");
    int i;
    for (i=0; i<MAXDATA; i++)
        addtimes[i] = 0;

    for (i=0; i<obj->npts; i++)
    {
        obj->pt_normal[i].x = 0;
        obj->pt_normal[i].y = 0;
        obj->pt_normal[i].z = 0;
    }
//printf("ptnrm\n");
    for (i=0; i<obj->npls; i++)
    {
        obj->pt_normal[obj->poly[i].p0].x += obj->normal[i].x;
        obj->pt_normal[obj->poly[i].p0].y += obj->normal[i].y;
        obj->pt_normal[obj->poly[i].p0].z += obj->normal[i].z;
        obj->pt_normal[obj->poly[i].p1].x += obj->normal[i].x;
        obj->pt_normal[obj->poly[i].p1].y += obj->normal[i].y;
        obj->pt_normal[obj->poly[i].p1].z += obj->normal[i].z;
        obj->pt_normal[obj->poly[i].p2].x += obj->normal[i].x;
        obj->pt_normal[obj->poly[i].p2].y += obj->normal[i].y;
        obj->pt_normal[obj->poly[i].p2].z += obj->normal[i].z;
	//	printf("badd%i\n",i);
        addtimes[obj->poly[i].p0]++;
        addtimes[obj->poly[i].p1]++;
        addtimes[obj->poly[i].p2]++;
	//	printf("add2%i\n",i);
    }
//printf("add\n");
    for (i=0; i<obj->npts; i++)
    {
        if (addtimes[i]!=0)
        {
            obj->pt_normal[i].x /= addtimes[i];
            obj->pt_normal[i].y /= addtimes[i]; 
            obj->pt_normal[i].z /= addtimes[i];
            obj->pt_normal[i] = Normalize(obj->pt_normal[i]);
        }
    }
	//printf("nrm\n");
}

void ReversePolygonOrder(object3d *obj)
{
    int i, a, b, c;
    for (i=0; i<obj->npls; i++)
    {
        a = obj->poly[i].p0;
        b = obj->poly[i].p1;
        c = obj->poly[i].p2;
        obj->poly[i].p0 = c;
        obj->poly[i].p1 = b;
        obj->poly[i].p2 = a;
    }
}


void Load32bit3doFile(char* filename, object3d *obj, int neg, float stdiv)
{
	FILE *obj3d;
	obj3d=fopen(filename,"rb");

	obj->npts=fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24);
	obj->nlns=fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24);
	obj->npls=fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24);

    obj->point = (point3d*)malloc(obj->npts * sizeof(point3d));
    obj->line = (line2d*)malloc(obj->nlns * sizeof(line2d));
    obj->poly = (poly2d*)malloc(obj->npls * sizeof(poly2d));

    int i;
	for (i=0; i<obj->npts; i++)
	{
		obj->point[i].x = (fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24) - 65536)/stdiv;
		obj->point[i].y = (fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24) - 65536)/stdiv;
		obj->point[i].z = (fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24) - 65536)/stdiv;
		obj->point[i].c = 0xFFFFFF;
	}

	for (i=0; i<obj->nlns; i++)
	{
        obj->line[i].p0 = fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24);
        obj->line[i].p1 = fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24);
        obj->line[i].c = 0xFFFFFF;
	}

	for (i=0; i<obj->npls; i++)
	{
        obj->poly[i].p0 = fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24);
        obj->poly[i].p1 = fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24);
        obj->poly[i].p2 = fgetc(obj3d)+(fgetc(obj3d)<<8)+(fgetc(obj3d)<<16)+(fgetc(obj3d)<<24);
	}

	fclose(obj3d);

    CalcNorms(obj, neg);
    CalcPtNorms(obj);
}


void Load16bit3do(object3d *obj, unsigned char* objdata, int neg)
{
    obj->npts = *objdata + (*(objdata+1)<<8);
    obj->nlns = *(objdata+2) + (*(objdata+3)<<8);
    obj->npls = *(objdata+4) + (*(objdata+5)<<8);

    obj->point = new point3d[obj->npts];//malloc(obj->npts * sizeof(point3d));
    obj->line = new line2d[obj->nlns];//(obj->nlns * sizeof(line2d));
    obj->poly = new poly2d[obj->npls];//malloc(obj->npls * sizeof(poly2d));

    objdata+=6;
    int i;
    for (i=0; i<obj->npts; i++)
    {
        obj->point[i].x = (*(objdata++) - 128) >> 1;
        obj->point[i].y = (*(objdata++) - 128) >> 1;
        obj->point[i].z = (*(objdata++) - 128) >> 1;
        obj->point[i].c = 0xFFFF;
    }

    for (i=0; i<obj->nlns; i++)
    {
        obj->line[i].p0 = *objdata + (*(objdata+1)<<8);
        obj->line[i].p1 = *(objdata+2) + (*(objdata+3)<<8);
        objdata+=4;
        obj->line[i].c = 0xFFFF;
    }

    for (i=0; i<obj->npls; i++)
    {
        obj->poly[i].p0 = *objdata + (*(objdata+1)<<8);
        obj->poly[i].p1 = *(objdata+2) + (*(objdata+3)<<8);
        obj->poly[i].p2 = *(objdata+4) + (*(objdata+5)<<8);
        objdata+=6;
    }

    CalcNorms(obj, neg);
    CalcPtNorms(obj);
}

// ==========================================================
	void loadOBJ(object3d *obj,const char *filename)  // Loads a Wavefront .OBJ 3D model from filename NOTE: You must add a line with just ! at the end of your file
	{
	FILE *fp;
	fp=fopen(filename,"r");
	bool in=1;
	int vat=0,fat=0,vtt=0;//what # vertice and face we're on
fscanf(fp,"%i %i",&obj->npts,&obj->npls);		 
	 //obj->npts = 8;
       //     obj->nlns = 12;
         //  obj->npls = 12;

            obj->point = new point3d[obj->npts];//malloc(obj->npts * sizeof(point3d));
           // obj->line = new line2d[obj->nlns];//malloc(obj->nlns * sizeof(line2d));
            obj->poly = new poly2d[obj->npls];//malloc(obj->npls * sizeof(poly2d));
			
	while (in) {
		//printf("Loading\n");
		char cmd[99];
		fscanf(fp,"%s ",&cmd);	
		printf("Command: %s\n",cmd);
		if (cmd[0] == '#')
		{		
			printf("c#\n");
			fscanf(fp,"\n");
			continue;
		}
		else if (cmd == "v " || cmd[0] == 'v') {
			//iss >> verti[vat].x >> verti[vat].y >> verti[vat].z;
			printf("cv\n");
			float x,y,z;
			if(fscanf(fp,"%f %f %f\n",&x,&y,&z))
			{
			obj->point[vat].x=x;
			obj->point[vat].y=y;
			obj->point[vat].z=z;
			printf("loadOBJ: %f %f %f\n",x,y,z);
			vat++;
			}
		} else if (cmd == "vn") {
			//vec3f v;
			//iss >> v.x >> v.y >> v.z;
			//result.normals.push_back(v);
		} else if (cmd == "cr") {
			//vec3f v;
			//iss >> v.x >> v.y >> v.z;
			//result.normals.push_back(v);
		} else if (cmd == "t" || cmd[0]=='t') {
			printf("ct\n");
			int a,b;
			if(fscanf(fp,"%i %i\n",&a,&b))
			{
		//	verti[vtt].u=a;
		//	verti[vtt].v=b;
			printf("loadOBJ: %i %i\n",a,b);
			vtt++;
			}
		} else if (cmd == "f " || (cmd[0] == 'f')) {
			printf("cf\n");
			//iss >> faces[fat][0] >> faces[fat][1] >> faces[fat][2];
			int a,b,c;
			if(fscanf(fp,"%i %i %i \n",&a,&b,&c))
			{
			 obj->poly[fat].p0=c-1;
			 obj->poly[fat].p1=b-1;
			 obj->poly[fat].p2=a-1;
			printf("loadOBJ: %i %i %i\n",a,b,c);
			fat++;
			}
		} else if (cmd == "g") {
			//iss >> faces[fat][0] >> faces[fat][1] >> faces[fat][2];
			fscanf(fp,"%s\n",cmd);
		} else if (cmd == "! " || cmd[0] == '!') {
			printf("c!\n");
			in=0;
		} else fscanf(fp,"\n");
	}
//	nver=vat;
	//nfac=fat;
	printf("loadOBJ: %i faces and %i verti\n",obj->npls,obj->npts);
	fclose(fp);
/*	vertex s1,s2;
	for(i=0;i<nfac;i++)
	{
		s1=verti[faces[i][1]]-verti[faces[i][0]];
		s2=verti[faces[i][2]]-verti[faces[i][1]];
		printf("loadOBJ: sides\n");
		norms[i]=s1.Cross(s2);
		printf("loadOBJ: crossed\n");
		norms[i].Normalize();
		printf("loadOBJ: normalized\n");
		faces[i][6]=-(int)(norms[i].Dot(verti[faces[i][0]]));
		printf("loadOBJ: face %i computed\n",i);
	}		*/
	int i;
	 for (i=0; i<obj->nlns; i++)
           obj->line[i].c = 0xFFFF;

            obj->pos.x = 0; obj->pos.y = 0; obj->pos.z = 128;
            obj->rot.x = 0; obj->rot.y = 0; obj->rot.z = 0;
            
            for (i=0; i<obj->npls; i++)
                obj->poly[i].m = i>>1;

            CalcNorms(obj, 1);
            CalcPtNorms(obj);
}
void InitObject(object3d *obj, int objn)
{
    int tl = 4, tr = 252;
    int k;

    switch(objn)
    {
        case 0:

            obj->point = new point3d[8];//malloc(8 * sizeof(point3d));
            obj->line = new line2d[12];//malloc(12 * sizeof(line2d));
            obj->poly = new poly2d[12];//malloc(12 * sizeof(poly2d));
            obj->npts = 8;
            obj->nlns = 12;
            obj->npls = 12;

            obj->point = new point3d[obj->npts];//malloc(obj->npts * sizeof(point3d));
            obj->line = new line2d[obj->nlns];//malloc(obj->nlns * sizeof(line2d));
            obj->poly = new poly2d[obj->npls];//malloc(obj->npls * sizeof(poly2d));

            obj->point[0].x = -64; obj->point[0].y = 64; obj->point[0].z = -64;
            obj->point[1].x = -64; obj->point[1].y = -64; obj->point[1].z = -64;
            obj->point[2].x = 64; obj->point[2].y = -64; obj->point[2].z = -64;
            obj->point[3].x = 64; obj->point[3].y = 64; obj->point[3].z = -64;
            obj->point[4].x = -64; obj->point[4].y = 64; obj->point[4].z = 64;
            obj->point[5].x = -64; obj->point[5].y = -64; obj->point[5].z = 64;
            obj->point[6].x = 64; obj->point[6].y = -64; obj->point[6].z = 64;
            obj->point[7].x = 64; obj->point[7].y = 64; obj->point[7].z = 64;

            obj->line[0].p0 = 0; obj->line[0].p1 = 1;
            obj->line[1].p0 = 1; obj->line[1].p1 = 2;
            obj->line[2].p0 = 2; obj->line[2].p1 = 3;
            obj->line[3].p0 = 3; obj->line[3].p1 = 0;
            obj->line[4].p0 = 4; obj->line[4].p1 = 5;
            obj->line[5].p0 = 5; obj->line[5].p1 = 6;
            obj->line[6].p0 = 6; obj->line[6].p1 = 7;
            obj->line[7].p0 = 7; obj->line[7].p1 = 4;
            obj->line[8].p0 = 0; obj->line[8].p1 = 4;
            obj->line[9].p0 = 1; obj->line[9].p1 = 5;
            obj->line[10].p0 = 2; obj->line[10].p1 = 6;
            obj->line[11].p0 = 3; obj->line[11].p1 = 7;

            obj->poly[0].p0 = 0; obj->poly[0].p1 = 1; obj->poly[0].p2 = 2;
            obj->poly[1].p0 = 0; obj->poly[1].p1 = 2; obj->poly[1].p2 = 3;
            obj->poly[2].p0 = 7; obj->poly[2].p1 = 6; obj->poly[2].p2 = 5;
            obj->poly[3].p0 = 7; obj->poly[3].p1 = 5; obj->poly[3].p2 = 4;
            obj->poly[4].p0 = 3; obj->poly[4].p1 = 2; obj->poly[4].p2 = 6;
            obj->poly[5].p0 = 3; obj->poly[5].p1 = 6; obj->poly[5].p2 = 7;
            obj->poly[6].p0 = 4; obj->poly[6].p1 = 5; obj->poly[6].p2 = 1;
            obj->poly[7].p0 = 4; obj->poly[7].p1 = 1; obj->poly[7].p2 = 0;
            obj->poly[8].p0 = 4; obj->poly[8].p1 = 0; obj->poly[8].p2 = 3;
            obj->poly[9].p0 = 4; obj->poly[9].p1 = 3; obj->poly[9].p2 = 7;
            obj->poly[10].p0 = 1; obj->poly[10].p1 = 5; obj->poly[10].p2 = 6;
            obj->poly[11].p0 = 1; obj->poly[11].p1 = 6; obj->poly[11].p2 = 2;

            int i;
            for (i=0; i<6; i++)
            {
                obj->poly[2*i].tc0.u = tl; obj->poly[2*i].tc0.v = tl; obj->poly[2*i].tc1.u = tl; obj->poly[2*i].tc1.v = tr; obj->poly[2*i].tc2.u = tr; obj->poly[2*i].tc2.v = tr;
                obj->poly[2*i+1].tc0.u = tl; obj->poly[2*i+1].tc0.v = tl; obj->poly[2*i+1].tc1.u = tr; obj->poly[2*i+1].tc1.v = tr; obj->poly[2*i+1].tc2.u = tr; obj->poly[2*i+1].tc2.v = tl;
            }

            for (i=0; i<obj->nlns; i++)
           obj->line[i].c = 0xFFFF;

            obj->pos.x = 0; obj->pos.y = 0; obj->pos.z = 256;
            obj->rot.x = 0; obj->rot.y = 0; obj->rot.z = 0;
            
            for (i=0; i<11; i++)
                obj->poly[i].m = i>>1;

            CalcNorms(obj, 1);
            CalcPtNorms(obj);
        break;

        case 1:
            Load16bit3do(obj, face3do,0);
            ReversePolygonOrder(obj);
            obj->pos.x = 0; obj->pos.y = -16; obj->pos.z = 96;
            obj->rot.x = 0; obj->rot.y = -PI/2; obj->rot.z = -PI/2;
			
        break;

        case 2:
            Load16bit3do(obj, cow3do,1);
            obj->pos.x = 0; obj->pos.y = 0; obj->pos.z = 128;
            obj->rot.x = 0; obj->rot.y = 0; obj->rot.z = 0;
        break;

        case 3:
            Load16bit3do(obj, teapot,1);
            obj->pos.x = 0; obj->pos.y = 0; obj->pos.z = 128;
            obj->rot.x = 0; obj->rot.y = 0; obj->rot.z = 0;
        break;

        case 4:
            Load16bit3do(obj, beet3do,1);
            obj->pos.x = 0; obj->pos.y = 0; obj->pos.z = 80;
            obj->rot.x = 0; obj->rot.y = 0; obj->rot.z = 0;
			   obj->point = new point3d[1609];//malloc(8 * sizeof(point3d));
            obj->line = new line2d[2413];//malloc(12 * sizeof(line2d));
            obj->poly = new poly2d[2413];//malloc(12 * sizeof(poly2d));
            obj->npts = 1600;
            obj->nlns = 2400;
            obj->npls = 2400;

            obj->point = new point3d[obj->npts];//malloc(obj->npts * sizeof(point3d));
            obj->line = new line2d[obj->nlns];//malloc(obj->nlns * sizeof(line2d));
            obj->poly = new poly2d[obj->npls];//malloc(obj->npls * sizeof(poly2d));
int j;
int k;   
for(j=0;j<200;j++)
{

			obj->point[0].x = -64+rand()%40-20; obj->point[0].y = 64+rand()%40-20; obj->point[0].z = -64+rand()%40-20;
            obj->point[1].x = -64+rand()%40-20; obj->point[1].y = -64+rand()%40-20; obj->point[1].z = -64+rand()%40-20;
            obj->point[2].x = 64+rand()%40-20; obj->point[2].y = -64+rand()%40-20; obj->point[2].z = -64+rand()%40-20;
            obj->point[3].x = 64+rand()%40-20; obj->point[3].y = 64+rand()%40-20; obj->point[3].z = -64+rand()%40-20;
            obj->point[4].x = -64+rand()%40-20; obj->point[4].y = 64+rand()%40-20; obj->point[4].z = 64+rand()%40-20;
            obj->point[5].x = -64+rand()%40-20; obj->point[5].y = -64+rand()%40-20; obj->point[5].z = 64+rand()%40-20;
            obj->point[6].x = 64+rand()%40-20; obj->point[6].y = -64+rand()%40-20; obj->point[6].z = 64+rand()%40-20;
            obj->point[7].x = 64+rand()%40-20; obj->point[7].y = 64+rand()%40-20; obj->point[7].z = 64+rand()%40-20;

            obj->line[j*12+0].p0 = rand()%8; obj->line[j*12+0].p1 = rand()%8;
            obj->line[j*12+1].p0 = rand()%8; obj->line[j*12+1].p1 = rand()%8;
            obj->line[j*12+2].p0 = rand()%8; obj->line[j*12+2].p1 = rand()%8;
            obj->line[j*12+3].p0 = rand()%8; obj->line[j*12+3].p1 = rand()%8;
            obj->line[j*12+4].p0 = rand()%8; obj->line[j*12+4].p1 = rand()%8;
            obj->line[j*12+5].p0 = rand()%8; obj->line[j*12+5].p1 =rand()%8 ;
            obj->line[j*12+6].p0 = rand()%8; obj->line[j*12+6].p1 =rand()%8 ;
            obj->line[j*12+7].p0 = rand()%8; obj->line[j*12+7].p1 = rand()%8;
            obj->line[j*12+8].p0 = rand()%8; obj->line[j*12+8].p1 = rand()%8;
            obj->line[j*12+9].p0 = rand()%8; obj->line[j*12+9].p1 = rand()%8;
            obj->line[j*12+10].p0 = rand()%8; obj->line[j*12+10].p1 = rand()%8;
            obj->line[j*12+11].p0 = rand()%8; obj->line[j*12+11].p1 = rand()%8;

            obj->poly[j*12+0].p0 = rand()%8; obj->poly[j*12+0].p1 = rand()%8; obj->poly[j*12+0].p2 = rand()%8;
            obj->poly[j*12+1].p0 = rand()%8; obj->poly[j*12+1].p1 = rand()%8; obj->poly[j*12+1].p2 = rand()%8;
            obj->poly[j*12+2].p0 = rand()%8; obj->poly[j*12+2].p1 = rand()%8; obj->poly[j*12+2].p2 = rand()%8;
            obj->poly[j*12+3].p0 = rand()%8; obj->poly[j*12+3].p1 = rand()%8; obj->poly[j*12+3].p2 = rand()%8;
            obj->poly[j*12+4].p0 = rand()%8; obj->poly[j*12+4].p1 = rand()%8; obj->poly[j*12+4].p2 = rand()%8;
            obj->poly[j*12+5].p0 = rand()%8; obj->poly[j*12+5].p1 = rand()%8; obj->poly[j*12+5].p2 = rand()%8;
            obj->poly[j*12+6].p0 = rand()%8; obj->poly[j*12+6].p1 = rand()%8; obj->poly[j*12+6].p2 = rand()%8;
            obj->poly[j*12+7].p0 = rand()%8; obj->poly[j*12+7].p1 = rand()%8; obj->poly[j*12+7].p2 = rand()%8;
            obj->poly[j*12+8].p0 = rand()%8; obj->poly[j*12+8].p1 = rand()%8; obj->poly[j*12+8].p2 = rand()%8;
            obj->poly[j*12+9].p0 = rand()%8; obj->poly[j*12+9].p1 = rand()%8; obj->poly[j*12+9].p2 = rand()%8;
            obj->poly[j*12+10].p0 = rand()%8; obj->poly[j*12+10].p1 = rand()%8; obj->poly[j*12+10].p2 = rand()%8;
            obj->poly[j*12+11].p0 = rand()%8; obj->poly[j*12+11].p1 = rand()%8; obj->poly[j*12+11].p2 = rand()%8;
}
            for (k=0; k<1200; k++)
            {
                obj->poly[2*k].tc0.u = tl; obj->poly[2*k].tc0.v = tl; obj->poly[2*k].tc1.u = tl; obj->poly[2*k].tc1.v = tr; obj->poly[2*k].tc2.u = tr; obj->poly[2*k].tc2.v = tr;
                obj->poly[2*k+1].tc0.u = tl; obj->poly[2*k+1].tc0.v = tl; obj->poly[2*k+1].tc1.u = tr; obj->poly[2*k+1].tc1.v = tr; obj->poly[2*k+1].tc2.u = tr; obj->poly[2*k+1].tc2.v = tl;
            }

          
				
				printf("lns\n");
	 for (k=0; k<obj->nlns-12; k++)
           obj->line[k].c = 0xFFFF;
		               	printf("lns\n");
            for (k=0; k<obj->npls-12; k++)
                obj->poly[k].m = k>>1;
					printf("lns\n");
            obj->pos.x = 0; obj->pos.y = 0; obj->pos.z = 256;
            obj->rot.x = 0; obj->rot.y = 0; obj->rot.z = 0;


obj->npts = 1600;
            obj->nlns = 2400;
            obj->npls = 2400;
				printf("lns\n");
            CalcNorms(obj, 1);
				printf("lns\n");
            CalcPtNorms(obj);
				printf("lns\n");
				//loadOBJ(obj,"cube.obj");
        break;

        case 5:
            Load32bit3doFile("./porsche.3do", obj, 1, 1024);
            obj->pos.x = 0; obj->pos.y = 180; obj->pos.z = 1024;
            obj->rot.x = 0; obj->rot.y = 0; obj->rot.z = 0;
        break;

        default:
        break;
    }    
	printf("%i: %i\n",objn,obj->npls);
}


void InitAllObjects()
{
    int i;
    for (i=0; i<maxobj; i++)
        InitObject(&object[i], i);
}
